{ Parsed from AppKit.framework (MacOSX10.8) NSAlert.h }
{ Created on Mon Sep 10 11:47:55 2012 }


{ Types from NSAlert }
{$ifdef TYPES}

const
  NSAlertFirstButtonReturn = 1000;
  NSAlertSecondButtonReturn = 1001;
  NSAlertThirdButtonReturn = 1002;
{$endif}


{$ifdef TYPES}
type
  NSAlertPtr = ^NSAlert;
  NSAlertDelegateProtocolPtr = ^NSAlertDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSWarningAlertStyle = 0;
  NSInformationalAlertStyle = 1;
  NSCriticalAlertStyle = 2;

type
  NSAlertStyle = NSUInteger;
  NSAlertStylePtr = ^NSAlertStyle;
{$endif}

{$ifdef CLASSES}

type
  NSAlert = objcclass external (NSObject)
  private
    _informationField: NSTextField;
    _first: id;
    _second: id;
    _third: id;
    _buttons: NSArray;
    _panel: NSPanel;
    _messageField: id;
    _imageView: id;
    _minButtonSize: NSSize;
    _buttonSpacing: CGFloat;
    _buttonPadding: CGFloat;
    _messagePadding: CGFloat;
    _buttonSpacingMaxX: CGFloat;
    _buttonSpacingY: CGFloat;
    _modalDelegate: id;
    _docWindow: NSWindow;
    _didEndSelector: SEL;
    _didDismissSelector: SEL;
    _unbadgedImage: NSImage;
    _defaultPanelSize: NSSize;
    _helpButton: id;
    _delegate: id;
    _alertStyle: NSAlertStyle;
    _helpAnchor: id;
    _layoutDone: boolean;
    _showsHelp: boolean;
    _showsSuppressionButton: boolean;
    reserved: boolean;
    _suppressionButton: id;
    _accessoryView: id;
  public
    class function alertWithError (error: NSError): NSAlert; message 'alertWithError:';
    class function alertWithMessageText_defaultButton_alternateButton_otherButton_informativeTextWithFormat (message_: NSString; defaultButton: NSString; alternateButton: NSString; otherButton: NSString; format: NSString): NSAlert; varargs; message 'alertWithMessageText:defaultButton:alternateButton:otherButton:informativeTextWithFormat:';
    procedure setMessageText (messageText: NSString); message 'setMessageText:';
    procedure setInformativeText (informativeText: NSString); message 'setInformativeText:';
    function messageText: NSString; message 'messageText';
    function informativeText: NSString; message 'informativeText';
    procedure setIcon (icon: NSImage); message 'setIcon:';
    function icon: NSImage; message 'icon';
    function addButtonWithTitle (title: NSString): NSButton; message 'addButtonWithTitle:';
    function buttons: NSArray; message 'buttons';
    procedure setShowsHelp (showsHelp: boolean); message 'setShowsHelp:';
    function showsHelp: boolean; message 'showsHelp';
    procedure setHelpAnchor (anchor: NSString); message 'setHelpAnchor:';
    function helpAnchor: NSString; message 'helpAnchor';
    procedure setAlertStyle (style: NSAlertStyle); message 'setAlertStyle:';
    function alertStyle: NSAlertStyle; message 'alertStyle';
    procedure setDelegate (delegate: NSAlertDelegateProtocol); message 'setDelegate:';
    function delegate: NSAlertDelegateProtocol; message 'delegate';
    procedure setShowsSuppressionButton (flag: boolean); message 'setShowsSuppressionButton:'; { available in 10_5 }
    function showsSuppressionButton: boolean; message 'showsSuppressionButton'; { available in 10_5 }
    function suppressionButton: NSButton; message 'suppressionButton'; { available in 10_5 }
    procedure setAccessoryView (view: NSView); message 'setAccessoryView:'; { available in 10_5 }
    function accessoryView: NSView; message 'accessoryView'; { available in 10_5 }
    procedure layout; message 'layout'; { available in 10_5 }
    function runModal: NSInteger; message 'runModal';
    procedure beginSheetModalForWindow_modalDelegate_didEndSelector_contextInfo (window: NSWindow; delegate_: id; didEndSelector: SEL; contextInfo: pointer); message 'beginSheetModalForWindow:modalDelegate:didEndSelector:contextInfo:';
    function window: id; message 'window';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSAlertDelegateProtocol = objcprotocol external name 'NSAlertDelegate' (NSObjectProtocol)
  optional
    function alertShowHelp (alert: NSAlert): boolean; message 'alertShowHelp:';
  end;
{$endif}

