{ Parsed from AppKit.framework (MacOSX10.8) NSBox.h }
{ Created on Mon Sep 10 11:47:55 2012 }


{$ifdef TYPES}
type
  NSBoxPtr = ^NSBox;
{$endif}

{$ifdef TYPES}
const
  NSNoTitle = 0;
  NSAboveTop = 1;
  NSAtTop = 2;
  NSBelowTop = 3;
  NSAboveBottom = 4;
  NSAtBottom = 5;
  NSBelowBottom = 6;

type
  NSTitlePosition = NSUInteger;
  NSTitlePositionPtr = ^NSTitlePosition;

const
  NSBoxPrimary = 0;
  NSBoxSecondary = 1;
  NSBoxSeparator = 2;
  NSBoxOldStyle = 3;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
  NSBoxCustom = 4;
  {$endif}

type
  NSBoxType = NSUInteger;
  NSBoxTypePtr = ^NSBoxType;
{$endif}

{$ifdef CLASSES}

type
  NSBox = objcclass external (NSView)
  private
    _titleCell: id;
    _contentView: id;
    _offsets: NSSize;
    _borderRect: NSRect;
    _titleRect: NSRect;
    __bFlags: bitpacked record
      case byte of
        0: (_anonBitField___bFlags0: cuint);
        1: (
          borderType_: 0..((1 shl 2)-1);
          titlePosition_: 0..((1 shl 3)-1);
          backgroundTransparent: 0..1;
          orientation: 0..((1 shl 2)-1);
          needsTile: 0..1;
          transparent: 0..1;
          colorAltInterpretation: 0..1;
          boxType_: 0..((1 shl 3)-1);
          useSuperAddSubview: 0..1;
          _RESERVED: 0..((1 shl 17)-1);
        );
      end;
    _unused: id;
  public
    function borderType: NSBorderType; message 'borderType';
    function titlePosition: NSTitlePosition; message 'titlePosition';
    procedure setBorderType (aType: NSBorderType); message 'setBorderType:';
    procedure setBoxType (boxType: NSBoxType); message 'setBoxType:';
    function boxType: NSBoxType; message 'boxType';
    procedure setTitlePosition (aPosition: NSTitlePosition); message 'setTitlePosition:';
    function title: NSString; message 'title';
    procedure setTitle (aString: NSString); message 'setTitle:';
    function titleFont: NSFont; message 'titleFont';
    procedure setTitleFont (fontObj: NSFont); message 'setTitleFont:';
    function borderRect: NSRect; message 'borderRect';
    function titleRect: NSRect; message 'titleRect';
    function titleCell: id; message 'titleCell';
    procedure sizeToFit; message 'sizeToFit';
    function contentViewMargins: NSSize; message 'contentViewMargins';
    procedure setContentViewMargins (offsetSize: NSSize); message 'setContentViewMargins:';
    procedure setFrameFromContentFrame (contentFrame: NSRect); message 'setFrameFromContentFrame:';
    function contentView: id; message 'contentView';
    procedure setContentView (aView: NSView); message 'setContentView:';
    function isTransparent: boolean; message 'isTransparent'; { available in 10_5 }
    procedure setTransparent (flag: boolean); message 'setTransparent:'; { available in 10_5 }
  end;


type
  NSCustomBoxTypeProperties = objccategory external (NSBox)
    function borderWidth: CGFloat; message 'borderWidth'; { available in 10_5 }
    procedure setBorderWidth (borderWidth_: CGFloat); message 'setBorderWidth:'; { available in 10_5 }
    function cornerRadius: CGFloat; message 'cornerRadius'; { available in 10_5 }
    procedure setCornerRadius (cornerRadius_: CGFloat); message 'setCornerRadius:'; { available in 10_5 }
    function borderColor: NSColor; message 'borderColor'; { available in 10_5 }
    procedure setBorderColor (borderColor_: NSColor); message 'setBorderColor:'; { available in 10_5 }
    function fillColor: NSColor; message 'fillColor'; { available in 10_5 }
    procedure setFillColor (fillColor_: NSColor); message 'setFillColor:'; { available in 10_5 }
  end;

type
  NSBox_NSKeyboardUI = objccategory external name 'NSKeyboardUI' (NSBox)
    procedure setTitleWithMnemonic (stringWithAmpersand: NSString); message 'setTitleWithMnemonic:'; deprecated 'in 10_0, 10_8';
  end;
{$endif}

