{ Parsed from AppKit.framework (MacOSX10.8) NSColorPanel.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSColorPanelPtr = ^NSColorPanel;
{$endif}

{$ifdef TYPES}
type
  NSColorPanelMode = NSInteger;
  NSColorPanelModePtr = ^NSColorPanelMode;

const
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
  NSNoModeColorPanel = -1;
  {$endif}
  NSGrayModeColorPanel = 0;
  NSRGBModeColorPanel = 1;
  NSCMYKModeColorPanel = 2;
  NSHSBModeColorPanel = 3;
  NSCustomPaletteModeColorPanel = 4;
  NSColorListModeColorPanel = 5;
  NSWheelModeColorPanel = 6;
  NSCrayonModeColorPanel = 7;
const
  NSColorPanelGrayModeMask = $00000001;
  NSColorPanelRGBModeMask = $00000002;
  NSColorPanelCMYKModeMask = $00000004;
  NSColorPanelHSBModeMask = $00000008;
  NSColorPanelCustomPaletteModeMask = $00000010;
  NSColorPanelColorListModeMask = $00000020;
  NSColorPanelWheelModeMask = $00000040;
  NSColorPanelCrayonModeMask = $00000080;
  NSColorPanelAllModesMask = $0000ffff;
{$endif}

{$ifdef CLASSES}

type
  NSColorPanel = objcclass external (NSPanel)
  private
    _colorSwatch: id;
    _reserved1: id;
    _colorWell: id;
    _pickersWithLoadedViews: NSMutableArray;
    _magnifyButton: id;
    _middleView: id;
    _opacitySlider: id;
    _opacityText: id;
    _opacityView: id;
    _modalButtons: id;
    _pickerView: id;
    _customViewsList: id;
    _customPickerList: id;
    _currViewObject: id;
    _boxAboveSwatch: id;
    _target: id;
    _accessoryView: id;
    _action: SEL;
    _minColorPanelSize: NSSize;
    _maxColorPanelSize: NSSize;
    _reserved2: NSSize;
    _reserved3: NSSize;
    _resizeDimple: id;
    _reserved5: boolean;
    _reserved6: boolean;
    _handlingOpacityMoveAction: boolean;
    _ignoreConstraints: boolean;
    _continuous: boolean;
    _allowColorSetting: boolean;
    _stillInitializing: boolean;
    _opacityTextController: id;
  public
    class function sharedColorPanel: NSColorPanel; message 'sharedColorPanel';
    class function sharedColorPanelExists: boolean; message 'sharedColorPanelExists';
    class function dragColor_withEvent_fromView (color: NSColor; theEvent: NSEvent; sourceView: NSView): boolean; message 'dragColor:withEvent:fromView:';
    class procedure setPickerMask (mask: NSUInteger); message 'setPickerMask:';
    class procedure setPickerMode (mode: NSColorPanelMode); message 'setPickerMode:';
    procedure setAccessoryView (aView: NSView); message 'setAccessoryView:';
    function accessoryView: NSView; message 'accessoryView';
    procedure setContinuous (flag: boolean); message 'setContinuous:';
    function isContinuous: boolean; message 'isContinuous';
    procedure setShowsAlpha (flag: boolean); message 'setShowsAlpha:';
    function showsAlpha: boolean; message 'showsAlpha';
    procedure setMode (mode: NSColorPanelMode); message 'setMode:';
    function mode: NSColorPanelMode; message 'mode';
    procedure setColor (color: NSColor); message 'setColor:';
    function color: NSColor; message 'color';
    function alpha: CGFloat; message 'alpha';
    procedure setAction (aSelector: SEL); message 'setAction:';
    procedure setTarget (anObject: id); message 'setTarget:';
    procedure attachColorList (colorList: NSColorList); message 'attachColorList:';
    procedure detachColorList (colorList: NSColorList); message 'detachColorList:';
  end;


type
  NSApplication_NSColorPanel = objccategory external name 'NSColorPanel' (NSApplication)
    procedure orderFrontColorPanel (sender: id); message 'orderFrontColorPanel:';
  end;

type
  NSColorPanelResponderMethod = objccategory external (NSObject)
    procedure changeColor (sender: id); message 'changeColor:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSColorPanelColorDidChangeNotification: NSString; cvar; external;
{$endif}

