{ Parsed from AppKit.framework (MacOSX10.8) NSControl.h }
{ Created on Mon Sep 10 11:47:55 2012 }


{$ifdef TYPES}
type
  NSControlPtr = ^NSControl;
  NSControlTextEditingDelegateProtocolPtr = ^NSControlTextEditingDelegateProtocol;
{$endif}

{$ifdef CLASSES}

type
  NSControl = objcclass external (NSView)
  private
    _tag: NSInteger;
    _cell: id;
    __conFlags: bitpacked record
      case byte of
        0: (_anonBitField___conFlags0: cuint);
        1: (
          enabled: 0..1;
          ignoreMultiClick: 0..1;
          calcSize_: 0..1;
          drawingAncestor: 0..1;
          ibReserved: 0..1;
          updateCellFocus: 0..1;
          allowsLogicalLayoutDirection: 0..1;
          asmlwidth: 0..1;
          hsmlwidth: 0..1;
          dontValidate: 0..1;
          reserved: 0..((1 shl 22)-1);
        );
      end;
  public
    class procedure classSetCellClass (factoryId: pobjc_class); message 'setCellClass:';
    class function classCellClass: pobjc_class; message 'cellClass';
    function initWithFrame (frameRect: NSRect): id; message 'initWithFrame:';
    procedure sizeToFit; message 'sizeToFit';
    procedure calcSize; message 'calcSize';
    function cell: id; message 'cell';
    procedure setCell (aCell: NSCell); message 'setCell:';
    function selectedCell: id; message 'selectedCell';
    function target: id; message 'target';
    procedure setTarget (anObject: id); message 'setTarget:';
    function action: SEL; message 'action';
    procedure setAction (aSelector: SEL); message 'setAction:';
    function tag: NSInteger; message 'tag';
    procedure setTag (anInt: NSInteger); message 'setTag:';
    function selectedTag: NSInteger; message 'selectedTag';
    procedure setIgnoresMultiClick (flag: boolean); message 'setIgnoresMultiClick:';
    function ignoresMultiClick: boolean; message 'ignoresMultiClick';
    function sendActionOn (mask: NSInteger): NSInteger; message 'sendActionOn:';
    function isContinuous: boolean; message 'isContinuous';
    procedure setContinuous (flag: boolean); message 'setContinuous:';
    function isEnabled: boolean; message 'isEnabled';
    procedure setEnabled (flag: boolean); message 'setEnabled:';
    function alignment: NSTextAlignment; message 'alignment';
    procedure setAlignment (mode: NSTextAlignment); message 'setAlignment:';
    function font: NSFont; message 'font';
    procedure setFont (fontObj: NSFont); message 'setFont:';
    procedure setFormatter (newFormatter: NSFormatter); message 'setFormatter:';
    function formatter: id; message 'formatter';
    procedure setObjectValue (obj: NSCopyingProtocol); message 'setObjectValue:';
    procedure setStringValue (aString: NSString); message 'setStringValue:';
    procedure setIntValue (anInt: cint); message 'setIntValue:';
    procedure setFloatValue (aFloat: single); message 'setFloatValue:';
    procedure setDoubleValue (aDouble: double); message 'setDoubleValue:';
    function objectValue: id; message 'objectValue';
    function stringValue: NSString; message 'stringValue';
    function intValue: cint; message 'intValue';
    function floatValue: single; message 'floatValue';
    function doubleValue: double; message 'doubleValue';
    procedure setNeedsDisplay; message 'setNeedsDisplay';
    procedure updateCell (aCell: NSCell); message 'updateCell:';
    procedure updateCellInside (aCell: NSCell); message 'updateCellInside:';
    procedure drawCellInside (aCell: NSCell); message 'drawCellInside:';
    procedure drawCell (aCell: NSCell); message 'drawCell:';
    procedure selectCell (aCell: NSCell); message 'selectCell:';
    function sendAction_to (theAction: SEL; theTarget: id): boolean; message 'sendAction:to:';
    procedure takeIntValueFrom (sender: id); message 'takeIntValueFrom:';
    procedure takeFloatValueFrom (sender: id); message 'takeFloatValueFrom:';
    procedure takeDoubleValueFrom (sender: id); message 'takeDoubleValueFrom:';
    procedure takeStringValueFrom (sender: id); message 'takeStringValueFrom:';
    procedure takeObjectValueFrom (sender: id); message 'takeObjectValueFrom:';
    function currentEditor: NSText; message 'currentEditor';
    function abortEditing: boolean; message 'abortEditing';
    procedure validateEditing; message 'validateEditing';
    procedure mouseDown (theEvent: NSEvent); message 'mouseDown:';
    function baseWritingDirection: NSWritingDirection; message 'baseWritingDirection';
    procedure setBaseWritingDirection (writingDirection: NSWritingDirection); message 'setBaseWritingDirection:';
    function integerValue: NSInteger; message 'integerValue'; { available in 10_5 }
    procedure setIntegerValue (anInteger: NSInteger); message 'setIntegerValue:'; { available in 10_5 }
    procedure takeIntegerValueFrom (sender: id); message 'takeIntegerValueFrom:'; { available in 10_5 }
    function allowsExpansionToolTips: boolean; message 'allowsExpansionToolTips'; { available in 10_8 }
    procedure setAllowsExpansionToolTips (value: boolean); message 'setAllowsExpansionToolTips:'; { available in 10_8 }
  end;


type
  NSControl_NSKeyboardUI = objccategory external name 'NSKeyboardUI' (NSControl)
    procedure performClick (sender: id); message 'performClick:';
    procedure setRefusesFirstResponder (flag: boolean); message 'setRefusesFirstResponder:';
    function refusesFirstResponder: boolean; message 'refusesFirstResponder';
  end;

type
  NSControlSubclassNotifications = objccategory external (NSObject)
    procedure controlTextDidBeginEditing (obj: NSNotification); message 'controlTextDidBeginEditing:';
    procedure controlTextDidEndEditing (obj: NSNotification); message 'controlTextDidEndEditing:';
    procedure controlTextDidChange (obj: NSNotification); message 'controlTextDidChange:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSControlTextEditingDelegateProtocol = objcprotocol external name 'NSControlTextEditingDelegate' (NSObjectProtocol)
  optional
    function control_textShouldBeginEditing (control: NSControl; fieldEditor: NSText): boolean; message 'control:textShouldBeginEditing:';
    function control_textShouldEndEditing (control: NSControl; fieldEditor: NSText): boolean; message 'control:textShouldEndEditing:';
    function control_didFailToFormatString_errorDescription (control: NSControl; string_: NSString; error: NSString): boolean; message 'control:didFailToFormatString:errorDescription:';
    procedure control_didFailToValidatePartialString_errorDescription (control: NSControl; string_: NSString; error: NSString); message 'control:didFailToValidatePartialString:errorDescription:';
    function control_isValidObject (control: NSControl; obj: id): boolean; message 'control:isValidObject:';
    function control_textView_doCommandBySelector (control: NSControl; textView: NSTextView; commandSelector: SEL): boolean; message 'control:textView:doCommandBySelector:';
    function control_textView_completions_forPartialWordRange_indexOfSelectedItem (control: NSControl; textView: NSTextView; words: NSArray; charRange: NSRange; index: NSIntegerPtr): NSArray; message 'control:textView:completions:forPartialWordRange:indexOfSelectedItem:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSControlTextDidBeginEditingNotification: NSString; cvar; external;
  NSControlTextDidEndEditingNotification: NSString; cvar; external;
  NSControlTextDidChangeNotification: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSControlAttributedStringMethods = objccategory external (NSControl)
    function attributedStringValue: NSAttributedString; message 'attributedStringValue';
    procedure setAttributedStringValue (obj: NSAttributedString); message 'setAttributedStringValue:';
  end;

type
  NSControl_NSDeprecated = objccategory external name 'NSDeprecated' (NSControl)
    procedure setFloatingPointFormat_left_right (autoRange: boolean; leftDigits: NSUInteger; rightDigits: NSUInteger); message 'setFloatingPointFormat:left:right:'; deprecated 'in 10_0, 10_0';
  end;
{$endif}

