{ Parsed from AppKit.framework (MacOSX10.8) NSDocument.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{ Types from NSDocument }
{$ifdef TYPES}



{$endif}


{$ifdef TYPES}
type
  NSDocumentPtr = ^NSDocument;
{$endif}

{$ifdef TYPES}
const
  NSChangeDone = 0;
  NSChangeUndone = 1;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
  NSChangeRedone = 5;
  {$endif}
  NSChangeCleared = 2;
  NSChangeReadOtherContents = 3;
  NSChangeAutosaved = 4;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
  NSChangeDiscardable = 256;
  {$endif}

type
  NSDocumentChangeType = NSUInteger;
  NSDocumentChangeTypePtr = ^NSDocumentChangeType;

const
  NSSaveOperation = 0;
  NSSaveAsOperation = 1;
  NSSaveToOperation = 2;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
  NSAutosaveInPlaceOperation = 4;
  {$endif}
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
  NSAutosaveElsewhereOperation = 3;
  {$endif}
  NSAutosaveAsOperation = 5 { available in 10_8 };
  NSAutosaveOperation = 3;

type
  NSSaveOperationType = NSUInteger;
  NSSaveOperationTypePtr = ^NSSaveOperationType;
{$endif}

{$ifdef CLASSES}

type
  NSDocument = objcclass external (NSObject, NSFilePresenterProtocol, NSUserInterfaceValidationsProtocol)
  private
    _window: NSWindow;
    _windowControllers: id;
    _fileURL: NSURL;
    _fileType: NSString;
    _printInfo: NSPrintInfo;
    _documentReserved: clong;
    savePanelAccessory: NSView;
    _displayName: id;
    _privateData: id;
    _undoManager: NSUndoManager;
    __docFlags: bitpacked record
      case byte of
        0: (_anonBitField___docFlags0: cuint);
        1: (
          inClose: 0..1;
          hasUndoManager_: 0..1;
          unused: 0..1;
          reconciledToFileName: 0..1;
          checkingDisplayName: 0..1;
          hasInvalidRestorableState: 0..1;
          hasEverHadInvalidRestorableState: 0..1;
          RESERVED: 0..((1 shl 25)-1);
        );
      end;
    _savePanelSaveType: NSString;
  public
    function init: id; message 'init';
    function initWithType_error (typeName: NSString; outError: NSErrorPtr): id; message 'initWithType:error:';
    class function canConcurrentlyReadDocumentsOfType (typeName: NSString): boolean; message 'canConcurrentlyReadDocumentsOfType:'; { available in 10_6 }
    function initWithContentsOfURL_ofType_error (url: NSURL; typeName: NSString; outError: NSErrorPtr): id; message 'initWithContentsOfURL:ofType:error:';
    function initForURL_withContentsOfURL_ofType_error (urlOrNil: NSURL; contentsURL: NSURL; typeName: NSString; outError: NSErrorPtr): id; message 'initForURL:withContentsOfURL:ofType:error:';
    procedure setFileType (typeName: NSString); message 'setFileType:';
    function fileType: NSString; message 'fileType';
    procedure setFileURL (url: NSURL); message 'setFileURL:';
    function fileURL: NSURL; message 'fileURL';
    procedure setFileModificationDate (modificationDate: NSDate); message 'setFileModificationDate:';
    function fileModificationDate: NSDate; message 'fileModificationDate';
    procedure setDraft (flag: boolean); message 'setDraft:'; { available in 10_8 }
    function isDraft: boolean; message 'isDraft'; { available in 10_8 }
    {$if defined(NS_BLOCKS_AVAILABLE)}
    procedure performActivityWithSynchronousWaiting_usingBlock (waitSynchronously: boolean; block: OpaqueCBlock); message 'performActivityWithSynchronousWaiting:usingBlock:'; { available in 10_7 }
    procedure continueActivityUsingBlock (block: OpaqueCBlock); message 'continueActivityUsingBlock:'; { available in 10_7 }
    procedure continueAsynchronousWorkOnMainThreadUsingBlock (block: OpaqueCBlock); message 'continueAsynchronousWorkOnMainThreadUsingBlock:'; { available in 10_7 }
    procedure performSynchronousFileAccessUsingBlock (block: OpaqueCBlock); message 'performSynchronousFileAccessUsingBlock:'; { available in 10_7 }
    procedure performAsynchronousFileAccessUsingBlock (block: OpaqueCBlock); message 'performAsynchronousFileAccessUsingBlock:'; { available in 10_7 }
    {$endif}
    procedure revertDocumentToSaved (sender: id); message 'revertDocumentToSaved:';
    function revertToContentsOfURL_ofType_error (url: NSURL; typeName: NSString; outError: NSErrorPtr): boolean; message 'revertToContentsOfURL:ofType:error:';
    function readFromURL_ofType_error (url: NSURL; typeName: NSString; outError: NSErrorPtr): boolean; message 'readFromURL:ofType:error:';
    function readFromFileWrapper_ofType_error (fileWrapper: NSFileWrapper; typeName: NSString; outError: NSErrorPtr): boolean; message 'readFromFileWrapper:ofType:error:';
    function readFromData_ofType_error (data: NSData; typeName: NSString; outError: NSErrorPtr): boolean; message 'readFromData:ofType:error:';
    function isEntireFileLoaded: boolean; message 'isEntireFileLoaded'; { available in 10_7 }
    function writeToURL_ofType_error (url: NSURL; typeName: NSString; outError: NSErrorPtr): boolean; message 'writeToURL:ofType:error:';
    function fileWrapperOfType_error (typeName: NSString; outError: NSErrorPtr): NSFileWrapper; message 'fileWrapperOfType:error:';
    function dataOfType_error (typeName: NSString; outError: NSErrorPtr): NSData; message 'dataOfType:error:';
    procedure unblockUserInteraction; message 'unblockUserInteraction'; { available in 10_7 }
    function autosavingIsImplicitlyCancellable: boolean; message 'autosavingIsImplicitlyCancellable'; { available in 10_7 }
    function writeSafelyToURL_ofType_forSaveOperation_error (url: NSURL; typeName: NSString; saveOperation: NSSaveOperationType; outError: NSErrorPtr): boolean; message 'writeSafelyToURL:ofType:forSaveOperation:error:';
    function writeToURL_ofType_forSaveOperation_originalContentsURL_error (url: NSURL; typeName: NSString; saveOperation: NSSaveOperationType; absoluteOriginalContentsURL: NSURL; outError: NSErrorPtr): boolean; message 'writeToURL:ofType:forSaveOperation:originalContentsURL:error:';
    function fileAttributesToWriteToURL_ofType_forSaveOperation_originalContentsURL_error (url: NSURL; typeName: NSString; saveOperation: NSSaveOperationType; absoluteOriginalContentsURL: NSURL; outError: NSErrorPtr): NSDictionary; message 'fileAttributesToWriteToURL:ofType:forSaveOperation:originalContentsURL:error:';
    function keepBackupFile: boolean; message 'keepBackupFile';
    function backupFileURL: NSURL; message 'backupFileURL'; { available in 10_8 }
    procedure saveDocument (sender: id); message 'saveDocument:';
    procedure saveDocumentAs (sender: id); message 'saveDocumentAs:';
    procedure saveDocumentTo (sender: id); message 'saveDocumentTo:';
    procedure saveDocumentWithDelegate_didSaveSelector_contextInfo (delegate: id; didSaveSelector: SEL; contextInfo: pointer); message 'saveDocumentWithDelegate:didSaveSelector:contextInfo:';
    procedure runModalSavePanelForSaveOperation_delegate_didSaveSelector_contextInfo (saveOperation: NSSaveOperationType; delegate: id; didSaveSelector: SEL; contextInfo: pointer); message 'runModalSavePanelForSaveOperation:delegate:didSaveSelector:contextInfo:';
    function shouldRunSavePanelWithAccessoryView: boolean; message 'shouldRunSavePanelWithAccessoryView';
    function prepareSavePanel (savePanel: NSSavePanel): boolean; message 'prepareSavePanel:';
    function fileNameExtensionWasHiddenInLastRunSavePanel: boolean; message 'fileNameExtensionWasHiddenInLastRunSavePanel';
    function fileTypeFromLastRunSavePanel: NSString; message 'fileTypeFromLastRunSavePanel';
    procedure saveToURL_ofType_forSaveOperation_delegate_didSaveSelector_contextInfo (url: NSURL; typeName: NSString; saveOperation: NSSaveOperationType; delegate: id; didSaveSelector: SEL; contextInfo: pointer); message 'saveToURL:ofType:forSaveOperation:delegate:didSaveSelector:contextInfo:';
    {$if defined(NS_BLOCKS_AVAILABLE)}
    procedure saveToURL_ofType_forSaveOperation_completionHandler (url: NSURL; typeName: NSString; saveOperation: NSSaveOperationType; completionHandler: OpaqueCBlock); message 'saveToURL:ofType:forSaveOperation:completionHandler:'; { available in 10_7 }
    {$endif}
    function canAsynchronouslyWriteToURL_ofType_forSaveOperation (url: NSURL; typeName: NSString; saveOperation: NSSaveOperationType): boolean; message 'canAsynchronouslyWriteToURL:ofType:forSaveOperation:'; { available in 10_7 }
    function checkAutosavingSafetyAndReturnError (outError: NSErrorPtr): boolean; message 'checkAutosavingSafetyAndReturnError:'; { available in 10_7 }
    procedure scheduleAutosaving; message 'scheduleAutosaving'; { available in 10_7 }
    function hasUnautosavedChanges: boolean; message 'hasUnautosavedChanges';
    procedure autosaveDocumentWithDelegate_didAutosaveSelector_contextInfo (delegate: id; didAutosaveSelector: SEL; contextInfo: pointer); message 'autosaveDocumentWithDelegate:didAutosaveSelector:contextInfo:';
    {$if defined(NS_BLOCKS_AVAILABLE)}
    procedure autosaveWithImplicitCancellability_completionHandler (autosavingIsImplicitlyCancellable_: boolean; completionHandler: OpaqueCBlock); message 'autosaveWithImplicitCancellability:completionHandler:'; { available in 10_7 }
    {$endif}
    class function autosavesInPlace: boolean; message 'autosavesInPlace'; { available in 10_7 }
    class function preservesVersions: boolean; message 'preservesVersions'; { available in 10_7 }
    procedure browseDocumentVersions (sender: id); message 'browseDocumentVersions:'; { available in 10_8 }
    class function autosavesDrafts: boolean; message 'autosavesDrafts'; { available in 10_8 }
    function autosavingFileType: NSString; message 'autosavingFileType';
    procedure setAutosavedContentsFileURL (url: NSURL); message 'setAutosavedContentsFileURL:';
    function autosavedContentsFileURL: NSURL; message 'autosavedContentsFileURL';
    procedure canCloseDocumentWithDelegate_shouldCloseSelector_contextInfo (delegate: id; shouldCloseSelector: SEL; contextInfo: pointer); message 'canCloseDocumentWithDelegate:shouldCloseSelector:contextInfo:';
    procedure close; message 'close';
    procedure duplicateDocument (sender: id); message 'duplicateDocument:'; { available in 10_7 }
    procedure duplicateDocumentWithDelegate_didDuplicateSelector_contextInfo (delegate: id; didDuplicateSelector: SEL; contextInfo: pointer); message 'duplicateDocumentWithDelegate:didDuplicateSelector:contextInfo:'; { available in 10_7 }
    function duplicateAndReturnError (outError: NSErrorPtr): NSDocument; message 'duplicateAndReturnError:'; { available in 10_7 }
    procedure renameDocument (sender: id); message 'renameDocument:'; { available in 10_8 }
    procedure moveDocumentToUbiquityContainer (sender: id); message 'moveDocumentToUbiquityContainer:'; { available in 10_8 }
    procedure moveDocument (sender: id); message 'moveDocument:'; { available in 10_8 }
    procedure moveDocumentWithCompletionHandler (completionHandler: OpaqueCBlock); message 'moveDocumentWithCompletionHandler:'; { available in 10_8 }
    procedure moveToURL_completionHandler (url: NSURL; completionHandler: OpaqueCBlock); message 'moveToURL:completionHandler:'; { available in 10_8 }
    procedure lockDocument (sender: id); message 'lockDocument:'; { available in 10_8 }
    procedure unlockDocument (sender: id); message 'unlockDocument:'; { available in 10_8 }
    procedure lockDocumentWithCompletionHandler (completionHandler: OpaqueCBlock); message 'lockDocumentWithCompletionHandler:'; { available in 10_8 }
    procedure lockWithCompletionHandler (completionHandler: OpaqueCBlock); message 'lockWithCompletionHandler:'; { available in 10_8 }
    procedure unlockDocumentWithCompletionHandler (completionHandler: OpaqueCBlock); message 'unlockDocumentWithCompletionHandler:'; { available in 10_8 }
    procedure unlockWithCompletionHandler (completionHandler: OpaqueCBlock); message 'unlockWithCompletionHandler:'; { available in 10_8 }
    function isLocked: boolean; message 'isLocked'; { available in 10_8 }
    procedure runPageLayout (sender: id); message 'runPageLayout:';
    procedure runModalPageLayoutWithPrintInfo_delegate_didRunSelector_contextInfo (printInfo: NSPrintInfo; delegate: id; didRunSelector: SEL; contextInfo: pointer); message 'runModalPageLayoutWithPrintInfo:delegate:didRunSelector:contextInfo:';
    function preparePageLayout (pageLayout: NSPageLayout): boolean; message 'preparePageLayout:';
    function shouldChangePrintInfo (newPrintInfo: NSPrintInfo): boolean; message 'shouldChangePrintInfo:';
    procedure setPrintInfo (printInfo: NSPrintInfo); message 'setPrintInfo:';
    function printInfo: NSPrintInfo; message 'printInfo';
    procedure printDocument (sender: id); message 'printDocument:';
    procedure printDocumentWithSettings_showPrintPanel_delegate_didPrintSelector_contextInfo (printSettings: NSDictionary; showPrintPanel: boolean; delegate: id; didPrintSelector: SEL; contextInfo: pointer); message 'printDocumentWithSettings:showPrintPanel:delegate:didPrintSelector:contextInfo:';
    function printOperationWithSettings_error (printSettings: NSDictionary; outError: NSErrorPtr): NSPrintOperation; message 'printOperationWithSettings:error:';
    procedure runModalPrintOperation_delegate_didRunSelector_contextInfo (printOperation: NSPrintOperation; delegate: id; didRunSelector: SEL; contextInfo: pointer); message 'runModalPrintOperation:delegate:didRunSelector:contextInfo:';
    function isDocumentEdited: boolean; message 'isDocumentEdited';
    function isInViewingMode: boolean; message 'isInViewingMode'; { available in 10_7 }
    procedure updateChangeCount (change: NSDocumentChangeType); message 'updateChangeCount:';
    function changeCountTokenForSaveOperation (saveOperation: NSSaveOperationType): id; message 'changeCountTokenForSaveOperation:'; { available in 10_7 }
    procedure updateChangeCountWithToken_forSaveOperation (changeCountToken: id; saveOperation: NSSaveOperationType); message 'updateChangeCountWithToken:forSaveOperation:'; { available in 10_7 }
    procedure setUndoManager (undoManager: NSUndoManager); message 'setUndoManager:';
    function undoManager: NSUndoManager; message 'undoManager';
    procedure setHasUndoManager (hasUndoManager: boolean); message 'setHasUndoManager:';
    function hasUndoManager: boolean; message 'hasUndoManager';
    procedure presentError_modalForWindow_delegate_didPresentSelector_contextInfo (error: NSError; window: NSWindow; delegate: id; didPresentSelector: SEL; contextInfo: pointer); message 'presentError:modalForWindow:delegate:didPresentSelector:contextInfo:';
    function presentError (error: NSError): boolean; message 'presentError:';
    function willPresentError (error: NSError): NSError; message 'willPresentError:';
    procedure willNotPresentError (error: NSError); message 'willNotPresentError:'; { available in 10_7 }
    procedure makeWindowControllers; message 'makeWindowControllers';
    function windowNibName: NSString; message 'windowNibName';
    procedure windowControllerWillLoadNib (windowController: NSWindowController); message 'windowControllerWillLoadNib:';
    procedure windowControllerDidLoadNib (windowController: NSWindowController); message 'windowControllerDidLoadNib:';
    procedure setWindow (window: NSWindow); message 'setWindow:';
    procedure addWindowController (windowController: NSWindowController); message 'addWindowController:';
    procedure removeWindowController (windowController: NSWindowController); message 'removeWindowController:';
    procedure showWindows; message 'showWindows';
    function windowControllers: NSArray; message 'windowControllers';
    procedure shouldCloseWindowController_delegate_shouldCloseSelector_contextInfo (windowController: NSWindowController; delegate: id; shouldCloseSelector: SEL; contextInfo: pointer); message 'shouldCloseWindowController:delegate:shouldCloseSelector:contextInfo:';
    procedure setDisplayName (displayNameOrNil: NSString); message 'setDisplayName:'; { available in 10_7 }
    function displayName: NSString; message 'displayName';
    function defaultDraftName: NSString; message 'defaultDraftName'; { available in 10_8 }
    function windowForSheet: NSWindow; message 'windowForSheet';
    class function readableTypes: NSArray; message 'readableTypes';
    class function writableTypes: NSArray; message 'writableTypes';
    class function isNativeType (type_: NSString): boolean; message 'isNativeType:';
    function writableTypesForSaveOperation (saveOperation: NSSaveOperationType): NSArray; message 'writableTypesForSaveOperation:';
    function fileNameExtensionForType_saveOperation (typeName: NSString; saveOperation: NSSaveOperationType): NSString; message 'fileNameExtensionForType:saveOperation:'; { available in 10_5 }
    function validateUserInterfaceItem (anItem: NSValidatedUserInterfaceItemProtocol): boolean; message 'validateUserInterfaceItem:';
    class function usesUbiquitousStorage: boolean; message 'usesUbiquitousStorage'; { available in 10_8 }

    { Adopted protocols }
    procedure accommodatePresentedItemDeletionWithCompletionHandler (completionHandler: OpaqueCBlock); message 'accommodatePresentedItemDeletionWithCompletionHandler:';
    procedure accommodatePresentedSubitemDeletionAtURL_completionHandler (url: NSURL; completionHandler: OpaqueCBlock); message 'accommodatePresentedSubitemDeletionAtURL:completionHandler:';
    function autorelease: id; message 'autorelease';
    function class_: pobjc_class; message 'class';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function isProxy: boolean; message 'isProxy';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    procedure presentedItemDidChange; message 'presentedItemDidChange';
    procedure presentedItemDidGainVersion (version: NSFileVersion); message 'presentedItemDidGainVersion:';
    procedure presentedItemDidLoseVersion (version: NSFileVersion); message 'presentedItemDidLoseVersion:';
    procedure presentedItemDidMoveToURL (newURL: NSURL); message 'presentedItemDidMoveToURL:';
    procedure presentedItemDidResolveConflictVersion (version: NSFileVersion); message 'presentedItemDidResolveConflictVersion:';
    function presentedItemOperationQueue: NSOperationQueue; message 'presentedItemOperationQueue';
    function presentedItemURL: NSURL; message 'presentedItemURL';
    procedure presentedSubitemAtURL_didGainVersion (url: NSURL; version: NSFileVersion); message 'presentedSubitemAtURL:didGainVersion:';
    procedure presentedSubitemAtURL_didLoseVersion (url: NSURL; version: NSFileVersion); message 'presentedSubitemAtURL:didLoseVersion:';
    procedure presentedSubitemAtURL_didMoveToURL (oldURL: NSURL; newURL: NSURL); message 'presentedSubitemAtURL:didMoveToURL:';
    procedure presentedSubitemAtURL_didResolveConflictVersion (url: NSURL; version: NSFileVersion); message 'presentedSubitemAtURL:didResolveConflictVersion:';
    procedure presentedSubitemDidAppearAtURL (url: NSURL); message 'presentedSubitemDidAppearAtURL:';
    procedure presentedSubitemDidChangeAtURL (url: NSURL); message 'presentedSubitemDidChangeAtURL:';
    function primaryPresentedItemURL: NSURL; message 'primaryPresentedItemURL';
    procedure release; message 'release';
    procedure relinquishPresentedItemToReader (reader: OpaqueCBlock); message 'relinquishPresentedItemToReader:';
    procedure relinquishPresentedItemToWriter (writer: OpaqueCBlock); message 'relinquishPresentedItemToWriter:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    function retainCount: NSUInteger; message 'retainCount';
    procedure savePresentedItemChangesWithCompletionHandler (completionHandler: OpaqueCBlock); message 'savePresentedItemChangesWithCompletionHandler:';
    function self_: id; message 'self';
    function superclass: pobjc_class; message 'superclass';
    function zone: NSZonePtr; message 'zone';
  end;


type
  NSDocument_NSDeprecated = objccategory external name 'NSDeprecated' (NSDocument)
    function saveToURL_ofType_forSaveOperation_error (url: NSURL; typeName: NSString; saveOperation: NSSaveOperationType; outError: NSErrorPtr): boolean; message 'saveToURL:ofType:forSaveOperation:error:';
    function dataRepresentationOfType (type_: NSString): NSData; message 'dataRepresentationOfType:'; deprecated 'in 10_0, 10_4';
    function fileAttributesToWriteToFile_ofType_saveOperation (fullDocumentPath: NSString; documentTypeName: NSString; saveOperationType: NSSaveOperationType): NSDictionary; message 'fileAttributesToWriteToFile:ofType:saveOperation:'; deprecated 'in 10_1, 10_4';
    function fileName: NSString; message 'fileName'; deprecated 'in 10_0, 10_4';
    function fileWrapperRepresentationOfType (type_: NSString): NSFileWrapper; message 'fileWrapperRepresentationOfType:'; deprecated 'in 10_0, 10_4';
    function initWithContentsOfFile_ofType (absolutePath: NSString; typeName: NSString): id; message 'initWithContentsOfFile:ofType:'; deprecated 'in 10_0, 10_4';
    function initWithContentsOfURL_ofType (url: NSURL; typeName: NSString): id; message 'initWithContentsOfURL:ofType:'; deprecated 'in 10_0, 10_4';
    function loadDataRepresentation_ofType (data: NSData; type_: NSString): boolean; message 'loadDataRepresentation:ofType:'; deprecated 'in 10_0, 10_4';
    function loadFileWrapperRepresentation_ofType (wrapper: NSFileWrapper; type_: NSString): boolean; message 'loadFileWrapperRepresentation:ofType:'; deprecated 'in 10_0, 10_4';
    procedure printShowingPrintPanel (flag: boolean); message 'printShowingPrintPanel:'; deprecated 'in 10_0, 10_4';
    function readFromFile_ofType (fileName_: NSString; type_: NSString): boolean; message 'readFromFile:ofType:'; deprecated 'in 10_0, 10_4';
    function readFromURL_ofType (url: NSURL; type_: NSString): boolean; message 'readFromURL:ofType:'; deprecated 'in 10_0, 10_4';
    function revertToSavedFromFile_ofType (fileName_: NSString; type_: NSString): boolean; message 'revertToSavedFromFile:ofType:'; deprecated 'in 10_0, 10_4';
    function revertToSavedFromURL_ofType (url: NSURL; type_: NSString): boolean; message 'revertToSavedFromURL:ofType:'; deprecated 'in 10_0, 10_4';
    function runModalPageLayoutWithPrintInfo (printInfo_: NSPrintInfo): NSInteger; message 'runModalPageLayoutWithPrintInfo:'; deprecated 'in 10_0, 10_4';
    procedure saveToFile_saveOperation_delegate_didSaveSelector_contextInfo (fileName_: NSString; saveOperation: NSSaveOperationType; delegate: id; didSaveSelector: SEL; contextInfo: pointer); message 'saveToFile:saveOperation:delegate:didSaveSelector:contextInfo:'; deprecated 'in 10_0, 10_4';
    procedure setFileName (fileName_: NSString); message 'setFileName:'; deprecated 'in 10_0, 10_4';
    function writeToFile_ofType (fileName_: NSString; type_: NSString): boolean; message 'writeToFile:ofType:'; deprecated 'in 10_0, 10_4';
    function writeToFile_ofType_originalFile_saveOperation (fullDocumentPath: NSString; documentTypeName: NSString; fullOriginalDocumentPath: NSString; saveOperationType: NSSaveOperationType): boolean; message 'writeToFile:ofType:originalFile:saveOperation:'; deprecated 'in 10_0, 10_4';
    function writeToURL_ofType (url: NSURL; type_: NSString): boolean; message 'writeToURL:ofType:'; deprecated 'in 10_0, 10_4';
    function writeWithBackupToFile_ofType_saveOperation (fullDocumentPath: NSString; documentTypeName: NSString; saveOperationType: NSSaveOperationType): boolean; message 'writeWithBackupToFile:ofType:saveOperation:'; deprecated 'in 10_0, 10_4';
  end;
{$endif}

