{ Parsed from AppKit.framework (MacOSX10.8) NSDragging.h }
{ Created on Mon Sep 10 11:47:55 2012 }


{ Types from NSDraggingInfoProtocol }
{$ifdef TYPES}

{$endif}


{$ifdef TYPES}
type
  NSDraggingInfoProtocolPtr = ^NSDraggingInfoProtocol;
  NSDraggingDestinationProtocolPtr = ^NSDraggingDestinationProtocol;
  NSDraggingSourceProtocolPtr = ^NSDraggingSourceProtocol;
{$endif}

{$ifdef TYPES}
type
  NSDragOperation = NSUInteger;
  NSDragOperationPtr = ^NSDragOperation;

const
  NSDragOperationNone = 0;
  NSDragOperationCopy = 1;
  NSDragOperationLink = 2;
  NSDragOperationGeneric = 4;
  NSDragOperationPrivate = 8;
  NSDragOperationAll_Obsolete = 15;
  NSDragOperationMove = 16;
  NSDragOperationDelete = 32;
  NSDragOperationEvery = NSUIntegerMax;

const
  NSDragOperationAll = NSDragOperationAll_Obsolete;
{$endif}

{$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED)}
{$ifdef TYPES}
const
  NSDraggingFormationDefault = 0;
  NSDraggingFormationNone = 1;
  NSDraggingFormationPile = 2;
  NSDraggingFormationList = 3;
  NSDraggingFormationStack = 4;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSDraggingFormation = NSInteger;
  NSDraggingFormationPtr = ^NSDraggingFormation;
{$endif}

{$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED)}
{$ifdef TYPES}
const
  NSDraggingContextOutsideApplication = 0;
  NSDraggingContextWithinApplication = 1;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSDraggingContext = NSInteger;
  NSDraggingContextPtr = ^NSDraggingContext;
{$endif}

{$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED)}
{$ifdef TYPES}
const
  NSDraggingItemEnumerationConcurrent = NSEnumerationConcurrent;
  NSDraggingItemEnumerationClearNonenumeratedImages = 1 shl 16;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSDraggingItemEnumerationOptions = NSUInteger;
  NSDraggingItemEnumerationOptionsPtr = ^NSDraggingItemEnumerationOptions;
{$endif}

{$ifdef PROTOCOLS}

type
  NSDraggingInfoProtocol = objcprotocol external name 'NSDraggingInfo' (NSObjectProtocol)
  required
    function draggingDestinationWindow: NSWindow; message 'draggingDestinationWindow';
    function draggingSourceOperationMask: NSDragOperation; message 'draggingSourceOperationMask';
    function draggingLocation: NSPoint; message 'draggingLocation';
    function draggedImageLocation: NSPoint; message 'draggedImageLocation';
    function draggedImage: NSImage; message 'draggedImage';
    function draggingPasteboard: NSPasteboard; message 'draggingPasteboard';
    function draggingSource: id; message 'draggingSource';
    function draggingSequenceNumber: NSInteger; message 'draggingSequenceNumber';
    procedure slideDraggedImageTo (screenPoint: NSPoint); message 'slideDraggedImageTo:';
    function namesOfPromisedFilesDroppedAtDestination (dropDestination: NSURL): NSArray; message 'namesOfPromisedFilesDroppedAtDestination:';
    procedure setDraggingFormation(newValue: NSDraggingFormation); message 'setDraggingFormation:';
    function draggingFormation: NSDraggingFormation; message 'draggingFormation';
    procedure setAnimatesToDestination(newValue: boolean); message 'setAnimatesToDestination:';
    function animatesToDestination: boolean; message 'animatesToDestination';
    procedure setNumberOfValidItemsForDrop(newValue: NSInteger); message 'setNumberOfValidItemsForDrop:';
    function numberOfValidItemsForDrop: NSInteger; message 'numberOfValidItemsForDrop';
    {$if defined(NS_BLOCKS_AVAILABLE)}
    procedure enumerateDraggingItemsWithOptions_forView_classes_searchOptions_usingBlock (enumOpts: NSDraggingItemEnumerationOptions; view: NSView; classArray: NSArray; searchOptions: NSDictionary; block: OpaqueCBlock); message 'enumerateDraggingItemsWithOptions:forView:classes:searchOptions:usingBlock:'; { available in 10_7 }
    {$endif}
  end;

type
  NSDraggingDestinationProtocol = objcprotocol external name 'NSDraggingDestination' (NSObjectProtocol)
  optional
    function draggingEntered (sender: NSDraggingInfoProtocol): NSDragOperation; message 'draggingEntered:';
    function draggingUpdated (sender: NSDraggingInfoProtocol): NSDragOperation; message 'draggingUpdated:';
    procedure draggingExited (sender: NSDraggingInfoProtocol); message 'draggingExited:';
    function prepareForDragOperation (sender: NSDraggingInfoProtocol): boolean; message 'prepareForDragOperation:';
    function performDragOperation (sender: NSDraggingInfoProtocol): boolean; message 'performDragOperation:';
    procedure concludeDragOperation (sender: NSDraggingInfoProtocol); message 'concludeDragOperation:';
    procedure draggingEnded (sender: NSDraggingInfoProtocol); message 'draggingEnded:';
    function wantsPeriodicDraggingUpdates: boolean; message 'wantsPeriodicDraggingUpdates';
    procedure updateDraggingItemsForDrag (sender: NSDraggingInfoProtocol); message 'updateDraggingItemsForDrag:'; { available in 10_7 }
  end;

type
  NSDraggingSourceProtocol = objcprotocol external name 'NSDraggingSource' (NSObjectProtocol)
  required
    function draggingSession_sourceOperationMaskForDraggingContext (session: NSDraggingSession; context: NSDraggingContext): NSDragOperation; message 'draggingSession:sourceOperationMaskForDraggingContext:';
  optional
    procedure draggingSession_willBeginAtPoint (session: NSDraggingSession; screenPoint: NSPoint); message 'draggingSession:willBeginAtPoint:';
    procedure draggingSession_movedToPoint (session: NSDraggingSession; screenPoint: NSPoint); message 'draggingSession:movedToPoint:';
    procedure draggingSession_endedAtPoint_operation (session: NSDraggingSession; screenPoint: NSPoint; operation: NSDragOperation); message 'draggingSession:endedAtPoint:operation:';
    function ignoreModifierKeysForDraggingSession (session: NSDraggingSession): boolean; message 'ignoreModifierKeysForDraggingSession:';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSDraggingSourceDeprecated = objccategory external (NSObject)
    function draggingSourceOperationMaskForLocal (flag: boolean): NSDragOperation; message 'draggingSourceOperationMaskForLocal:';
    function namesOfPromisedFilesDroppedAtDestination (dropDestination: NSURL): NSArray; message 'namesOfPromisedFilesDroppedAtDestination:';
    procedure draggedImage_beganAt (image: NSImage; screenPoint: NSPoint); message 'draggedImage:beganAt:';
    procedure draggedImage_endedAt_operation (image: NSImage; screenPoint: NSPoint; operation: NSDragOperation); message 'draggedImage:endedAt:operation:';
    procedure draggedImage_movedTo (image: NSImage; screenPoint: NSPoint); message 'draggedImage:movedTo:';
    function ignoreModifierKeysWhileDragging: boolean; message 'ignoreModifierKeysWhileDragging';
    procedure draggedImage_endedAt_deposited (image: NSImage; screenPoint: NSPoint; flag: boolean); message 'draggedImage:endedAt:deposited:'; deprecated 'in 10_0, 10_1';
    procedure draggedImage_endedAt_deposited_ (image: NSImage; screenPoint: NSPoint; flag: boolean); message 'draggedImage:endedAt:deposited:'; deprecated 'in 10.1 and later';
  end;
{$endif}

