{ Parsed from AppKit.framework (MacOSX10.8) NSDrawer.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSDrawerPtr = ^NSDrawer;
  NSDrawerDelegateProtocolPtr = ^NSDrawerDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSDrawerClosedState = 0;
  NSDrawerOpeningState = 1;
  NSDrawerOpenState = 2;
  NSDrawerClosingState = 3;

type
  NSDrawerState = NSUInteger;
  NSDrawerStatePtr = ^NSDrawerState;
{$endif}

{$ifdef CLASSES}

type
  NSDrawer = objcclass external (NSResponder)
  private
    _drawerState: NSDrawerState;
    _drawerNextState: NSDrawerState;
    _drawerEdge: NSRectEdge;
    _drawerNextEdge: NSRectEdge;
    _drawerPreferredEdge: NSRectEdge;
    _drawerPercent: single;
    _drawerPercentSaved: single;
    _drawerLeadingOffset: CGFloat;
    _drawerTrailingOffset: CGFloat;
    _drawerLock: NSLock;
    _drawerWindow: NSWindow;
    _drawerParentWindow: NSWindow;
    _drawerNextParentWindow: NSWindow;
    _drawerSaveName: NSString;
    _drawerStartTime: CFAbsoluteTime;
    _drawerTotalTime: CFTimeInterval;
    _drawerLoop: CFRunLoopRef;
    _drawerTimer: CFRunLoopTimerRef;
    _drawerDelegate: id;
    _drawerFlags: cuint;
    _drawerObserver: CFRunLoopObserverRef;
  public
    function initWithContentSize_preferredEdge (contentSize: NSSize; edge: NSRectEdge): id; message 'initWithContentSize:preferredEdge:';
    procedure setParentWindow (parent: NSWindow); message 'setParentWindow:';
    function parentWindow: NSWindow; message 'parentWindow';
    procedure setContentView (aView: NSView); message 'setContentView:';
    function contentView: NSView; message 'contentView';
    procedure setPreferredEdge (edge: NSRectEdge); message 'setPreferredEdge:';
    function preferredEdge: NSRectEdge; message 'preferredEdge';
    procedure setDelegate (anObject: NSDrawerDelegateProtocol); message 'setDelegate:';
    function delegate: NSDrawerDelegateProtocol; message 'delegate';
    procedure open; message 'open';
    procedure openOnEdge (edge: NSRectEdge); message 'openOnEdge:';
    procedure close; message 'close';
    procedure open_ (sender: id); message 'open:';
    procedure close_ (sender: id); message 'close:';
    procedure toggle (sender: id); message 'toggle:';
    function state: NSInteger; message 'state';
    function edge: NSRectEdge; message 'edge';
    procedure setContentSize (size: NSSize); message 'setContentSize:';
    function contentSize: NSSize; message 'contentSize';
    procedure setMinContentSize (size: NSSize); message 'setMinContentSize:';
    function minContentSize: NSSize; message 'minContentSize';
    procedure setMaxContentSize (size: NSSize); message 'setMaxContentSize:';
    function maxContentSize: NSSize; message 'maxContentSize';
    procedure setLeadingOffset (offset: CGFloat); message 'setLeadingOffset:';
    function leadingOffset: CGFloat; message 'leadingOffset';
    procedure setTrailingOffset (offset: CGFloat); message 'setTrailingOffset:';
    function trailingOffset: CGFloat; message 'trailingOffset';
  end;


type
  Drawers = objccategory external (NSWindow)
    function drawers: NSArray; message 'drawers';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSDrawerDelegateProtocol = objcprotocol external name 'NSDrawerDelegate' (NSObjectProtocol)
  optional
    function drawerShouldOpen (sender: NSDrawer): boolean; message 'drawerShouldOpen:';
    function drawerShouldClose (sender: NSDrawer): boolean; message 'drawerShouldClose:';
    function drawerWillResizeContents_toSize (sender: NSDrawer; contentSize: NSSize): NSSize; message 'drawerWillResizeContents:toSize:';
    procedure drawerWillOpen (notification: NSNotification); message 'drawerWillOpen:';
    procedure drawerDidOpen (notification: NSNotification); message 'drawerDidOpen:';
    procedure drawerWillClose (notification: NSNotification); message 'drawerWillClose:';
    procedure drawerDidClose (notification: NSNotification); message 'drawerDidClose:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSDrawerWillOpenNotification: NSString; cvar; external;
  NSDrawerDidOpenNotification: NSString; cvar; external;
  NSDrawerWillCloseNotification: NSString; cvar; external;
  NSDrawerDidCloseNotification: NSString; cvar; external;
{$endif}

