{ Parsed from AppKit.framework (MacOSX10.8) NSFontManager.h }
{ Created on Mon Sep 10 11:47:55 2012 }


{$ifdef TYPES}
type
  NSFontManagerPtr = ^NSFontManager;
{$endif}

{$ifdef TYPES}
type
  NSFontTraitMask = NSUInteger;
  NSFontTraitMaskPtr = ^NSFontTraitMask;

const
  NSItalicFontMask = $00000001;
  NSBoldFontMask = $00000002;
  NSUnboldFontMask = $00000004;
  NSNonStandardCharacterSetFontMask = $00000008;
  NSNarrowFontMask = $00000010;
  NSExpandedFontMask = $00000020;
  NSCondensedFontMask = $00000040;
  NSSmallCapsFontMask = $00000080;
  NSPosterFontMask = $00000100;
  NSCompressedFontMask = $00000200;
  NSFixedPitchFontMask = $00000400;
  NSUnitalicFontMask = $01000000;
const
  NSFontCollectionApplicationOnlyMask = 1 shl 0;
const
  NSNoFontChangeAction = 0;
  NSViaPanelFontAction = 1;
  NSAddTraitFontAction = 2;
  NSSizeUpFontAction = 3;
  NSSizeDownFontAction = 4;
  NSHeavierFontAction = 5;
  NSLighterFontAction = 6;
  NSRemoveTraitFontAction = 7;

type
  NSFontAction = NSUInteger;
  NSFontActionPtr = ^NSFontAction;
{$endif}

{$ifdef CLASSES}

type
  NSFontManager = objcclass external (NSObject)
  private
    _panel: NSFontPanel;
    _fmReserved1: cuint;
    _action: SEL;
    _actionOrigin: id;
    _target: id;
    _selFont: NSFont;
    _fmFlags: bitpacked record
      case byte of
        0: (_anonBitField__fmFlags0: cuint);
        1: (
          multipleFont: 0..1;
          disabled: 0..1;
          senderTagMode: 0..((1 shl 2)-1);
          _RESERVED: 0..((1 shl 12)-1);
        );
      end;
    _fmReserved3: cushort;
    _delegate: id;
    _collections: id;
    _hiddenCollections: id;
    _fmReserved4: NSUInteger;
  public
    class procedure setFontPanelFactory (factoryId: pobjc_class); message 'setFontPanelFactory:';
    class procedure setFontManagerFactory (factoryId: pobjc_class); message 'setFontManagerFactory:';
    class function sharedFontManager: NSFontManager; message 'sharedFontManager';
    function isMultiple: boolean; message 'isMultiple';
    function selectedFont: NSFont; message 'selectedFont';
    procedure setSelectedFont_isMultiple (fontObj: NSFont; flag: boolean); message 'setSelectedFont:isMultiple:';
    procedure setFontMenu (newMenu: NSMenu); message 'setFontMenu:';
    function fontMenu (create_: boolean): NSMenu; message 'fontMenu:';
    function fontPanel (create_: boolean): NSFontPanel; message 'fontPanel:';
    function fontWithFamily_traits_weight_size (family: NSString; traits: NSFontTraitMask; weight: NSInteger; size: CGFloat): NSFont; message 'fontWithFamily:traits:weight:size:';
    function traitsOfFont (fontObj: NSFont): NSFontTraitMask; message 'traitsOfFont:';
    function weightOfFont (fontObj: NSFont): NSInteger; message 'weightOfFont:';
    function availableFonts: NSArray; message 'availableFonts';
    function availableFontFamilies: NSArray; message 'availableFontFamilies';
    function availableMembersOfFontFamily (fam: NSString): NSArray; message 'availableMembersOfFontFamily:';
    function convertFont (fontObj: NSFont): NSFont; message 'convertFont:';
    function convertFont_toSize (fontObj: NSFont; size: CGFloat): NSFont; message 'convertFont:toSize:';
    function convertFont_toFace (fontObj: NSFont; typeface: NSString): NSFont; message 'convertFont:toFace:';
    function convertFont_toFamily (fontObj: NSFont; family: NSString): NSFont; message 'convertFont:toFamily:';
    function convertFont_toHaveTrait (fontObj: NSFont; trait: NSFontTraitMask): NSFont; message 'convertFont:toHaveTrait:';
    function convertFont_toNotHaveTrait (fontObj: NSFont; trait: NSFontTraitMask): NSFont; message 'convertFont:toNotHaveTrait:';
    function convertWeight_ofFont (upFlag: boolean; fontObj: NSFont): NSFont; message 'convertWeight:ofFont:';
    function isEnabled: boolean; message 'isEnabled';
    procedure setEnabled (flag: boolean); message 'setEnabled:';
    function action: SEL; message 'action';
    procedure setAction (aSelector: SEL); message 'setAction:';
    function sendAction: boolean; message 'sendAction';
    procedure setDelegate (anObject: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    function localizedNameForFamily_face (family: NSString; faceKey: NSString): NSString; message 'localizedNameForFamily:face:';
    procedure setSelectedAttributes_isMultiple (attributes: NSDictionary; flag: boolean); message 'setSelectedAttributes:isMultiple:';
    function convertAttributes (attributes: NSDictionary): NSDictionary; message 'convertAttributes:';
    function availableFontNamesMatchingFontDescriptor (descriptor: NSFontDescriptor): NSArray; message 'availableFontNamesMatchingFontDescriptor:';
    function collectionNames: NSArray; message 'collectionNames';
    function fontDescriptorsInCollection (collectionNames_: NSString): NSArray; message 'fontDescriptorsInCollection:';
    function addCollection_options (collectionName: NSString; collectionOptions: NSInteger): boolean; message 'addCollection:options:';
    function removeCollection (collectionName: NSString): boolean; message 'removeCollection:';
    procedure addFontDescriptors_toCollection (descriptors: NSArray; collectionName: NSString); message 'addFontDescriptors:toCollection:';
    procedure removeFontDescriptor_fromCollection (descriptor: NSFontDescriptor; collection: NSString); message 'removeFontDescriptor:fromCollection:';
    function currentFontAction: NSFontAction; message 'currentFontAction'; { available in 10_5 }
    function convertFontTraits (traits: NSFontTraitMask): NSFontTraitMask; message 'convertFontTraits:'; { available in 10_5 }
    procedure setTarget (aTarget: id); message 'setTarget:'; { available in 10_5 }
    function target: id; message 'target'; { available in 10_5 }
  end;


type
  NSFontManagerMenuActionMethods = objccategory external (NSFontManager)
    function fontNamed_hasTraits (fName: NSString; someTraits: NSFontTraitMask): boolean; message 'fontNamed:hasTraits:';
    function availableFontNamesWithTraits (someTraits: NSFontTraitMask): NSArray; message 'availableFontNamesWithTraits:';
    procedure addFontTrait (sender: id); message 'addFontTrait:';
    procedure removeFontTrait (sender: id); message 'removeFontTrait:';
    procedure modifyFontViaPanel (sender: id); message 'modifyFontViaPanel:';
    procedure modifyFont (sender: id); message 'modifyFont:';
    procedure orderFrontFontPanel (sender: id); message 'orderFrontFontPanel:';
    procedure orderFrontStylesPanel (sender: id); message 'orderFrontStylesPanel:';
  end;

type
  NSFontManagerDelegate = objccategory external (NSObject)
    function fontManager_willIncludeFont (sender: id; fontName: NSString): boolean; message 'fontManager:willIncludeFont:';
  end;

type
  NSFontManagerResponderMethod = objccategory external (NSObject)
    procedure changeFont (sender: id); message 'changeFont:';
  end;
{$endif}

