{ Parsed from AppKit.framework (MacOSX10.8) NSGraphics.h }
{ Created on Mon Sep 10 11:47:55 2012 }

{$ifdef TYPES}
const
  NSCompositeClear = 0;
  NSCompositeCopy = 1;
  NSCompositeSourceOver = 2;
  NSCompositeSourceIn = 3;
  NSCompositeSourceOut = 4;
  NSCompositeSourceAtop = 5;
  NSCompositeDestinationOver = 6;
  NSCompositeDestinationIn = 7;
  NSCompositeDestinationOut = 8;
  NSCompositeDestinationAtop = 9;
  NSCompositeXOR = 10;
  NSCompositePlusDarker = 11;
  NSCompositeHighlight = 12;
  NSCompositePlusLighter = 13;

type
  NSCompositingOperation = NSUInteger;
  NSCompositingOperationPtr = ^NSCompositingOperation;

const
  NSBackingStoreRetained = 0;
  NSBackingStoreNonretained = 1;
  NSBackingStoreBuffered = 2;

type
  NSBackingStoreType = NSUInteger;
  NSBackingStoreTypePtr = ^NSBackingStoreType;

const
  NSWindowAbove = 1;
  NSWindowBelow = -1;
  NSWindowOut = 0;

type
  NSWindowOrderingMode = NSInteger;
  NSWindowOrderingModePtr = ^NSWindowOrderingMode;

const
  NSFocusRingOnly = 0;
  NSFocusRingBelow = 1;
  NSFocusRingAbove = 2;

type
  NSFocusRingPlacement = NSUInteger;
  NSFocusRingPlacementPtr = ^NSFocusRingPlacement;

const
  NSFocusRingTypeDefault = 0;
  NSFocusRingTypeNone = 1;
  NSFocusRingTypeExterior = 2;

type
  NSFocusRingType = NSUInteger;
  NSFocusRingTypePtr = ^NSFocusRingType;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef TYPES}
const
  NSColorRenderingIntentDefault = 0;
  NSColorRenderingIntentAbsoluteColorimetric = 1;
  NSColorRenderingIntentRelativeColorimetric = 2;
  NSColorRenderingIntentPerceptual = 3;
  NSColorRenderingIntentSaturation = 4;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSColorRenderingIntent = NSInteger;
  NSColorRenderingIntentPtr = ^NSColorRenderingIntent;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSCalibratedWhiteColorSpace: NSString; cvar; external;
  NSCalibratedRGBColorSpace: NSString; cvar; external;
  NSDeviceWhiteColorSpace: NSString; cvar; external;
  NSDeviceRGBColorSpace: NSString; cvar; external;
  NSDeviceCMYKColorSpace: NSString; cvar; external;
  NSNamedColorSpace: NSString; cvar; external;
  NSPatternColorSpace: NSString; cvar; external;
  NSCustomColorSpace: NSString; cvar; external;
  NSCalibratedBlackColorSpace: NSString deprecated 'in 10_0, 10_6'; cvar; external;
  NSDeviceBlackColorSpace: NSString deprecated 'in 10_0, 10_6'; cvar; external;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
{$ifdef TYPES}
const
  NSWindowDepthTwentyfourBitRGB = $208;
  NSWindowDepthSixtyfourBitRGB = $210;
  NSWindowDepthOnehundredtwentyeightBitRGB = $220;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSWindowDepth = cint;
  NSWindowDepthPtr = ^NSWindowDepth;
{$endif}

{$ifdef FUNCTIONS}
function NSBestDepth(colorSpace: NSString; bps: NSInteger; bpp: NSInteger; planar: boolean; exactMatch: pboolean): NSWindowDepth; cdecl; external;
function NSPlanarFromDepth(depth: NSWindowDepth): boolean; cdecl; external;
function NSColorSpaceFromDepth(depth: NSWindowDepth): NSString; cdecl; external;
function NSBitsPerSampleFromDepth(depth: NSWindowDepth): NSInteger; cdecl; external;
function NSBitsPerPixelFromDepth(depth: NSWindowDepth): NSInteger; cdecl; external;
function NSNumberOfColorComponents(colorSpaceName: NSString): NSInteger; cdecl; external;
function NSAvailableWindowDepths: NSWindowDepthPtr; cdecl; external;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSWhite: CGFloat; cvar; external;
  NSLightGray: CGFloat; cvar; external;
  NSDarkGray: CGFloat; cvar; external;
  NSBlack: CGFloat; cvar; external;
  NSDeviceResolution: NSString; cvar; external;
  NSDeviceColorSpaceName: NSString; cvar; external;
  NSDeviceBitsPerSample: NSString; cvar; external;
  NSDeviceIsScreen: NSString; cvar; external;
  NSDeviceIsPrinter: NSString; cvar; external;
  NSDeviceSize: NSString; cvar; external;
{$endif}

{$ifdef FUNCTIONS}
procedure NSRectFill(aRect: NSRect); cdecl; external;
procedure NSRectFillList(rects: NSRectPtr; count: NSInteger); cdecl; external;
procedure NSRectFillListWithGrays(rects: NSRectPtr; grays: CGFloatPtr; num: NSInteger); cdecl; external;
procedure NSRectFillListWithColors(rects: NSRectPtr; colors: NSColor; num: NSInteger); cdecl; external;
procedure NSRectFillUsingOperation(aRect: NSRect; op: NSCompositingOperation); cdecl; external;
procedure NSRectFillListUsingOperation(rects: NSRectPtr; count: NSInteger; op: NSCompositingOperation); cdecl; external;
procedure NSRectFillListWithColorsUsingOperation(rects: NSRectPtr; colors: NSColor; num: NSInteger; op: NSCompositingOperation); cdecl; external;
procedure NSFrameRect(aRect: NSRect); cdecl; external;
procedure NSFrameRectWithWidth(aRect: NSRect; frameWidth: CGFloat); cdecl; external;
procedure NSFrameRectWithWidthUsingOperation(aRect: NSRect; frameWidth: CGFloat; op: NSCompositingOperation); cdecl; external;
procedure NSRectClip(aRect: NSRect); cdecl; external;
procedure NSRectClipList(rects: NSRectPtr; count: NSInteger); cdecl; external;
function NSDrawTiledRects(boundsRect: NSRect; clipRect: NSRect; sides: NSRectEdgePtr; grays: CGFloatPtr; count: NSInteger): NSRect; cdecl; external;
procedure NSDrawGrayBezel(aRect: NSRect; clipRect: NSRect); cdecl; external;
procedure NSDrawGroove(aRect: NSRect; clipRect: NSRect); cdecl; external;
procedure NSDrawWhiteBezel(aRect: NSRect; clipRect: NSRect); cdecl; external;
procedure NSDrawButton(aRect: NSRect; clipRect: NSRect); cdecl; external;
procedure NSEraseRect(aRect: NSRect); cdecl; external;
function NSReadPixel(passedPoint: NSPoint): NSColor; cdecl; external;
procedure NSDrawBitmap(rect: NSRect; width: NSInteger; height: NSInteger; bps: NSInteger; spp: NSInteger; bpp: NSInteger; bpr: NSInteger; isPlanar: boolean; hasAlpha: boolean; colorSpaceName: NSString; data: PChar { 5 element array of PChar }); cdecl; external;
procedure NSCopyBits(srcGState: NSInteger; srcRect: NSRect; destPoint: NSPoint); cdecl; external;
procedure NSHighlightRect(aRect: NSRect); cdecl; external;
procedure NSBeep; cdecl; external;
function NSGetWindowServerMemory(context: NSInteger; virtualMemory: NSIntegerPtr; windowBackingMemory: NSIntegerPtr; windowDumpString: NSStringPtr): NSInteger; cdecl; external;
function NSDrawColorTiledRects(boundsRect: NSRect; clipRect: NSRect; sides: NSRectEdgePtr; colors: NSColorPtr; count: NSInteger): NSRect; cdecl; external;
procedure NSDrawDarkBezel(aRect: NSRect; clipRect: NSRect); cdecl; external;
procedure NSDrawLightBezel(aRect: NSRect; clipRect: NSRect); cdecl; external;
procedure NSDottedFrameRect(aRect: NSRect); cdecl; external;
procedure NSDrawWindowBackground(aRect: NSRect); cdecl; external;
procedure NSSetFocusRingStyle(placement: NSFocusRingPlacement); cdecl; external;
procedure NSDisableScreenUpdates; cdecl; external;
procedure NSEnableScreenUpdates; cdecl; external;
{$endif}

{$ifdef TYPES}
const
  NSAnimationEffectDisappearingItemDefault = 0;
  NSAnimationEffectPoof = 10;

type
  NSAnimationEffect = NSUInteger;
  NSAnimationEffectPtr = ^NSAnimationEffect;
{$endif}

{$ifdef FUNCTIONS}
procedure NSShowAnimationEffect(animationEffect: NSAnimationEffect; centerLocation: NSPoint; size: NSSize; animationDelegate: id; didEndSelector: SEL; contextInfo: pointer); cdecl; external;
procedure NSCountWindows(count: NSIntegerPtr); cdecl; external;
procedure NSWindowList(size: NSInteger; list: NSIntegerPtr { variable size array of NSInteger }); cdecl; external;
procedure NSCountWindowsForContext(context: NSInteger; count: NSIntegerPtr); cdecl; external;
procedure NSWindowListForContext(context: NSInteger; size: NSInteger; list: NSIntegerPtr { variable size array of NSInteger }); cdecl; external;
{$endif}

