{ Parsed from AppKit.framework (MacOSX10.8) NSGraphicsContext.h }
{ Created on Mon Sep 10 11:47:55 2012 }


{$ifdef TYPES}
type
  NSGraphicsContextPtr = ^NSGraphicsContext;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSGraphicsContextDestinationAttributeName: NSString; cvar; external;
  NSGraphicsContextRepresentationFormatAttributeName: NSString; cvar; external;
  NSGraphicsContextPSFormat: NSString; cvar; external;
  NSGraphicsContextPDFFormat: NSString; cvar; external;
{$endif}

{$ifdef TYPES}
const
  NSImageInterpolationDefault = 0;
  NSImageInterpolationNone = 1;
  NSImageInterpolationLow = 2;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
  NSImageInterpolationMedium = 4;
  {$endif}
  NSImageInterpolationHigh = 3;

type
  NSImageInterpolation = NSUInteger;
  NSImageInterpolationPtr = ^NSImageInterpolation;
{$endif}

{$ifdef CLASSES}

type
  NSGraphicsContext = objcclass external (NSObject)
  private
  public
    class function graphicsContextWithAttributes (attributes: NSDictionary): NSGraphicsContext; message 'graphicsContextWithAttributes:';
    class function graphicsContextWithWindow (window: NSWindow): NSGraphicsContext; message 'graphicsContextWithWindow:';
    class function graphicsContextWithBitmapImageRep (bitmapRep: NSBitmapImageRep): NSGraphicsContext; message 'graphicsContextWithBitmapImageRep:';
    class function graphicsContextWithGraphicsPort_flipped (graphicsPort: pointer; initialFlippedState: boolean): NSGraphicsContext; message 'graphicsContextWithGraphicsPort:flipped:';
    class function currentContext: NSGraphicsContext; message 'currentContext';
    class procedure setCurrentContext (context: NSGraphicsContext); message 'setCurrentContext:';
    class function currentContextDrawingToScreen: boolean; message 'currentContextDrawingToScreen';
    class procedure classSaveGraphicsState; message 'saveGraphicsState';
    class procedure classRestoreGraphicsState; message 'restoreGraphicsState';
    class procedure setGraphicsState (gState: NSInteger); message 'setGraphicsState:';
    function attributes: NSDictionary; message 'attributes';
    function isDrawingToScreen: boolean; message 'isDrawingToScreen';
    procedure saveGraphicsState; message 'saveGraphicsState';
    procedure restoreGraphicsState; message 'restoreGraphicsState';
    procedure flushGraphics; message 'flushGraphics';
    function graphicsPort: pointer; message 'graphicsPort';
    function isFlipped: boolean; message 'isFlipped';
  end;


type
  NSGraphicsContext_RenderingOptions = objccategory external (NSGraphicsContext)
    procedure setShouldAntialias (antialias: boolean); message 'setShouldAntialias:';
    function shouldAntialias: boolean; message 'shouldAntialias';
    procedure setImageInterpolation (interpolation: NSImageInterpolation); message 'setImageInterpolation:';
    function imageInterpolation: NSImageInterpolation; message 'imageInterpolation';
    procedure setPatternPhase (phase: NSPoint); message 'setPatternPhase:';
    function patternPhase: NSPoint; message 'patternPhase';
    procedure setCompositingOperation (operation: NSCompositingOperation); message 'setCompositingOperation:';
    function compositingOperation: NSCompositingOperation; message 'compositingOperation';
    function colorRenderingIntent: NSColorRenderingIntent; message 'colorRenderingIntent'; { available in 10_5 }
    procedure setColorRenderingIntent (renderingIntent: NSColorRenderingIntent); message 'setColorRenderingIntent:'; { available in 10_5 }
  end;

type
  NSGraphicsContext_NSQuartzCoreAdditions = objccategory external name 'NSQuartzCoreAdditions' (NSGraphicsContext)
    function CIContext_: CIContext; message 'CIContext';
  end;
{$endif}

{$if (MAC_OS_X_VERSION_MIN_REQUIRED < MAC_OS_X_VERSION_10_6)}
{$ifdef CLASSES}

type
  NSGraphicsContextDeprecated = objccategory external (NSGraphicsContext)
    function focusStack: id; message 'focusStack';
    procedure setFocusStack (stack: id); message 'setFocusStack:';
  end;
{$endif}

{$endif}
