{ Parsed from AppKit.framework (MacOSX10.8) NSInputManager.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSInputManagerPtr = ^NSInputManager;
  NSTextInputProtocolPtr = ^NSTextInputProtocol;
{$endif}

{$ifdef PROTOCOLS}

type
  NSTextInputProtocol = objcprotocol external name 'NSTextInput'
    procedure insertText (aString: id); message 'insertText:';
    procedure doCommandBySelector (aSelector: SEL); message 'doCommandBySelector:';
    procedure setMarkedText_selectedRange (aString: id; selRange: NSRange); message 'setMarkedText:selectedRange:';
    procedure unmarkText; message 'unmarkText';
    function hasMarkedText: boolean; message 'hasMarkedText';
    function conversationIdentifier: NSInteger; message 'conversationIdentifier';
    function attributedSubstringFromRange (theRange: NSRange): NSAttributedString; message 'attributedSubstringFromRange:';
    function markedRange: NSRange; message 'markedRange';
    function selectedRange: NSRange; message 'selectedRange';
    function firstRectForCharacterRange (theRange: NSRange): NSRect; message 'firstRectForCharacterRange:';
    function characterIndexForPoint (thePoint: NSPoint): NSUInteger; message 'characterIndexForPoint:';
    function validAttributesForMarkedText: NSArray; message 'validAttributesForMarkedText';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSInputManager = objcclass external (NSObject, NSTextInputProtocol)
  private
    _currentClient: id;
    _server: id;
    _bundleObj: id;
    _keybindings: id;
    _trueName: NSString;
    _connectionName: NSString;
    _hostName: NSString;
    _procToExec: NSString;
    _visibleName: NSString;
    _bundleName: NSString;
    _language: NSString;
    _image: NSImage;
    _flags: cuint;
    _keyBindingsName: NSString;
    _reservedInputManager2: cint;
  public
    class function currentInputManager: NSInputManager; message 'currentInputManager';
    class procedure cycleToNextInputLanguage (sender: id); message 'cycleToNextInputLanguage:';
    class procedure cycleToNextInputServerInLanguage (sender: id); message 'cycleToNextInputServerInLanguage:';
    function initWithName_host (inputServerName: NSString; hostName: NSString): NSInputManager; message 'initWithName:host:'; deprecated 'in 10_0, 10_6';
    function localizedInputManagerName: NSString; message 'localizedInputManagerName'; deprecated 'in 10_0, 10_6';
    procedure markedTextAbandoned (cli: id); message 'markedTextAbandoned:';
    procedure markedTextSelectionChanged_client (newSel: NSRange; cli: id); message 'markedTextSelectionChanged:client:';
    function wantsToInterpretAllKeystrokes: boolean; message 'wantsToInterpretAllKeystrokes'; deprecated 'in 10_0, 10_6';
    function language: NSString; message 'language'; deprecated 'in 10_0, 10_6';
    function image: NSImage; message 'image'; deprecated 'in 10_0, 10_6';
    function server: NSInputServer; message 'server'; deprecated 'in 10_0, 10_6';
    function wantsToHandleMouseEvents: boolean; message 'wantsToHandleMouseEvents';
    function handleMouseEvent (theMouseEvent: NSEvent): boolean; message 'handleMouseEvent:';
    function wantsToDelayTextChangeNotifications: boolean; message 'wantsToDelayTextChangeNotifications'; deprecated 'in 10_0, 10_6';

    { Adopted protocols }
    function attributedSubstringFromRange (theRange: NSRange): NSAttributedString; message 'attributedSubstringFromRange:';
    function characterIndexForPoint (thePoint: NSPoint): NSUInteger; message 'characterIndexForPoint:';
    function conversationIdentifier: NSInteger; message 'conversationIdentifier';
    procedure doCommandBySelector (aSelector: SEL); message 'doCommandBySelector:';
    function firstRectForCharacterRange (theRange: NSRange): NSRect; message 'firstRectForCharacterRange:';
    function hasMarkedText: boolean; message 'hasMarkedText';
    procedure insertText (aString: id); message 'insertText:';
    function markedRange: NSRange; message 'markedRange';
    function selectedRange: NSRange; message 'selectedRange';
    procedure setMarkedText_selectedRange (aString: id; selRange: NSRange); message 'setMarkedText:selectedRange:';
    procedure unmarkText; message 'unmarkText';
    function validAttributesForMarkedText: NSArray; message 'validAttributesForMarkedText';
  end;
{$endif}

