{ Parsed from AppKit.framework (MacOSX10.8) NSMenuItem.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSMenuItemPtr = ^NSMenuItem;
{$endif}

{$ifdef CLASSES}

type
  NSMenuItem = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol, NSValidatedUserInterfaceItemProtocol)
  private
    _menu: NSMenu;
    _title: NSString;
    _keyEquivalent: NSString;
    {$if defined(__LP64__)}
    _uiid: NSString;
    _repObject: id;
    _submenu: NSMenu;
    _extraData: id;
    _target: id;
    _action: SEL;
    _tag: NSInteger;
    _keyEquivalentModifierMask: char;
    {$else}
    _keyEquivalentModifierMask_: NSUInteger;
    _userKEGenerationCount: NSInteger;
    _state: NSInteger;
    _image: NSImage;
    _submenu_: NSMenu;
    _uiid_: NSString;
    _repObject_: id;
    _target_: id;
    _action_: SEL;
    _tag_: NSInteger;
    _extraData_: id;
    {$endif}
    __miFlags: bitpacked record
      case byte of
        0: (_anonBitField___miFlags0: cuint);
        1: (
          keGenerationCount: 0..((1 shl 8)-1);
          disabled: 0..1;
          isSeparator: 0..1;
          hidden: 0..1;
          alternate: 0..1;
          moreAlternate: 0..1;
          singleAlternate: 0..1;
          indent: 0..((1 shl 4)-1);
          keShareMode: 0..((1 shl 3)-1);
          state_: 0..((1 shl 2)-1);
          RESERVED1: 0..((1 shl 2)-1);
          limitedView: 0..1;
          nextItemIsAlternate: 0..1;
          blockKE: 0..1;
          ignoredForAccessibility: 0..1;
          hiddenActiveKE: 0..1;
          noRepeatKEs: 0..1;
          RESERVED2: 0..1;
        );
      end;
  public
    class procedure setUsesUserKeyEquivalents (flag: boolean); message 'setUsesUserKeyEquivalents:';
    class function usesUserKeyEquivalents: boolean; message 'usesUserKeyEquivalents';
    class function separatorItem: NSMenuItem; message 'separatorItem';
    function initWithTitle_action_keyEquivalent (aString: NSString; aSelector: SEL; charCode: NSString): id; message 'initWithTitle:action:keyEquivalent:';
    procedure setMenu (menu: NSMenu); message 'setMenu:';
    function menu: NSMenu; message 'menu';
    function hasSubmenu: boolean; message 'hasSubmenu';
    procedure setSubmenu (submenu: NSMenu); message 'setSubmenu:';
    function submenu: NSMenu; message 'submenu';
    function parentItem: NSMenuItem; message 'parentItem'; { available in 10_6 }
    procedure setTitle (aString: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure setAttributedTitle (string_: NSAttributedString); message 'setAttributedTitle:';
    function attributedTitle: NSAttributedString; message 'attributedTitle';
    function isSeparatorItem: boolean; message 'isSeparatorItem';
    procedure setKeyEquivalent (aKeyEquivalent: NSString); message 'setKeyEquivalent:';
    function keyEquivalent: NSString; message 'keyEquivalent';
    procedure setKeyEquivalentModifierMask (mask: NSUInteger); message 'setKeyEquivalentModifierMask:';
    function keyEquivalentModifierMask: NSUInteger; message 'keyEquivalentModifierMask';
    function userKeyEquivalent: NSString; message 'userKeyEquivalent';
    procedure setTitleWithMnemonic (stringWithAmpersand: NSString); message 'setTitleWithMnemonic:';
    procedure setImage (menuImage: NSImage); message 'setImage:';
    function image: NSImage; message 'image';
    procedure setState (state: NSInteger); message 'setState:';
    function state: NSInteger; message 'state';
    procedure setOnStateImage (image_: NSImage); message 'setOnStateImage:';
    function onStateImage: NSImage; message 'onStateImage';
    procedure setOffStateImage (image_: NSImage); message 'setOffStateImage:';
    function offStateImage: NSImage; message 'offStateImage';
    procedure setMixedStateImage (image_: NSImage); message 'setMixedStateImage:';
    function mixedStateImage: NSImage; message 'mixedStateImage';
    procedure setEnabled (flag: boolean); message 'setEnabled:';
    function isEnabled: boolean; message 'isEnabled';
    procedure setAlternate (isAlternate: boolean); message 'setAlternate:';
    function isAlternate: boolean; message 'isAlternate';
    procedure setIndentationLevel (indentationLevel: NSInteger); message 'setIndentationLevel:';
    function indentationLevel: NSInteger; message 'indentationLevel';
    procedure setTarget (anObject: id); message 'setTarget:';
    function target: id; message 'target';
    procedure setAction (aSelector: SEL); message 'setAction:';
    function action: SEL; message 'action';
    procedure setTag (anInt: NSInteger); message 'setTag:';
    function tag: NSInteger; message 'tag';
    procedure setRepresentedObject (anObject: id); message 'setRepresentedObject:';
    function representedObject: id; message 'representedObject';
    procedure setView (view: NSView); message 'setView:'; { available in 10_5 }
    function view: NSView; message 'view'; { available in 10_5 }
    function isHighlighted: boolean; message 'isHighlighted'; { available in 10_5 }
    procedure setHidden (hidden: boolean); message 'setHidden:'; { available in 10_5 }
    function isHidden: boolean; message 'isHidden'; { available in 10_5 }
    function isHiddenOrHasHiddenAncestor: boolean; message 'isHiddenOrHasHiddenAncestor'; { available in 10_5 }
    procedure setToolTip (toolTip: NSString); message 'setToolTip:';
    function toolTip: NSString; message 'toolTip';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  NSViewEnclosingMenuItem = objccategory external (NSView)
    function enclosingMenuItem: NSMenuItem; message 'enclosingMenuItem'; { available in 10_5 }
  end;
{$endif}

{$ifdef CLASSES}

type
  NSMenuItem_NSDeprecated = objccategory external name 'NSDeprecated' (NSMenuItem)
    procedure setMnemonicLocation (location: NSUInteger); message 'setMnemonicLocation:'; deprecated 'in 10_0, 10_6';
    function mnemonicLocation: NSUInteger; message 'mnemonicLocation'; deprecated 'in 10_0, 10_6';
    function mnemonic: NSString; message 'mnemonic'; deprecated 'in 10_0, 10_6';
  end;
{$endif}

