{ Parsed from AppKit.framework (MacOSX10.8) NSObjectController.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSObjectControllerPtr = ^NSObjectController;
{$endif}

{$ifdef CLASSES}

type
  NSObjectController = objcclass external (NSController)
  private
    _reserved3: pointer;
    _managedProxy: id;
    __objectControllerFlags: bitpacked record
      case byte of
        0: (_anonBitField___objectControllerFlags0: cuint);
        1: (
          _editable: 0..1;
          _automaticallyPreparesContent: 0..1;
          _hasLoadedData: 0..1;
          _explicitlyCannotAdd: 0..1;
          _explicitlyCannotRemove: 0..1;
          _isUsingManagedProxy: 0..1;
          _hasFetched: 0..1;
          _batches: 0..1;
          _reservedObjectController: 0..((1 shl 24)-1);
        );
      end;
    _objectClassName: NSString;
    _objectClass: pobjc_class;
    _contentObjectArray: NSArray;
    _content: id;
    _objectHandler: id;
  public
    function initWithContent (content: id): id; message 'initWithContent:';
    procedure setContent (content: id); message 'setContent:';
    function content: id; message 'content';
    function selection: id; message 'selection';
    function selectedObjects: NSArray; message 'selectedObjects';
    procedure setAutomaticallyPreparesContent (flag: boolean); message 'setAutomaticallyPreparesContent:';
    function automaticallyPreparesContent: boolean; message 'automaticallyPreparesContent';
    procedure prepareContent; message 'prepareContent';
    procedure setObjectClass (objectClass: pobjc_class); message 'setObjectClass:';
    function objectClass: pobjc_class; message 'objectClass';
    function newObject: id; message 'newObject';
    procedure addObject (object_: id); message 'addObject:';
    procedure removeObject (object_: id); message 'removeObject:';
    procedure setEditable (flag: boolean); message 'setEditable:';
    function isEditable: boolean; message 'isEditable';
    procedure add (sender: id); message 'add:';
    function canAdd: boolean; message 'canAdd';
    procedure remove (sender: id); message 'remove:';
    function canRemove: boolean; message 'canRemove';
    function validateUserInterfaceItem (item: NSValidatedUserInterfaceItemProtocol): boolean; message 'validateUserInterfaceItem:';
  end;


type
  NSManagedController = objccategory external (NSObjectController)
    function managedObjectContext: NSManagedObjectContext; message 'managedObjectContext';
    procedure setManagedObjectContext (managedObjectContext_: NSManagedObjectContext); message 'setManagedObjectContext:';
    function entityName: NSString; message 'entityName';
    procedure setEntityName (entityName_: NSString); message 'setEntityName:';
    function fetchPredicate: NSPredicate; message 'fetchPredicate';
    procedure setFetchPredicate (predicate: NSPredicate); message 'setFetchPredicate:';
    function fetchWithRequest_merge_error (fetchRequest: NSFetchRequest; merge: boolean; error: NSErrorPtr): boolean; message 'fetchWithRequest:merge:error:';
    procedure fetch (sender: id); message 'fetch:';
    procedure setUsesLazyFetching (enabled: boolean); message 'setUsesLazyFetching:'; { available in 10_5 }
    function usesLazyFetching: boolean; message 'usesLazyFetching'; { available in 10_5 }
    function defaultFetchRequest: NSFetchRequest; message 'defaultFetchRequest'; { available in 10_5 }
  end;
{$endif}

