{ Parsed from AppKit.framework (MacOSX10.8) NSOpenGL.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSOpenGLPixelFormatPtr = ^NSOpenGLPixelFormat;
  NSOpenGLPixelBufferPtr = ^NSOpenGLPixelBuffer;
  NSOpenGLContextPtr = ^NSOpenGLContext;
{$endif}

{$ifdef TYPES}
const
  NSOPENGL_CURRENT_VERSION = 1;

const
  NSOpenGLGOFormatCacheSize = 501;
  NSOpenGLGOClearFormatCache = 502;
  NSOpenGLGORetainRenderers = 503;
  NSOpenGLGOUseBuildCache = 506;
  NSOpenGLGOResetLibrary = 504;
type
  NSOpenGLGlobalOption = clong;
{$endif}

{$ifdef FUNCTIONS}
procedure NSOpenGLSetOption(pname: NSOpenGLGlobalOption; param: GLint); cdecl; external;
procedure NSOpenGLGetOption(pname: NSOpenGLGlobalOption; param: GLintPtr); cdecl; external;
procedure NSOpenGLGetVersion(major: GLintPtr; minor: GLintPtr); cdecl; external;
{$endif}

{$ifdef TYPES}
const
  NSOpenGLPFAAllRenderers = 1;
  NSOpenGLPFATripleBuffer = 3;
  NSOpenGLPFADoubleBuffer = 5;
  NSOpenGLPFAStereo = 6;
  NSOpenGLPFAAuxBuffers = 7;
  NSOpenGLPFAColorSize = 8;
  NSOpenGLPFAAlphaSize = 11;
  NSOpenGLPFADepthSize = 12;
  NSOpenGLPFAStencilSize = 13;
  NSOpenGLPFAAccumSize = 14;
  NSOpenGLPFAMinimumPolicy = 51;
  NSOpenGLPFAMaximumPolicy = 52;
  NSOpenGLPFAOffScreen = 53;
  NSOpenGLPFAFullScreen = 54;
  NSOpenGLPFASampleBuffers = 55;
  NSOpenGLPFASamples = 56;
  NSOpenGLPFAAuxDepthStencil = 57;
  NSOpenGLPFAColorFloat = 58;
  NSOpenGLPFAMultisample = 59;
  NSOpenGLPFASupersample = 60;
  NSOpenGLPFASampleAlpha = 61;
  NSOpenGLPFARendererID = 70;
  NSOpenGLPFASingleRenderer = 71;
  NSOpenGLPFANoRecovery = 72;
  NSOpenGLPFAAccelerated = 73;
  NSOpenGLPFAClosestPolicy = 74;
  NSOpenGLPFABackingStore = 76;
  NSOpenGLPFAWindow = 80;
  NSOpenGLPFACompliant = 83;
  NSOpenGLPFAScreenMask = 84;
  NSOpenGLPFAPixelBuffer = 90;
  NSOpenGLPFARemotePixelBuffer = 91;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
  NSOpenGLPFAAllowOfflineRenderers = 96;
  {$endif}
  NSOpenGLPFAAcceleratedCompute = 97;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
  NSOpenGLPFAOpenGLProfile = 99;
  {$endif}
  NSOpenGLPFAVirtualScreenCount = 128;
  NSOpenGLPFARobust = 75;
  NSOpenGLPFAMPSafe = 78;
  NSOpenGLPFAMultiScreen = 81;

type
  NSOpenGLPixelFormatAttribute = cuint32;
  NSOpenGLPixelFormatAttributePtr = ^NSOpenGLPixelFormatAttribute;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
{$ifdef TYPES}
const
  NSOpenGLProfileVersionLegacy = $1000;
  NSOpenGLProfileVersion3_2Core = $3200;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSOpenGLPixelFormatAuxiliary = OpaqueType;
  NSOpenGLPixelFormatAuxiliaryPtr = ^NSOpenGLPixelFormatAuxiliary;
{$endif}

{$ifdef CLASSES}

type
  NSOpenGLPixelFormat = objcclass external (NSObject, NSCodingProtocol)
  private
    _pixelFormatAuxiliary: NSOpenGLPixelFormatAuxiliaryPtr;
    _pixelAttributes: NSData;
    _reserved1: NSInteger;
    _reserved2: NSInteger;
    _reserved3: NSInteger;
  public
    function initWithAttributes (attribs: NSOpenGLPixelFormatAttributePtr): id; message 'initWithAttributes:';
    function initWithData (attribs: NSData): id; message 'initWithData:';
    function initWithCGLPixelFormatObj (format: pointer): id; message 'initWithCGLPixelFormatObj:'; { available in 10_6 }
    function attributes: NSData; message 'attributes';
    procedure setAttributes (attribs: NSData); message 'setAttributes:';
    procedure getValues_forAttribute_forVirtualScreen (vals: GLintPtr; attrib: NSOpenGLPixelFormatAttribute; screen: GLint); message 'getValues:forAttribute:forVirtualScreen:';
    function numberOfVirtualScreens: GLint; message 'numberOfVirtualScreens';
    function CGLPixelFormatObj: pointer; message 'CGLPixelFormatObj';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;

type
  NSOpenGLPixelBuffer = objcclass external (NSObject)
  private
    _pixelBufferAuxiliary: _CGLPBufferObjectPtr;
    _reserved1: pointer;
    _reserved2: pointer;
  public
    function initWithTextureTarget_textureInternalFormat_textureMaxMipMapLevel_pixelsWide_pixelsHigh (target: GLenum; format: GLenum; maxLevel: GLint; pixelsWide: GLsizei; pixelsHigh: GLsizei): id; message 'initWithTextureTarget:textureInternalFormat:textureMaxMipMapLevel:pixelsWide:pixelsHigh:';
    function initWithCGLPBufferObj (pbuffer: pointer): id; message 'initWithCGLPBufferObj:'; { available in 10_6 }
    function CGLPBufferObj: pointer; message 'CGLPBufferObj'; { available in 10_6 }
    function pixelsWide: GLsizei; message 'pixelsWide';
    function pixelsHigh: GLsizei; message 'pixelsHigh';
    function textureTarget: GLenum; message 'textureTarget';
    function textureInternalFormat: GLenum; message 'textureInternalFormat';
    function textureMaxMipMapLevel: GLint; message 'textureMaxMipMapLevel';
  end;
{$endif}

{$ifdef TYPES}
const
  NSOpenGLCPSwapInterval = 222;
  NSOpenGLCPSurfaceOrder = 235;
  NSOpenGLCPSurfaceOpacity = 236;
  NSOpenGLCPSurfaceBackingSize = 304;
  NSOpenGLCPReclaimResources = 308;
  NSOpenGLCPCurrentRendererID = 309;
  NSOpenGLCPGPUVertexProcessing = 310;
  NSOpenGLCPGPUFragmentProcessing = 311;
  NSOpenGLCPHasDrawable = 314;
  NSOpenGLCPMPSwapsInFlight = 315;
  NSOpenGLCPSwapRectangle = 200;
  NSOpenGLCPSwapRectangleEnable = 201;
  NSOpenGLCPRasterizationEnable = 221;
  NSOpenGLCPStateValidation = 301;
  NSOpenGLCPSurfaceSurfaceVolatile = 306;
type
  NSOpenGLContextParameter = clong;

type
  NSOpenGLContextAuxiliary = OpaqueType;
  NSOpenGLContextAuxiliaryPtr = ^NSOpenGLContextAuxiliary;
{$endif}

{$ifdef CLASSES}

type
  NSOpenGLContext = objcclass external (NSObject)
  private
    _view: NSView;
    _contextAuxiliary: NSOpenGLContextAuxiliaryPtr;
  public
    function initWithFormat_shareContext (format: NSOpenGLPixelFormat; share: NSOpenGLContext): id; message 'initWithFormat:shareContext:';
    function initWithCGLContextObj (context: pointer): id; message 'initWithCGLContextObj:'; { available in 10_6 }
    procedure setView (view: NSView); message 'setView:';
    function view: NSView; message 'view';
    procedure setFullScreen; message 'setFullScreen';
    procedure setOffScreen_width_height_rowbytes (baseaddr: pointer; width: GLsizei; height: GLsizei; rowbytes: GLint); message 'setOffScreen:width:height:rowbytes:';
    procedure clearDrawable; message 'clearDrawable';
    procedure update; message 'update';
    procedure flushBuffer; message 'flushBuffer';
    procedure makeCurrentContext; message 'makeCurrentContext';
    class procedure clearCurrentContext; message 'clearCurrentContext';
    class function currentContext: NSOpenGLContext; message 'currentContext';
    procedure copyAttributesFromContext_withMask (context: NSOpenGLContext; mask: GLbitfield); message 'copyAttributesFromContext:withMask:';
    procedure setValues_forParameter (vals: GLintPtr; param: NSOpenGLContextParameter); message 'setValues:forParameter:';
    procedure getValues_forParameter (vals: GLintPtr; param: NSOpenGLContextParameter); message 'getValues:forParameter:';
    procedure setCurrentVirtualScreen (screen: GLint); message 'setCurrentVirtualScreen:';
    function currentVirtualScreen: GLint; message 'currentVirtualScreen';
    procedure createTexture_fromView_internalFormat (target: GLenum; view_: NSView; format: GLenum); message 'createTexture:fromView:internalFormat:';
    function CGLContextObj: pointer; message 'CGLContextObj';
    procedure setPixelBuffer_cubeMapFace_mipMapLevel_currentVirtualScreen (pixelBuffer: NSOpenGLPixelBuffer; face: GLenum; level: GLint; screen: GLint); message 'setPixelBuffer:cubeMapFace:mipMapLevel:currentVirtualScreen:';
    function pixelBuffer: NSOpenGLPixelBuffer; message 'pixelBuffer';
    function pixelBufferCubeMapFace: GLenum; message 'pixelBufferCubeMapFace';
    function pixelBufferMipMapLevel: GLint; message 'pixelBufferMipMapLevel';
    procedure setTextureImageToPixelBuffer_colorBuffer (pixelBuffer_: NSOpenGLPixelBuffer; source: GLenum); message 'setTextureImageToPixelBuffer:colorBuffer:';
  end;
{$endif}

