{ Parsed from AppKit.framework (MacOSX10.8) NSPasteboardItem.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSPasteboardItemPtr = ^NSPasteboardItem;
  NSPasteboardItemDataProviderProtocolPtr = ^NSPasteboardItemDataProviderProtocol;
{$endif}

{$ifdef CLASSES}

type
  NSPasteboardItem = objcclass external (NSObject, NSPasteboardWritingProtocol, NSPasteboardReadingProtocol)
  private
    _pasteboard: NSPasteboard;
    _index: NSUInteger;
    _gen: NSInteger;
    _auxObject: id;
    _reserved: pointer;
  public
    function types: NSArray; message 'types';
    function availableTypeFromArray (types_: NSArray): NSString; message 'availableTypeFromArray:';
    function setDataProvider_forTypes (dataProvider: NSPasteboardItemDataProviderProtocol; types_: NSArray): boolean; message 'setDataProvider:forTypes:';
    function setData_forType (data: NSData; type_: NSString): boolean; message 'setData:forType:';
    function setString_forType (string_: NSString; type_: NSString): boolean; message 'setString:forType:';
    function setPropertyList_forType (propertyList: id; type_: NSString): boolean; message 'setPropertyList:forType:';
    function dataForType (type_: NSString): NSData; message 'dataForType:';
    function stringForType (type_: NSString): NSString; message 'stringForType:';
    function propertyListForType (type_: NSString): id; message 'propertyListForType:';

    { Adopted protocols }
    function autorelease: id; message 'autorelease';
    function class_: pobjc_class; message 'class';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function initWithPasteboardPropertyList_ofType (propertyList: id; type_: NSString): id; message 'initWithPasteboardPropertyList:ofType:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function isProxy: boolean; message 'isProxy';
    function pasteboardPropertyListForType (type_: NSString): id; message 'pasteboardPropertyListForType:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    class function readableTypesForPasteboard (pasteboard: NSPasteboard): NSArray; message 'readableTypesForPasteboard:';
    class function readingOptionsForType_pasteboard (type_: NSString; pasteboard: NSPasteboard): NSPasteboardReadingOptions; message 'readingOptionsForType:pasteboard:';
    procedure release; message 'release';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    function retainCount: NSUInteger; message 'retainCount';
    function self_: id; message 'self';
    function superclass: pobjc_class; message 'superclass';
    function writableTypesForPasteboard (pasteboard: NSPasteboard): NSArray; message 'writableTypesForPasteboard:';
    function writingOptionsForType_pasteboard (type_: NSString; pasteboard: NSPasteboard): NSPasteboardWritingOptions; message 'writingOptionsForType:pasteboard:';
    function zone: NSZonePtr; message 'zone';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSPasteboardItemDataProviderProtocol = objcprotocol external name 'NSPasteboardItemDataProvider' (NSObjectProtocol)
  required
    procedure pasteboard_item_provideDataForType (pasteboard: NSPasteboard; item: NSPasteboardItem; type_: NSString); message 'pasteboard:item:provideDataForType:';
  optional
    procedure pasteboardFinishedWithDataProvider (pasteboard: NSPasteboard); message 'pasteboardFinishedWithDataProvider:';
  end;
{$endif}

