{ Parsed from AppKit.framework (MacOSX10.8) NSPathCell.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSPathCellPtr = ^NSPathCell;
  NSPathCellDelegateProtocolPtr = ^NSPathCellDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSPathStyleStandard = 0;
  NSPathStylePopUp = 2;

type
  NSPathStyle = NSInteger;
  NSPathStylePtr = ^NSPathStyle;
{$endif}

{$ifdef CLASSES}

type
  NSPathCell = objcclass external (NSActionCell, NSOpenSavePanelDelegateProtocol)
  private
    _backgroundColor: NSColor;
    _borderColors: NSMutableArray;
    _cells: NSMutableArray;
    _clickedCell: NSPathComponentCell;
    _hoveredCell: NSPathComponentCell;
    _popUpButtonCell: NSPopUpButtonCell;
    _currentRect: NSRect;
    _animation: NSAnimation;
    _allowedTypes: NSArray;
    _doubleAction: SEL;
    _delegate: id;
    _piFlags: bitpacked record
      case byte of
        0: (_anonBitField__piFlags0: cuint);
        1: (
          cbs: 0..((1 shl 4)-1);
          reserved: 0..((1 shl 28)-1);
        );
      end;
    _pathStyle: NSPathStyle;
    _aux: id;
  public
    function pathStyle: NSPathStyle; message 'pathStyle';
    procedure setPathStyle (style: NSPathStyle); message 'setPathStyle:';
    function URL: NSURL; message 'URL';
    procedure setURL (url_: NSURL); message 'setURL:';
    procedure setObjectValue (obj: NSCopyingProtocol); message 'setObjectValue:';
    function allowedTypes: NSArray; message 'allowedTypes';
    procedure setAllowedTypes (allowedTypes_: NSArray); message 'setAllowedTypes:';
    function delegate: NSPathCellDelegateProtocol; message 'delegate';
    procedure setDelegate (value: NSPathCellDelegateProtocol); message 'setDelegate:';
    class function pathComponentCellClass: pobjc_class; message 'pathComponentCellClass';
    function pathComponentCells: NSArray; message 'pathComponentCells';
    procedure setPathComponentCells (cells: NSArray); message 'setPathComponentCells:';
    function rectOfPathComponentCell_withFrame_inView (cell: NSPathComponentCell; frame: NSRect; view: NSView): NSRect; message 'rectOfPathComponentCell:withFrame:inView:';
    function pathComponentCellAtPoint_withFrame_inView (point: NSPoint; frame: NSRect; view: NSView): NSPathComponentCell; message 'pathComponentCellAtPoint:withFrame:inView:';
    function clickedPathComponentCell: NSPathComponentCell; message 'clickedPathComponentCell';
    procedure mouseEntered_withFrame_inView (event: NSEvent; frame: NSRect; view: NSView); message 'mouseEntered:withFrame:inView:';
    procedure mouseExited_withFrame_inView (event: NSEvent; frame: NSRect; view: NSView); message 'mouseExited:withFrame:inView:';
    function doubleAction: SEL; message 'doubleAction';
    procedure setDoubleAction (action_: SEL); message 'setDoubleAction:';
    procedure setBackgroundColor (color: NSColor); message 'setBackgroundColor:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setPlaceholderString (string_: NSString); message 'setPlaceholderString:';
    function placeholderString: NSString; message 'placeholderString';
    procedure setPlaceholderAttributedString (string_: NSAttributedString); message 'setPlaceholderAttributedString:';
    function placeholderAttributedString: NSAttributedString; message 'placeholderAttributedString';
    procedure setControlSize (size: NSControlSize); message 'setControlSize:';

    { Adopted protocols }
    function autorelease: id; message 'autorelease';
    function class_: pobjc_class; message 'class';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function isProxy: boolean; message 'isProxy';
    procedure panel_didChangeToDirectoryURL (sender: id; url: NSURL); message 'panel:didChangeToDirectoryURL:'; { available in 10_6 }
    function panel_shouldEnableURL (sender: id; url: NSURL): boolean; message 'panel:shouldEnableURL:'; { available in 10_6 }
    function panel_userEnteredFilename_confirmed (sender: id; filename: NSString; okFlag: boolean): NSString; message 'panel:userEnteredFilename:confirmed:';
    function panel_validateURL_error (sender: id; url: NSURL; outError: NSErrorPtr): boolean; message 'panel:validateURL:error:'; { available in 10_6 }
    procedure panel_willExpand (sender: id; expanding: boolean); message 'panel:willExpand:';
    procedure panelSelectionDidChange (sender: id); message 'panelSelectionDidChange:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    procedure release; message 'release';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    function retainCount: NSUInteger; message 'retainCount';
    function self_: id; message 'self';
    function superclass: pobjc_class; message 'superclass';
    function zone: NSZonePtr; message 'zone';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSPathCellDelegateProtocol = objcprotocol external name 'NSPathCellDelegate' (NSObjectProtocol)
  optional
    procedure pathCell_willDisplayOpenPanel (pathCell: NSPathCell; openPanel: NSOpenPanel); message 'pathCell:willDisplayOpenPanel:';
    procedure pathCell_willPopUpMenu (pathCell: NSPathCell; menu: NSMenu); message 'pathCell:willPopUpMenu:';
  end;
{$endif}

{$ifdef TYPES}
const
  NSPathStyleNavigationBar = 1;
{$endif}

