{ Parsed from AppKit.framework (MacOSX10.8) NSPopover.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSPopoverPtr = ^NSPopover;
  NSPopoverDelegateProtocolPtr = ^NSPopoverDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSPopoverAppearanceMinimal = 0;
  NSPopoverAppearanceHUD = 1;

type
  NSPopoverAppearance = NSInteger;
  NSPopoverAppearancePtr = ^NSPopoverAppearance;

const
  NSPopoverBehaviorApplicationDefined = 0;
  NSPopoverBehaviorTransient = 1;
  NSPopoverBehaviorSemitransient = 2;

type
  NSPopoverBehavior = NSInteger;
  NSPopoverBehaviorPtr = ^NSPopoverBehavior;
{$endif}

{$ifdef CLASSES}

type
  NSPopover = objcclass external (NSResponder)
  private
    _bindingAdaptor: id;
    _delegate: NSPopoverDelegateProtocol;
    _visualRepresentation: id;
    _positioningView: NSView;
    _contentViewController: NSViewController;
    _positioningWindow: NSWindow;
    _appearance: NSPopoverAppearance;
    _behavior: NSPopoverBehavior;
    _unused: NSRectEdge;
    _preferredEdge: NSRectEdge;
    _unused2: NSPoint;
    _contentSize: NSSize;
    _positioningRect: NSRect;
    {$if  not defined(__OBJC2__)}
    _reserved:array[0..2] of id;
    {$endif}
    _flags: bitpacked record
      case byte of
        0: (_anonBitField__flags0: cuint);
        1: (
          animates: 0..1;
          positioningRectIsBounds: 0..1;
          registeredAsTransient: 0..1;
          registeredAsSemitransient: 0..1;
          shown: 0..1;
          toolbarHidesAnchor: 0..1;
          closing: 0..1;
          reserved: 0..((1 shl 25)-1);
        );
      end;
  public
    procedure setDelegate(newValue: NSPopoverDelegateProtocol); message 'setDelegate:';
    function delegate: NSPopoverDelegateProtocol; message 'delegate';
    procedure setAppearance(newValue: NSPopoverAppearance); message 'setAppearance:';
    function appearance: NSPopoverAppearance; message 'appearance';
    procedure setBehavior(newValue: NSPopoverBehavior); message 'setBehavior:';
    function behavior: NSPopoverBehavior; message 'behavior';
    procedure setAnimates(newValue: boolean); message 'setAnimates:';
    function animates: boolean; message 'animates';
    procedure setContentViewController(newValue: NSViewController); message 'setContentViewController:';
    function contentViewController: NSViewController; message 'contentViewController';
    procedure setContentSize(newValue: NSSize); message 'setContentSize:';
    function contentSize: NSSize; message 'contentSize';
    function isShown: boolean; message 'isShown';
    procedure setPositioningRect(newValue: NSRect); message 'setPositioningRect:';
    function positioningRect: NSRect; message 'positioningRect';
    procedure showRelativeToRect_ofView_preferredEdge (positioningRect_: NSRect; positioningView: NSView; preferredEdge: NSRectEdge); message 'showRelativeToRect:ofView:preferredEdge:';
    procedure performClose (sender: id); message 'performClose:';
    procedure close; message 'close';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSPopoverCloseReasonKey: NSString { available in 10_7 }; cvar; external;
  NSPopoverCloseReasonStandard: NSString { available in 10_7 }; cvar; external;
  NSPopoverCloseReasonDetachToWindow: NSString { available in 10_7 }; cvar; external;
  NSPopoverWillShowNotification: NSString { available in 10_7 }; cvar; external;
  NSPopoverDidShowNotification: NSString { available in 10_7 }; cvar; external;
  NSPopoverWillCloseNotification: NSString { available in 10_7 }; cvar; external;
  NSPopoverDidCloseNotification: NSString { available in 10_7 }; cvar; external;
{$endif}

{$ifdef PROTOCOLS}

type
  NSPopoverDelegateProtocol = objcprotocol external name 'NSPopoverDelegate' (NSObjectProtocol)
  optional
    function popoverShouldClose (popover: NSPopover): boolean; message 'popoverShouldClose:';
    function detachableWindowForPopover (popover: NSPopover): NSWindow; message 'detachableWindowForPopover:';
    procedure popoverWillShow (notification: NSNotification); message 'popoverWillShow:';
    procedure popoverDidShow (notification: NSNotification); message 'popoverDidShow:';
    procedure popoverWillClose (notification: NSNotification); message 'popoverWillClose:';
    procedure popoverDidClose (notification: NSNotification); message 'popoverDidClose:';
  end;
{$endif}

