{ Parsed from AppKit.framework (MacOSX10.8) NSPrintInfo.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSPrintInfoPtr = ^NSPrintInfo;
{$endif}

{$ifdef TYPES}
const
  NSPortraitOrientation = 0;
  NSLandscapeOrientation = 1;

type
  NSPrintingOrientation = NSUInteger;
  NSPrintingOrientationPtr = ^NSPrintingOrientation;

const
  NSAutoPagination = 0;
  NSFitPagination = 1;
  NSClipPagination = 2;

type
  NSPrintingPaginationMode = NSUInteger;
  NSPrintingPaginationModePtr = ^NSPrintingPaginationMode;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSPrintSpoolJob: NSString; cvar; external;
  NSPrintPreviewJob: NSString; cvar; external;
  NSPrintSaveJob: NSString; cvar; external;
  NSPrintCancelJob: NSString; cvar; external;
  NSPrintPaperName: NSString; cvar; external;
  NSPrintPaperSize: NSString; cvar; external;
  NSPrintOrientation: NSString; cvar; external;
  NSPrintScalingFactor: NSString; cvar; external;
  NSPrintLeftMargin: NSString; cvar; external;
  NSPrintRightMargin: NSString; cvar; external;
  NSPrintTopMargin: NSString; cvar; external;
  NSPrintBottomMargin: NSString; cvar; external;
  NSPrintHorizontallyCentered: NSString; cvar; external;
  NSPrintVerticallyCentered: NSString; cvar; external;
  NSPrintHorizontalPagination: NSString; cvar; external;
  NSPrintVerticalPagination: NSString; cvar; external;
  NSPrintPrinter: NSString; cvar; external;
  NSPrintCopies: NSString; cvar; external;
  NSPrintAllPages: NSString; cvar; external;
  NSPrintFirstPage: NSString; cvar; external;
  NSPrintLastPage: NSString; cvar; external;
  NSPrintMustCollate: NSString; cvar; external;
  NSPrintReversePageOrder: NSString; cvar; external;
  NSPrintJobDisposition: NSString; cvar; external;
  NSPrintPagesAcross: NSString; cvar; external;
  NSPrintPagesDown: NSString; cvar; external;
  NSPrintTime: NSString; cvar; external;
  NSPrintDetailedErrorReporting: NSString; cvar; external;
  NSPrintFaxNumber: NSString; cvar; external;
  NSPrintPrinterName: NSString; cvar; external;
  NSPrintSelectionOnly: NSString { available in 10_6 }; cvar; external;
  NSPrintJobSavingURL: NSString { available in 10_6 }; cvar; external;
  NSPrintJobSavingFileNameExtensionHidden: NSString { available in 10_6 }; cvar; external;
  NSPrintHeaderAndFooter: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSPrintInfo = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  private
    _attributes: NSMutableDictionary;
    _moreVars: id;
  public
    class procedure setSharedPrintInfo (printInfo: NSPrintInfo); message 'setSharedPrintInfo:';
    class function sharedPrintInfo: NSPrintInfo; message 'sharedPrintInfo';
    function initWithDictionary (attributes: NSDictionary): id; message 'initWithDictionary:';
    function dictionary: NSMutableDictionary; message 'dictionary';
    procedure setPaperName (name: NSString); message 'setPaperName:';
    procedure setPaperSize (size: NSSize); message 'setPaperSize:';
    procedure setOrientation (orientation: NSPrintingOrientation); message 'setOrientation:';
    procedure setScalingFactor (scalingFactor: CGFloat); message 'setScalingFactor:'; { available in 10_6 }
    function paperName: NSString; message 'paperName';
    function paperSize: NSSize; message 'paperSize';
    function orientation: NSPrintingOrientation; message 'orientation';
    function scalingFactor: CGFloat; message 'scalingFactor'; { available in 10_6 }
    procedure setLeftMargin (margin: CGFloat); message 'setLeftMargin:';
    procedure setRightMargin (margin: CGFloat); message 'setRightMargin:';
    procedure setTopMargin (margin: CGFloat); message 'setTopMargin:';
    procedure setBottomMargin (margin: CGFloat); message 'setBottomMargin:';
    function leftMargin: CGFloat; message 'leftMargin';
    function rightMargin: CGFloat; message 'rightMargin';
    function topMargin: CGFloat; message 'topMargin';
    function bottomMargin: CGFloat; message 'bottomMargin';
    procedure setHorizontallyCentered (flag: boolean); message 'setHorizontallyCentered:';
    procedure setVerticallyCentered (flag: boolean); message 'setVerticallyCentered:';
    function isHorizontallyCentered: boolean; message 'isHorizontallyCentered';
    function isVerticallyCentered: boolean; message 'isVerticallyCentered';
    procedure setHorizontalPagination (mode: NSPrintingPaginationMode); message 'setHorizontalPagination:';
    procedure setVerticalPagination (mode: NSPrintingPaginationMode); message 'setVerticalPagination:';
    function horizontalPagination: NSPrintingPaginationMode; message 'horizontalPagination';
    function verticalPagination: NSPrintingPaginationMode; message 'verticalPagination';
    procedure setJobDisposition (disposition: NSString); message 'setJobDisposition:';
    function jobDisposition: NSString; message 'jobDisposition';
    procedure setPrinter (printer: NSPrinter); message 'setPrinter:';
    function printer: NSPrinter; message 'printer';
    procedure setUpPrintOperationDefaultValues; message 'setUpPrintOperationDefaultValues';
    function imageablePageBounds: NSRect; message 'imageablePageBounds';
    function localizedPaperName: NSString; message 'localizedPaperName';
    class function defaultPrinter: NSPrinter; message 'defaultPrinter';
    function printSettings: NSMutableDictionary; message 'printSettings'; { available in 10_5 }
    function PMPrintSession: pointer; message 'PMPrintSession'; { available in 10_5 }
    function PMPageFormat: pointer; message 'PMPageFormat'; { available in 10_5 }
    function PMPrintSettings: pointer; message 'PMPrintSettings'; { available in 10_5 }
    procedure updateFromPMPageFormat; message 'updateFromPMPageFormat'; { available in 10_5 }
    procedure updateFromPMPrintSettings; message 'updateFromPMPrintSettings'; { available in 10_5 }
    procedure setSelectionOnly (selectionOnly: boolean); message 'setSelectionOnly:'; { available in 10_6 }
    function isSelectionOnly: boolean; message 'isSelectionOnly'; { available in 10_6 }

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  NSPrintInfo_NSDeprecated = objccategory external name 'NSDeprecated' (NSPrintInfo)
    class procedure setDefaultPrinter (printer_: NSPrinter); message 'setDefaultPrinter:'; deprecated 'in 10_0, 10_2';
    class function sizeForPaperName (name: NSString): NSSize; message 'sizeForPaperName:'; deprecated 'in 10_0, 10_2';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSPrintFormName: NSString deprecated 'in 10_0, 10_2'; cvar; external;
  NSPrintJobFeatures: NSString deprecated 'in 10_0, 10_2'; cvar; external;
  NSPrintManualFeed: NSString deprecated 'in 10_0, 10_2'; cvar; external;
  NSPrintPagesPerSheet: NSString deprecated 'in 10_0, 10_2'; cvar; external;
  NSPrintPaperFeed: NSString deprecated 'in 10_0, 10_2'; cvar; external;
  NSPrintSavePath: NSString; cvar; external;
{$endif}

