{ Parsed from AppKit.framework (MacOSX10.8) NSProgressIndicator.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSProgressIndicatorPtr = ^NSProgressIndicator;
{$endif}

{$ifdef TYPES}
type
  _NSProgressIndicatorThreadInfo = OpaqueType;
  _NSProgressIndicatorThreadInfoPtr = ^_NSProgressIndicatorThreadInfo;

const
  NSProgressIndicatorPreferredThickness = 14;
  NSProgressIndicatorPreferredSmallThickness = 10;
  NSProgressIndicatorPreferredLargeThickness = 18;
  NSProgressIndicatorPreferredAquaThickness = 12;

type
  NSProgressIndicatorThickness = NSUInteger;
  NSProgressIndicatorThicknessPtr = ^NSProgressIndicatorThickness;

const
  NSProgressIndicatorBarStyle = 0;
  NSProgressIndicatorSpinningStyle = 1;

type
  NSProgressIndicatorStyle = NSUInteger;
  NSProgressIndicatorStylePtr = ^NSProgressIndicatorStyle;
{$endif}

{$ifdef CLASSES}

type
  NSProgressIndicator = objcclass external (NSView)
  private
    _isBezeled: boolean;
    _isIndeterminate: boolean;
    _threadedAnimation: boolean;
    _minimum: double;
    _maximum: double;
    _value: double;
    _animationIndex: cuint;
    _animationDelay: NSTimeInterval;
    _timer: id;
    _drawingWidth: CGFloat;
    _roundColor: id;
    _reserved: id;
    __progressIndicatorFlags: bitpacked record
      case byte of
        0: (_anonBitField___progressIndicatorFlags0: cuint);
        1: (
          isSpinning: 0..1;
          isVector: 0..1;
          isLocked: 0..1;
          controlTint_: 0..((1 shl 3)-1);
          controlSize_: 0..((1 shl 2)-1);
          style_: 0..1;
          _delayedStartup: 0..1;
          hideWhenStopped: 0..1;
          revive: 0..1;
          _temporarilyBlockHeartBeating: 0..1;
          _isHidden: 0..1;
          _isHeartBeatInstalled: 0..1;
          _customRenderer: 0..1;
          _lastFrame: 0..((1 shl 8)-1);
          _isDetaching: 0..1;
          RESERVED: 0..((1 shl 7)-1);
        );
      end;
    _NSProgressIndicatorReserved1: id;
  public
    function isIndeterminate: boolean; message 'isIndeterminate';
    procedure setIndeterminate (flag: boolean); message 'setIndeterminate:';
    function isBezeled: boolean; message 'isBezeled';
    procedure setBezeled (flag: boolean); message 'setBezeled:';
    function controlTint: NSControlTint; message 'controlTint';
    procedure setControlTint (tint: NSControlTint); message 'setControlTint:';
    function controlSize: NSControlSize; message 'controlSize';
    procedure setControlSize (size: NSControlSize); message 'setControlSize:';
    function doubleValue: double; message 'doubleValue';
    procedure setDoubleValue (doubleValue_: double); message 'setDoubleValue:';
    procedure incrementBy (delta: double); message 'incrementBy:';
    function minValue: double; message 'minValue';
    function maxValue: double; message 'maxValue';
    procedure setMinValue (newMinimum: double); message 'setMinValue:';
    procedure setMaxValue (newMaximum: double); message 'setMaxValue:';
    function usesThreadedAnimation: boolean; message 'usesThreadedAnimation';
    procedure setUsesThreadedAnimation (threadedAnimation: boolean); message 'setUsesThreadedAnimation:';
    procedure startAnimation (sender: id); message 'startAnimation:';
    procedure stopAnimation (sender: id); message 'stopAnimation:';
    procedure setStyle (style: NSProgressIndicatorStyle); message 'setStyle:';
    function style: NSProgressIndicatorStyle; message 'style';
    procedure sizeToFit; message 'sizeToFit';
    function isDisplayedWhenStopped: boolean; message 'isDisplayedWhenStopped';
    procedure setDisplayedWhenStopped (isDisplayed: boolean); message 'setDisplayedWhenStopped:';
  end;


type
  NSProgressIndicatorDeprecated = objccategory external (NSProgressIndicator)
    function animationDelay: NSTimeInterval; message 'animationDelay'; deprecated 'in 10_0, 10_6';
    procedure setAnimationDelay (delay: NSTimeInterval); message 'setAnimationDelay:'; deprecated 'in 10_0, 10_6';
    procedure animate (sender: id); message 'animate:'; deprecated 'in 10_0, 10_6';
  end;
{$endif}

