{ Parsed from AppKit.framework (MacOSX10.8) NSSavePanel.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{ Types from NSSavePanel }
{$ifdef TYPES}

{$endif}


{$ifdef TYPES}
type
  NSSavePanelPtr = ^NSSavePanel;
  NSOpenSavePanelDelegateProtocolPtr = ^NSOpenSavePanelDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSFileHandlingPanelCancelButton = NSCancelButton;
  NSFileHandlingPanelOKButton = NSOKButton;

type
  __SPFlags = bitpacked record
    case byte of
      0: (_anonBitField___SPFlags0: cuint);
      1: (
        saveMode: 0..1;
        isExpanded: 0..1;
        allowsOtherFileTypes: 0..1;
        canCreateDirectories: 0..1;
        canSelectedHiddenExtension: 0..1;
        reserved2: 0..1;
        delegate_shouldShowFilename: 0..1;
        delegate_compareFilename: 0..1;
        delegate_shouldEnableURL: 0..1;
        delegate_validateURL: 0..1;
        delegate_didChangeToDirectoryURL: 0..1;
        changingFrameSize: 0..1;
        movingAccessoryView: 0..1;
        userAccessoryViewFrameChange: 0..1;
        canChooseDirectories: 0..1;
        canChooseFiles: 0..1;
        delegate_selectionDidChange: 0..1;
        delegate_didChangeToDirectory: 0..1;
        calledWindowOrderedIn: 0..1;
        appCentric: 0..1;
        disableBottomControls: 0..1;
        accessoryViewDisclosed: 0..1;
        reserved: 0..((1 shl 10)-1);
      );
    end;
type
  _SPFlags = __SPFlags;
type
  _SPFlagsPtr = ^__SPFlags;
type
  __SPFlagsPtr = ^__SPFlags;
{$endif}

{$ifdef CLASSES}

type
  NSSavePanel = objcclass external (NSPanel)
  private
    __navView: NSView;
    _accessoryView: NSView;
    _allowedFileTypes: NSArray;
    _validatedPosixName: NSString;
    _hiddenExtension: NSString;
    _messageTextField: NSTextField;
    _savePane: NSView;
    _saveNavSeparatorBox: NSBox;
    _savePaneTopPartsContainer: NSView;
    _nameField: NSTextField;
    _nameFieldLabel: NSTextField;
    _expansionButton: NSButton;
    _directoryPopUpContainer: NSView;
    _directoryPopUp: NSControl;
    _directoryPopUpLabel: NSTextField;
    _navViewContainer: NSBox;
    _accessoryViewContainer: NSBox;
    _bottomControlsContainer: NSView;
    _hideExtensionButton: NSButton;
    _newFolderButton: NSButton;
    _cancelButton: NSButton;
    _okButton: NSButton;
    _filepathInputController: id;
    _reservedID: id;
    _spFlags: _SPFlags;
    _spAuxiliaryStorage: NSSavePanelAuxiliary;
    _anonStruct_NSSavePanel0: record
      case byte of
        0: (anonBitField_NSSavePanel0: cuint);
        1: (data: bitpacked record
          _directorySet: 0..1;
        end;
      );
    end;
    _reserved:array[0..3] of char;
    _openProgressIndicator: NSProgressIndicator;
  public
    class function savePanel: NSSavePanel; message 'savePanel';
    function URL: NSURL; message 'URL';
    function directoryURL: NSURL; message 'directoryURL'; { available in 10_6 }
    procedure setDirectoryURL (url_: NSURL); message 'setDirectoryURL:'; { available in 10_6 }
    function allowedFileTypes: NSArray; message 'allowedFileTypes';
    procedure setAllowedFileTypes (types: NSArray); message 'setAllowedFileTypes:';
    function allowsOtherFileTypes: boolean; message 'allowsOtherFileTypes';
    procedure setAllowsOtherFileTypes (flag: boolean); message 'setAllowsOtherFileTypes:';
    function accessoryView: NSView; message 'accessoryView';
    procedure setAccessoryView (view: NSView); message 'setAccessoryView:';
    function delegate: NSOpenSavePanelDelegateProtocol; message 'delegate';
    procedure setDelegate (delegate_: NSOpenSavePanelDelegateProtocol); message 'setDelegate:';
    function isExpanded: boolean; message 'isExpanded';
    function canCreateDirectories: boolean; message 'canCreateDirectories';
    procedure setCanCreateDirectories (flag: boolean); message 'setCanCreateDirectories:';
    function canSelectHiddenExtension: boolean; message 'canSelectHiddenExtension';
    procedure setCanSelectHiddenExtension (flag: boolean); message 'setCanSelectHiddenExtension:';
    function isExtensionHidden: boolean; message 'isExtensionHidden';
    procedure setExtensionHidden (flag: boolean); message 'setExtensionHidden:';
    function treatsFilePackagesAsDirectories: boolean; message 'treatsFilePackagesAsDirectories';
    procedure setTreatsFilePackagesAsDirectories (flag: boolean); message 'setTreatsFilePackagesAsDirectories:';
    function prompt: NSString; message 'prompt';
    procedure setPrompt (prompt_: NSString); message 'setPrompt:';
    function title: NSString; message 'title';
    procedure setTitle (title_: NSString); message 'setTitle:';
    function nameFieldLabel: NSString; message 'nameFieldLabel';
    procedure setNameFieldLabel (label_: NSString); message 'setNameFieldLabel:';
    function nameFieldStringValue: NSString; message 'nameFieldStringValue'; { available in 10_6 }
    procedure setNameFieldStringValue (value: NSString); message 'setNameFieldStringValue:'; { available in 10_6 }
    function message_: NSString; message 'message';
    procedure setMessage (message__: NSString); message 'setMessage:';
    procedure validateVisibleColumns; message 'validateVisibleColumns';
    function showsHiddenFiles: boolean; message 'showsHiddenFiles';
    procedure setShowsHiddenFiles (flag: boolean); message 'setShowsHiddenFiles:';
    procedure ok (sender: id); message 'ok:';
    procedure cancel (sender: id); message 'cancel:';
    {$if defined(NS_BLOCKS_AVAILABLE)}
    procedure beginSheetModalForWindow_completionHandler (window: NSWindow; handler: OpaqueCBlock); message 'beginSheetModalForWindow:completionHandler:'; { available in 10_6 }
    procedure beginWithCompletionHandler (handler: OpaqueCBlock); message 'beginWithCompletionHandler:'; { available in 10_6 }
    {$endif}
    function runModal: NSInteger; message 'runModal';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSOpenSavePanelDelegateProtocol = objcprotocol external name 'NSOpenSavePanelDelegate' (NSObjectProtocol)
  optional
    function panel_shouldEnableURL (sender: id; url: NSURL): boolean; message 'panel:shouldEnableURL:'; { available in 10_6 }
    function panel_validateURL_error (sender: id; url: NSURL; outError: NSErrorPtr): boolean; message 'panel:validateURL:error:'; { available in 10_6 }
    procedure panel_didChangeToDirectoryURL (sender: id; url: NSURL); message 'panel:didChangeToDirectoryURL:'; { available in 10_6 }
    function panel_userEnteredFilename_confirmed (sender: id; filename: NSString; okFlag: boolean): NSString; message 'panel:userEnteredFilename:confirmed:';
    procedure panel_willExpand (sender: id; expanding: boolean); message 'panel:willExpand:';
    procedure panelSelectionDidChange (sender: id); message 'panelSelectionDidChange:';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSSavePanelDelegateDeprecated = objccategory external (NSObject)
    function panel_isValidFilename (sender: id; filename: NSString): boolean; message 'panel:isValidFilename:';
    procedure panel_directoryDidChange (sender: id; path: NSString); message 'panel:directoryDidChange:';
    function panel_compareFilename_with_caseSensitive (sender: id; name1: NSString; name2: NSString; caseSensitive: boolean): NSComparisonResult; message 'panel:compareFilename:with:caseSensitive:';
    function panel_shouldShowFilename (sender: id; filename: NSString): boolean; message 'panel:shouldShowFilename:';
  end;

type
  NSSavePanel_NSDeprecated = objccategory external name 'NSDeprecated' (NSSavePanel)
    function filename: NSString; message 'filename'; deprecated 'in 10_0, 10_6';
    function directory: NSString; message 'directory'; deprecated 'in 10_0, 10_6';
    procedure setDirectory (path: NSString); message 'setDirectory:'; deprecated 'in 10_0, 10_6';
    function requiredFileType: NSString; message 'requiredFileType'; deprecated 'in 10_0, 10_6';
    procedure setRequiredFileType (type_: NSString); message 'setRequiredFileType:'; deprecated 'in 10_0, 10_6';
    procedure beginSheetForDirectory_file_modalForWindow_modalDelegate_didEndSelector_contextInfo (path: NSString; name: NSString; docWindow: NSWindow; delegate_: id; didEndSelector: SEL; contextInfo: pointer); message 'beginSheetForDirectory:file:modalForWindow:modalDelegate:didEndSelector:contextInfo:'; deprecated 'in 10_0, 10_6';
    function runModalForDirectory_file (path: NSString; name: NSString): NSInteger; message 'runModalForDirectory:file:'; deprecated 'in 10_0, 10_6';
    procedure selectText (sender: id); message 'selectText:'; deprecated 'in 10_0, 10_3';
  end;
{$endif}

