{ Parsed from AppKit.framework (MacOSX10.8) NSScrollView.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSScrollViewPtr = ^NSScrollView;
{$endif}

{$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED)}
{$ifdef TYPES}
const
  NSScrollElasticityAutomatic = 0;
  NSScrollElasticityNone = 1;
  NSScrollElasticityAllowed = 2;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSScrollElasticity = NSInteger;
  NSScrollElasticityPtr = ^NSScrollElasticity;

type
  __SFlags = bitpacked record
    case byte of
      0: (_anonBitField___SFlags0: cuint);
      1: (
        {$ifdef __BIG_ENDIAN__}
        vScrollerRequired: 0..1;
        hScrollerRequired: 0..1;
        vScrollerStatus: 0..1;
        hScrollerStatus: 0..1;
        noDynamicScrolling: 0..1;
        borderType: 0..((1 shl 2)-1);
        oldRulerInstalled: 0..1;
        showRulers: 0..1;
        hasHorizontalRuler: 0..1;
        hasVerticalRuler: 0..1;
        needsTile: 0..1;
        doesNotDrawBackground: 0..1;
        skipRemoveSuperviewCheck: 0..1;
        focusRingNeedsRedisplay: 0..1;
        hasCustomLineBorderColor: 0..1;
        autohidesScrollers: 0..1;
        autoforwardsScrollWheelEvents: 0..1;
        findBarVisible: 0..1;
        unused: 0..1;
        vContentElasticity: 0..((1 shl 2)-1);
        hContentElasticity: 0..((1 shl 2)-1);
        predominantAxisScrolling: 0..1;
        findBarPosition: 0..((1 shl 2)-1);
        RESERVED: 0..((1 shl 5)-1);
        {$else}
        RESERVED_: 0..((1 shl 5)-1);
        findBarPosition_: 0..((1 shl 2)-1);
        predominantAxisScrolling_: 0..1;
        hContentElasticity_: 0..((1 shl 2)-1);
        vContentElasticity_: 0..((1 shl 2)-1);
        unused_: 0..1;
        findBarVisible_: 0..1;
        autoforwardsScrollWheelEvents_: 0..1;
        autohidesScrollers_: 0..1;
        hasCustomLineBorderColor_: 0..1;
        focusRingNeedsRedisplay_: 0..1;
        skipRemoveSuperviewCheck_: 0..1;
        doesNotDrawBackground_: 0..1;
        needsTile_: 0..1;
        hasVerticalRuler_: 0..1;
        hasHorizontalRuler_: 0..1;
        showRulers_: 0..1;
        oldRulerInstalled_: 0..1;
        borderType_: 0..((1 shl 2)-1);
        noDynamicScrolling_: 0..1;
        hScrollerStatus_: 0..1;
        vScrollerStatus_: 0..1;
        hScrollerRequired_: 0..1;
        vScrollerRequired_: 0..1;
        {$endif}
      );
    end;
type
  _SFlags = __SFlags;
type
  _SFlagsPtr = ^__SFlags;
type
  __SFlagsPtr = ^__SFlags;
{$endif}

{$ifdef CLASSES}

type
  NSScrollView = objcclass external (NSView, NSTextFinderBarContainerProtocol)
  private
    _vScroller: NSScroller;
    _hScroller: NSScroller;
    _contentView: NSClipView;
    _headerClipView: NSClipView;
    _cornerView: NSView;
    _ruler: id;
    _sFlags: _SFlags;
    _extraIvars: pointer;
    _horizontalRuler: NSRulerView;
    _verticalRuler: NSRulerView;
  public
    class function frameSizeForContentSize_horizontalScrollerClass_verticalScrollerClass_borderType_controlSize_scrollerStyle (cSize: NSSize; horizontalScrollerClass: pobjc_class; verticalScrollerClass: pobjc_class; aType: NSBorderType; controlSize: NSControlSize; scrollerStyle: NSScrollerStyle): NSSize; message 'frameSizeForContentSize:horizontalScrollerClass:verticalScrollerClass:borderType:controlSize:scrollerStyle:'; { available in 10_7 }
    class function contentSizeForFrameSize_horizontalScrollerClass_verticalScrollerClass_borderType_controlSize_scrollerStyle (fSize: NSSize; horizontalScrollerClass: pobjc_class; verticalScrollerClass: pobjc_class; aType: NSBorderType; controlSize: NSControlSize; scrollerStyle: NSScrollerStyle): NSSize; message 'contentSizeForFrameSize:horizontalScrollerClass:verticalScrollerClass:borderType:controlSize:scrollerStyle:'; { available in 10_7 }
    class function frameSizeForContentSize_hasHorizontalScroller_hasVerticalScroller_borderType (cSize: NSSize; hFlag: boolean; vFlag: boolean; aType: NSBorderType): NSSize; message 'frameSizeForContentSize:hasHorizontalScroller:hasVerticalScroller:borderType:';
    class function contentSizeForFrameSize_hasHorizontalScroller_hasVerticalScroller_borderType (fSize: NSSize; hFlag: boolean; vFlag: boolean; aType: NSBorderType): NSSize; message 'contentSizeForFrameSize:hasHorizontalScroller:hasVerticalScroller:borderType:';
    function documentVisibleRect: NSRect; message 'documentVisibleRect';
    function contentSize: NSSize; message 'contentSize';
    procedure setDocumentView (aView: NSView); message 'setDocumentView:';
    function documentView: id; message 'documentView';
    procedure setContentView (contentView: NSClipView); message 'setContentView:';
    function contentView: NSClipView; message 'contentView';
    procedure setDocumentCursor (anObj: NSCursor); message 'setDocumentCursor:';
    function documentCursor: NSCursor; message 'documentCursor';
    procedure setBorderType (aType: NSBorderType); message 'setBorderType:';
    function borderType: NSBorderType; message 'borderType';
    procedure setBackgroundColor (color: NSColor); message 'setBackgroundColor:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setDrawsBackground (flag: boolean); message 'setDrawsBackground:';
    function drawsBackground: boolean; message 'drawsBackground';
    procedure setHasVerticalScroller (flag: boolean); message 'setHasVerticalScroller:';
    function hasVerticalScroller: boolean; message 'hasVerticalScroller';
    procedure setHasHorizontalScroller (flag: boolean); message 'setHasHorizontalScroller:';
    function hasHorizontalScroller: boolean; message 'hasHorizontalScroller';
    procedure setVerticalScroller (anObject: NSScroller); message 'setVerticalScroller:';
    function verticalScroller: NSScroller; message 'verticalScroller';
    procedure setHorizontalScroller (anObject: NSScroller); message 'setHorizontalScroller:';
    function horizontalScroller: NSScroller; message 'horizontalScroller';
    function autohidesScrollers: boolean; message 'autohidesScrollers';
    procedure setAutohidesScrollers (flag: boolean); message 'setAutohidesScrollers:';
    procedure setHorizontalLineScroll (value: CGFloat); message 'setHorizontalLineScroll:';
    procedure setVerticalLineScroll (value: CGFloat); message 'setVerticalLineScroll:';
    procedure setLineScroll (value: CGFloat); message 'setLineScroll:';
    function horizontalLineScroll: CGFloat; message 'horizontalLineScroll';
    function verticalLineScroll: CGFloat; message 'verticalLineScroll';
    function lineScroll: CGFloat; message 'lineScroll';
    procedure setHorizontalPageScroll (value: CGFloat); message 'setHorizontalPageScroll:';
    procedure setVerticalPageScroll (value: CGFloat); message 'setVerticalPageScroll:';
    procedure setPageScroll (value: CGFloat); message 'setPageScroll:';
    function horizontalPageScroll: CGFloat; message 'horizontalPageScroll';
    function verticalPageScroll: CGFloat; message 'verticalPageScroll';
    function pageScroll: CGFloat; message 'pageScroll';
    procedure setScrollsDynamically (flag: boolean); message 'setScrollsDynamically:';
    function scrollsDynamically: boolean; message 'scrollsDynamically';
    procedure tile; message 'tile';
    procedure reflectScrolledClipView (cView: NSClipView); message 'reflectScrolledClipView:';
    procedure scrollWheel (theEvent: NSEvent); message 'scrollWheel:';
    function scrollerStyle: NSScrollerStyle; message 'scrollerStyle'; { available in 10_7 }
    procedure setScrollerStyle (newScrollerStyle: NSScrollerStyle); message 'setScrollerStyle:'; { available in 10_7 }
    function scrollerKnobStyle: NSScrollerKnobStyle; message 'scrollerKnobStyle'; { available in 10_7 }
    procedure setScrollerKnobStyle (newScrollerKnobStyle: NSScrollerKnobStyle); message 'setScrollerKnobStyle:'; { available in 10_7 }
    procedure flashScrollers; message 'flashScrollers'; { available in 10_7 }
    function horizontalScrollElasticity: NSScrollElasticity; message 'horizontalScrollElasticity'; { available in 10_7 }
    procedure setHorizontalScrollElasticity (elasticity: NSScrollElasticity); message 'setHorizontalScrollElasticity:'; { available in 10_7 }
    function verticalScrollElasticity: NSScrollElasticity; message 'verticalScrollElasticity'; { available in 10_7 }
    procedure setVerticalScrollElasticity (elasticity: NSScrollElasticity); message 'setVerticalScrollElasticity:'; { available in 10_7 }
    function usesPredominantAxisScrolling: boolean; message 'usesPredominantAxisScrolling'; { available in 10_7 }
    procedure setUsesPredominantAxisScrolling (predominantAxisScrolling: boolean); message 'setUsesPredominantAxisScrolling:'; { available in 10_7 }
    procedure setAllowsMagnification(newValue: boolean); message 'setAllowsMagnification:';
    function allowsMagnification: boolean; message 'allowsMagnification';
    procedure setMagnification(newValue: CGFloat); message 'setMagnification:';
    function magnification: CGFloat; message 'magnification';
    procedure setMaxMagnification(newValue: CGFloat); message 'setMaxMagnification:';
    function maxMagnification: CGFloat; message 'maxMagnification';
    procedure setMinMagnification(newValue: CGFloat); message 'setMinMagnification:';
    function minMagnification: CGFloat; message 'minMagnification';
    procedure magnifyToFitRect (rect: NSRect); message 'magnifyToFitRect:'; { available in 10_8 }
    procedure setMagnification_centeredAtPoint (magnification_: CGFloat; point: NSPoint); message 'setMagnification:centeredAtPoint:'; { available in 10_8 }

    { Adopted protocols }
    procedure setFindBarView(newValue: NSView); message 'setFindBarView:';
    function findBarView: NSView; message 'findBarView';
    procedure findBarViewDidChangeHeight; message 'findBarViewDidChangeHeight';
    procedure setFindBarVisible(newValue: boolean); message 'setFindBarVisible:';
    function isFindBarVisible: boolean; message 'isFindBarVisible';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSScrollViewWillStartLiveMagnifyNotification: NSString { available in 10_8 }; cvar; external;
  NSScrollViewDidEndLiveMagnifyNotification: NSString { available in 10_8 }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSRulerSupport = objccategory external (NSScrollView)
    class procedure setRulerViewClass (rulerViewClass: pobjc_class); message 'setRulerViewClass:';
    class function rulerViewClass: pobjc_class; message 'rulerViewClass';
    procedure setRulersVisible (flag: boolean); message 'setRulersVisible:';
    function rulersVisible: boolean; message 'rulersVisible';
    procedure setHasHorizontalRuler (flag: boolean); message 'setHasHorizontalRuler:';
    function hasHorizontalRuler: boolean; message 'hasHorizontalRuler';
    procedure setHasVerticalRuler (flag: boolean); message 'setHasVerticalRuler:';
    function hasVerticalRuler: boolean; message 'hasVerticalRuler';
    procedure setHorizontalRulerView (ruler: NSRulerView); message 'setHorizontalRulerView:';
    function horizontalRulerView: NSRulerView; message 'horizontalRulerView';
    procedure setVerticalRulerView (ruler: NSRulerView); message 'setVerticalRulerView:';
    function verticalRulerView: NSRulerView; message 'verticalRulerView';
  end;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
{$ifdef TYPES}
const
  NSScrollViewFindBarPositionAboveHorizontalRuler = 0;
  NSScrollViewFindBarPositionAboveContent = 1;
  NSScrollViewFindBarPositionBelowContent = 2;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSScrollViewFindBarPosition = NSInteger;
  NSScrollViewFindBarPositionPtr = ^NSScrollViewFindBarPosition;
{$endif}

{$ifdef CLASSES}

type
  NSFindBarSupport = objccategory external (NSScrollView)
    procedure setFindBarPosition (position: NSScrollViewFindBarPosition); message 'setFindBarPosition:'; { available in 10_7 }
    function findBarPosition: NSScrollViewFindBarPosition; message 'findBarPosition'; { available in 10_7 }
  end;
{$endif}

