{ Parsed from AppKit.framework (MacOSX10.8) NSSegmentedControl.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSSegmentedControlPtr = ^NSSegmentedControl;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef TYPES}
const
  NSSegmentStyleAutomatic = 0;
  NSSegmentStyleRounded = 1;
  NSSegmentStyleRoundRect = 3;
  NSSegmentStyleTexturedSquare = 4;
  NSSegmentStyleSmallSquare = 6;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSSegmentStyle = NSInteger;
  NSSegmentStylePtr = ^NSSegmentStyle;
{$endif}

{$ifdef CLASSES}

type
  NSSegmentedControl = objcclass external (NSControl)
  private
    _reserved1: NSInteger;
    _reserved2: NSInteger;
    _reserved3: NSInteger;
    _reserved4: NSInteger;
  public
    procedure setSegmentCount (count: NSInteger); message 'setSegmentCount:';
    function segmentCount: NSInteger; message 'segmentCount';
    procedure setSelectedSegment (selectedSegment: NSInteger); message 'setSelectedSegment:';
    function selectedSegment: NSInteger; message 'selectedSegment';
    function selectSegmentWithTag (tag_: NSInteger): boolean; message 'selectSegmentWithTag:';
    procedure setWidth_forSegment (width: CGFloat; segment: NSInteger); message 'setWidth:forSegment:';
    function widthForSegment (segment: NSInteger): CGFloat; message 'widthForSegment:';
    procedure setImage_forSegment (image: NSImage; segment: NSInteger); message 'setImage:forSegment:';
    function imageForSegment (segment: NSInteger): NSImage; message 'imageForSegment:';
    procedure setImageScaling_forSegment (scaling: NSImageScaling; segment: NSInteger); message 'setImageScaling:forSegment:'; { available in 10_5 }
    function imageScalingForSegment (segment: NSInteger): NSImageScaling; message 'imageScalingForSegment:'; { available in 10_5 }
    procedure setLabel_forSegment (label_: NSString; segment: NSInteger); message 'setLabel:forSegment:';
    function labelForSegment (segment: NSInteger): NSString; message 'labelForSegment:';
    procedure setMenu_forSegment (menu_: NSMenu; segment: NSInteger); message 'setMenu:forSegment:';
    function menuForSegment (segment: NSInteger): NSMenu; message 'menuForSegment:';
    procedure setSelected_forSegment (selected: boolean; segment: NSInteger); message 'setSelected:forSegment:';
    function isSelectedForSegment (segment: NSInteger): boolean; message 'isSelectedForSegment:';
    procedure setEnabled_forSegment (enabled: boolean; segment: NSInteger); message 'setEnabled:forSegment:';
    function isEnabledForSegment (segment: NSInteger): boolean; message 'isEnabledForSegment:';
    procedure setSegmentStyle (segmentStyle: NSSegmentStyle); message 'setSegmentStyle:'; { available in 10_5 }
    function segmentStyle: NSSegmentStyle; message 'segmentStyle'; { available in 10_5 }
  end;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef TYPES}
const
  NSSegmentStyleTexturedRounded = 2;
  NSSegmentStyleCapsule = 5;
{$endif}

{$endif}
