{ Parsed from AppKit.framework (MacOSX10.8) NSSliderCell.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSSliderCellPtr = ^NSSliderCell;
{$endif}

{$ifdef TYPES}
const
  NSTickMarkBelow = 0;
  NSTickMarkAbove = 1;
  NSTickMarkLeft = NSTickMarkAbove;
  NSTickMarkRight = NSTickMarkBelow;

type
  NSTickMarkPosition = NSUInteger;
  NSTickMarkPositionPtr = ^NSTickMarkPosition;

const
  NSLinearSlider = 0;
  NSCircularSlider = 1;

type
  NSSliderType = NSUInteger;
  NSSliderTypePtr = ^NSSliderType;
{$endif}

{$ifdef CLASSES}

type
  NSSliderCell = objcclass external (NSActionCell)
  private
    _reserved:array[0..2] of cint;
    _numberOfTickMarks: cint;
    _altIncValue: double;
    _value: double;
    _maxValue: double;
    _minValue: double;
    _trackRect: NSRect;
    __sliderCellFlags: bitpacked record
      case byte of
        0: (_anonBitField___sliderCellFlags0: cuint);
        1: (
          weAreVertical: 0..1;
          weAreVerticalSet: 0..1;
          reserved1: 0..1;
          isPressed: 0..1;
          allowsTickMarkValuesOnly_: 0..1;
          tickMarkPosition_: 0..1;
          sliderType_: 0..((1 shl 2)-1);
          drawing: 0..1;
          reserved2: 0..((1 shl 23)-1);
        );
      end;
  public
    class function prefersTrackingUntilMouseUp: boolean; message 'prefersTrackingUntilMouseUp';
    function minValue: double; message 'minValue';
    procedure setMinValue (aDouble: double); message 'setMinValue:';
    function maxValue: double; message 'maxValue';
    procedure setMaxValue (aDouble: double); message 'setMaxValue:';
    procedure setAltIncrementValue (incValue: double); message 'setAltIncrementValue:';
    function altIncrementValue: double; message 'altIncrementValue';
    function isVertical: NSInteger; message 'isVertical';
    procedure setTitleColor (newColor: NSColor); message 'setTitleColor:';
    function titleColor: NSColor; message 'titleColor';
    procedure setTitleFont (fontObj: NSFont); message 'setTitleFont:';
    function titleFont: NSFont; message 'titleFont';
    function title: NSString; message 'title';
    procedure setTitle (aString: NSString); message 'setTitle:';
    procedure setTitleCell (aCell: NSCell); message 'setTitleCell:';
    function titleCell: id; message 'titleCell';
    procedure setKnobThickness (aFloat: CGFloat); message 'setKnobThickness:';
    function knobThickness: CGFloat; message 'knobThickness';
    function knobRectFlipped (flipped: boolean): NSRect; message 'knobRectFlipped:';
    procedure drawKnob (knobRect: NSRect); message 'drawKnob:';
    procedure drawKnob_; message 'drawKnob';
    procedure drawBarInside_flipped (aRect: NSRect; flipped: boolean); message 'drawBarInside:flipped:';
    function trackRect: NSRect; message 'trackRect';
    procedure setSliderType (sliderType: NSSliderType); message 'setSliderType:';
    function sliderType: NSSliderType; message 'sliderType';
  end;


type
  NSSliderCell_NSTickMarkSupport = objccategory external name 'NSTickMarkSupport' (NSSliderCell)
    procedure setNumberOfTickMarks (count: NSInteger); message 'setNumberOfTickMarks:';
    function numberOfTickMarks: NSInteger; message 'numberOfTickMarks';
    procedure setTickMarkPosition (position: NSTickMarkPosition); message 'setTickMarkPosition:';
    function tickMarkPosition: NSTickMarkPosition; message 'tickMarkPosition';
    procedure setAllowsTickMarkValuesOnly (yorn: boolean); message 'setAllowsTickMarkValuesOnly:';
    function allowsTickMarkValuesOnly: boolean; message 'allowsTickMarkValuesOnly';
    function tickMarkValueAtIndex (index: NSInteger): double; message 'tickMarkValueAtIndex:';
    function rectOfTickMarkAtIndex (index: NSInteger): NSRect; message 'rectOfTickMarkAtIndex:';
    function indexOfTickMarkAtPoint (point: NSPoint): NSInteger; message 'indexOfTickMarkAtPoint:';
    function closestTickMarkValueToValue (value: double): double; message 'closestTickMarkValueToValue:';
  end;
{$endif}

