{ Parsed from AppKit.framework (MacOSX10.8) NSSound.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSSoundPtr = ^NSSound;
  NSSoundDelegateProtocolPtr = ^NSSoundDelegateProtocol;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSSoundPboardType: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSSound = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol, NSPasteboardReadingProtocol, NSPasteboardWritingProtocol)
  private
    _delegate: id;
    _info: id;
    _reserved:array[0..5] of id;
    _sFlags: cuint32;
  public
    class function soundNamed (name: NSString): id; message 'soundNamed:';
    function initWithContentsOfURL_byReference (url: NSURL; byRef: boolean): id; message 'initWithContentsOfURL:byReference:';
    function initWithContentsOfFile_byReference (path: NSString; byRef: boolean): id; message 'initWithContentsOfFile:byReference:';
    function initWithData (data: NSData): id; message 'initWithData:';
    function setName (string_: NSString): boolean; message 'setName:';
    function name: NSString; message 'name';
    class function canInitWithPasteboard (pasteboard: NSPasteboard): boolean; message 'canInitWithPasteboard:';
    class function soundUnfilteredTypes: NSArray; message 'soundUnfilteredTypes'; { available in 10_5 }
    function initWithPasteboard (pasteboard: NSPasteboard): id; message 'initWithPasteboard:';
    procedure writeToPasteboard (pasteboard: NSPasteboard); message 'writeToPasteboard:';
    function play: boolean; message 'play';
    function pause: boolean; message 'pause';
    function resume: boolean; message 'resume';
    function stop: boolean; message 'stop';
    function isPlaying: boolean; message 'isPlaying';
    function delegate: NSSoundDelegateProtocol; message 'delegate';
    procedure setDelegate (aDelegate: NSSoundDelegateProtocol); message 'setDelegate:';
    function duration: NSTimeInterval; message 'duration'; { available in 10_5 }
    procedure setVolume (volume: single); message 'setVolume:'; { available in 10_5 }
    function volume: single; message 'volume'; { available in 10_5 }
    function currentTime: NSTimeInterval; message 'currentTime'; { available in 10_5 }
    procedure setCurrentTime (seconds: NSTimeInterval); message 'setCurrentTime:'; { available in 10_5 }
    procedure setLoops (val: boolean); message 'setLoops:'; { available in 10_5 }
    function loops: boolean; message 'loops'; { available in 10_5 }
    procedure setPlaybackDeviceIdentifier (deviceUID: NSString); message 'setPlaybackDeviceIdentifier:'; { available in 10_5 }
    function playbackDeviceIdentifier: NSString; message 'playbackDeviceIdentifier'; { available in 10_5 }
    procedure setChannelMapping (channelMapping: NSArray); message 'setChannelMapping:'; { available in 10_5 }
    function channelMapping: NSArray; message 'channelMapping'; { available in 10_5 }

    { Adopted protocols }
    function autorelease: id; message 'autorelease';
    function class_: pobjc_class; message 'class';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function hash: NSUInteger; message 'hash';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function initWithPasteboardPropertyList_ofType (propertyList: id; type_: NSString): id; message 'initWithPasteboardPropertyList:ofType:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function isProxy: boolean; message 'isProxy';
    function pasteboardPropertyListForType (type_: NSString): id; message 'pasteboardPropertyListForType:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    class function readableTypesForPasteboard (pasteboard: NSPasteboard): NSArray; message 'readableTypesForPasteboard:';
    class function readingOptionsForType_pasteboard (type_: NSString; pasteboard: NSPasteboard): NSPasteboardReadingOptions; message 'readingOptionsForType:pasteboard:';
    procedure release; message 'release';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    function retainCount: NSUInteger; message 'retainCount';
    function self_: id; message 'self';
    function superclass: pobjc_class; message 'superclass';
    function writableTypesForPasteboard (pasteboard: NSPasteboard): NSArray; message 'writableTypesForPasteboard:';
    function writingOptionsForType_pasteboard (type_: NSString; pasteboard: NSPasteboard): NSPasteboardWritingOptions; message 'writingOptionsForType:pasteboard:';
    function zone: NSZonePtr; message 'zone';
  end;


type
  NSSound_NSDeprecated = objccategory external name 'NSDeprecated' (NSSound)
    class function soundUnfilteredFileTypes: NSArray; message 'soundUnfilteredFileTypes'; deprecated 'in 10_0, 10_5';
    class function soundUnfilteredPasteboardTypes: NSArray; message 'soundUnfilteredPasteboardTypes'; deprecated 'in 10_0, 10_5';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSSoundDelegateProtocol = objcprotocol external name 'NSSoundDelegate' (NSObjectProtocol)
  optional
    procedure sound_didFinishPlaying (sound: NSSound; aBool: boolean); message 'sound:didFinishPlaying:';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSBundleSoundExtensions = objccategory external (NSBundle)
    function pathForSoundResource (name: NSString): NSString; message 'pathForSoundResource:';
  end;
{$endif}

