{ Parsed from AppKit.framework (MacOSX10.8) NSSplitView.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSSplitViewPtr = ^NSSplitView;
  NSSplitViewDelegateProtocolPtr = ^NSSplitViewDelegateProtocol;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef TYPES}
const
  NSSplitViewDividerStyleThick = 1;
  NSSplitViewDividerStyleThin = 2;
  {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
  NSSplitViewDividerStylePaneSplitter = 3;
  {$endif}
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSSplitViewDividerStyle = NSInteger;
  NSSplitViewDividerStylePtr = ^NSSplitViewDividerStyle;
{$endif}

{$ifdef CLASSES}

type
  NSSplitView = objcclass external (NSView)
  private
    _variables: id;
  public
    procedure setVertical (flag: boolean); message 'setVertical:';
    function isVertical: boolean; message 'isVertical';
    procedure setDividerStyle (dividerStyle: NSSplitViewDividerStyle); message 'setDividerStyle:'; { available in 10_5 }
    function dividerStyle: NSSplitViewDividerStyle; message 'dividerStyle'; { available in 10_5 }
    procedure setAutosaveName (autosaveName: NSString); message 'setAutosaveName:'; { available in 10_5 }
    function autosaveName: NSString; message 'autosaveName'; { available in 10_5 }
    procedure setDelegate (delegate: NSSplitViewDelegateProtocol); message 'setDelegate:';
    function delegate: NSSplitViewDelegateProtocol; message 'delegate';
    procedure drawDividerInRect (rect: NSRect); message 'drawDividerInRect:';
    function dividerColor: NSColor; message 'dividerColor'; { available in 10_5 }
    function dividerThickness: CGFloat; message 'dividerThickness';
    procedure adjustSubviews; message 'adjustSubviews';
    function isSubviewCollapsed (subview: NSView): boolean; message 'isSubviewCollapsed:';
    function minPossiblePositionOfDividerAtIndex (dividerIndex: NSInteger): CGFloat; message 'minPossiblePositionOfDividerAtIndex:'; { available in 10_5 }
    function maxPossiblePositionOfDividerAtIndex (dividerIndex: NSInteger): CGFloat; message 'maxPossiblePositionOfDividerAtIndex:'; { available in 10_5 }
    procedure setPosition_ofDividerAtIndex (position: CGFloat; dividerIndex: NSInteger); message 'setPosition:ofDividerAtIndex:'; { available in 10_5 }
    function holdingPriorityForSubviewAtIndex (subviewIndex: NSInteger): NSLayoutPriority; message 'holdingPriorityForSubviewAtIndex:'; { available in 10_8 }
    procedure setHoldingPriority_forSubviewAtIndex (priority: NSLayoutPriority; subviewIndex: NSInteger); message 'setHoldingPriority:forSubviewAtIndex:'; { available in 10_8 }
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSSplitViewDelegateProtocol = objcprotocol external name 'NSSplitViewDelegate' (NSObjectProtocol)
  optional
    function splitView_canCollapseSubview (splitView: NSSplitView; subview: NSView): boolean; message 'splitView:canCollapseSubview:';
    function splitView_shouldCollapseSubview_forDoubleClickOnDividerAtIndex (splitView: NSSplitView; subview: NSView; dividerIndex: NSInteger): boolean; message 'splitView:shouldCollapseSubview:forDoubleClickOnDividerAtIndex:'; { available in 10_5 }
    function splitView_constrainMinCoordinate_ofSubviewAt (splitView: NSSplitView; proposedMinimumPosition: CGFloat; dividerIndex: NSInteger): CGFloat; message 'splitView:constrainMinCoordinate:ofSubviewAt:';
    function splitView_constrainMaxCoordinate_ofSubviewAt (splitView: NSSplitView; proposedMaximumPosition: CGFloat; dividerIndex: NSInteger): CGFloat; message 'splitView:constrainMaxCoordinate:ofSubviewAt:';
    function splitView_constrainSplitPosition_ofSubviewAt (splitView: NSSplitView; proposedPosition: CGFloat; dividerIndex: NSInteger): CGFloat; message 'splitView:constrainSplitPosition:ofSubviewAt:';
    procedure splitView_resizeSubviewsWithOldSize (splitView: NSSplitView; oldSize: NSSize); message 'splitView:resizeSubviewsWithOldSize:';
    function splitView_shouldAdjustSizeOfSubview (splitView: NSSplitView; view: NSView): boolean; message 'splitView:shouldAdjustSizeOfSubview:'; { available in 10_6 }
    function splitView_shouldHideDividerAtIndex (splitView: NSSplitView; dividerIndex: NSInteger): boolean; message 'splitView:shouldHideDividerAtIndex:'; { available in 10_5 }
    function splitView_effectiveRect_forDrawnRect_ofDividerAtIndex (splitView: NSSplitView; proposedEffectiveRect: NSRect; drawnRect: NSRect; dividerIndex: NSInteger): NSRect; message 'splitView:effectiveRect:forDrawnRect:ofDividerAtIndex:'; { available in 10_5 }
    function splitView_additionalEffectiveRectOfDividerAtIndex (splitView: NSSplitView; dividerIndex: NSInteger): NSRect; message 'splitView:additionalEffectiveRectOfDividerAtIndex:'; { available in 10_5 }
    procedure splitViewWillResizeSubviews (notification: NSNotification); message 'splitViewWillResizeSubviews:';
    procedure splitViewDidResizeSubviews (notification: NSNotification); message 'splitViewDidResizeSubviews:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSSplitViewWillResizeSubviewsNotification: NSString; cvar; external;
  NSSplitViewDidResizeSubviewsNotification: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSSplitView_NSDeprecated = objccategory external name 'NSDeprecated' (NSSplitView)
    procedure setIsPaneSplitter (flag: boolean); message 'setIsPaneSplitter:'; deprecated 'in 10_0, 10_6';
    function isPaneSplitter: boolean; message 'isPaneSplitter'; deprecated 'in 10_0, 10_6';
  end;
{$endif}

