{ Parsed from AppKit.framework (MacOSX10.8) NSTabView.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSTabViewPtr = ^NSTabView;
  NSTabViewDelegateProtocolPtr = ^NSTabViewDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSAppKitVersionNumberWithDirectionalTabs = 631.0;

const
  NSTopTabsBezelBorder = 0;
  NSLeftTabsBezelBorder = 1;
  NSBottomTabsBezelBorder = 2;
  NSRightTabsBezelBorder = 3;
  NSNoTabsBezelBorder = 4;
  NSNoTabsLineBorder = 5;
  NSNoTabsNoBorder = 6;

type
  NSTabViewType = NSUInteger;
  NSTabViewTypePtr = ^NSTabViewType;
{$endif}

{$ifdef CLASSES}

type
  NSTabView = objcclass external (NSView)
  private
    _tabViewItems: id;
    _selectedTabViewItem: NSTabViewItem;
    _font: NSFont;
    _tabViewType: NSTabViewType;
    _allowTruncatedLabels: boolean;
    _delegate: id;
    _tabViewUnusedBOOL1: boolean;
    _drawsBackground: boolean;
    _pressedTabViewItem: NSTabViewItem;
    _endTabWidth: NSInteger;
    _maxOverlap: NSInteger;
    _tabHeight: CGFloat;
    _tabViewItemWithKeyView: NSTabViewItem;
    _originalNextKeyView: NSView;
    __NSTabViewDelegateRespondTo: bitpacked record
      case byte of
        0: (_anonBitField___NSTabViewDelegateRespondTo0: cuint);
        1: (
          shouldSelectTabViewItem: 0..1;
          willSelectTabViewItem: 0..1;
          didSelectTabViewItem: 0..1;
          didChangeNumberOfTabViewItems: 0..1;
          reserved: 0..((1 shl 28)-1);
        );
      end;
    __NSTabViewFlags: bitpacked record
      case byte of
        0: (_anonBitField___NSTabViewFlags0: cuint);
        1: (
          needsLayout: 0..1;
          controlTint_: 0..((1 shl 3)-1);
          controlSize_: 0..((1 shl 2)-1);
          wiringNibConnections: 0..1;
          wiringInteriorLastKeyView: 0..1;
          originalNextKeyViewChanged: 0..1;
          liveResizeSkippedResetToolTips: 0..1;
          subviewsAddedForTabs: 0..1;
          reserved: 0..((1 shl 21)-1);
        );
      end;
    _focusedTabViewItem: NSTabViewItem;
    _tabViewUnused2: pointer;
  public
    procedure selectTabViewItem (tabViewItem: NSTabViewItem); message 'selectTabViewItem:';
    procedure selectTabViewItemAtIndex (index: NSInteger); message 'selectTabViewItemAtIndex:';
    procedure selectTabViewItemWithIdentifier (identifier: id); message 'selectTabViewItemWithIdentifier:';
    procedure takeSelectedTabViewItemFromSender (sender: id); message 'takeSelectedTabViewItemFromSender:';
    procedure selectFirstTabViewItem (sender: id); message 'selectFirstTabViewItem:';
    procedure selectLastTabViewItem (sender: id); message 'selectLastTabViewItem:';
    procedure selectNextTabViewItem (sender: id); message 'selectNextTabViewItem:';
    procedure selectPreviousTabViewItem (sender: id); message 'selectPreviousTabViewItem:';
    function selectedTabViewItem: NSTabViewItem; message 'selectedTabViewItem';
    function font: NSFont; message 'font';
    function tabViewType: NSTabViewType; message 'tabViewType';
    function tabViewItems: NSArray; message 'tabViewItems';
    function allowsTruncatedLabels: boolean; message 'allowsTruncatedLabels';
    function minimumSize: NSSize; message 'minimumSize';
    function drawsBackground: boolean; message 'drawsBackground';
    function controlTint: NSControlTint; message 'controlTint';
    function controlSize: NSControlSize; message 'controlSize';
    procedure setFont (font_: NSFont); message 'setFont:';
    procedure setTabViewType (tabViewType_: NSTabViewType); message 'setTabViewType:';
    procedure setAllowsTruncatedLabels (allowTruncatedLabels: boolean); message 'setAllowsTruncatedLabels:';
    procedure setDrawsBackground (flag: boolean); message 'setDrawsBackground:';
    procedure setControlTint (controlTint_: NSControlTint); message 'setControlTint:';
    procedure setControlSize (controlSize_: NSControlSize); message 'setControlSize:';
    procedure addTabViewItem (tabViewItem: NSTabViewItem); message 'addTabViewItem:';
    procedure insertTabViewItem_atIndex (tabViewItem: NSTabViewItem; index: NSInteger); message 'insertTabViewItem:atIndex:';
    procedure removeTabViewItem (tabViewItem: NSTabViewItem); message 'removeTabViewItem:';
    procedure setDelegate (anObject: NSTabViewDelegateProtocol); message 'setDelegate:';
    function delegate: NSTabViewDelegateProtocol; message 'delegate';
    function tabViewItemAtPoint (point: NSPoint): NSTabViewItem; message 'tabViewItemAtPoint:';
    function contentRect: NSRect; message 'contentRect';
    function numberOfTabViewItems: NSInteger; message 'numberOfTabViewItems';
    function indexOfTabViewItem (tabViewItem: NSTabViewItem): NSInteger; message 'indexOfTabViewItem:';
    function tabViewItemAtIndex (index: NSInteger): NSTabViewItem; message 'tabViewItemAtIndex:';
    function indexOfTabViewItemWithIdentifier (identifier: id): NSInteger; message 'indexOfTabViewItemWithIdentifier:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSTabViewDelegateProtocol = objcprotocol external name 'NSTabViewDelegate' (NSObjectProtocol)
  optional
    function tabView_shouldSelectTabViewItem (tabView: NSTabView; tabViewItem: NSTabViewItem): boolean; message 'tabView:shouldSelectTabViewItem:';
    procedure tabView_willSelectTabViewItem (tabView: NSTabView; tabViewItem: NSTabViewItem); message 'tabView:willSelectTabViewItem:';
    procedure tabView_didSelectTabViewItem (tabView: NSTabView; tabViewItem: NSTabViewItem); message 'tabView:didSelectTabViewItem:';
    procedure tabViewDidChangeNumberOfTabViewItems (tabView: NSTabView); message 'tabViewDidChangeNumberOfTabViewItems:';
  end;
{$endif}

