{ Parsed from AppKit.framework (MacOSX10.8) NSTableColumn.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{ Types from NSTableColumn }
{$ifdef TYPES}

const
  NSTableColumnNoResizing = 0;
  NSTableColumnAutoresizingMask = 1 shl 0;
  NSTableColumnUserResizingMask = 1 shl 1;
{$endif}


{$ifdef TYPES}
type
  NSTableColumnPtr = ^NSTableColumn;
{$endif}

{$ifdef CLASSES}

type
  NSTableColumn = objcclass external (NSObject, NSCodingProtocol, NSUserInterfaceItemIdentificationProtocol)
  private
    _identifier: id;
    _width: CGFloat;
    _minWidth: CGFloat;
    _maxWidth: CGFloat;
    _tableView: NSTableView;
    _headerCell: NSCell;
    _dataCell: NSCell;
    __colFlags: bitpacked record
      case byte of
        0: (_anonBitField___colFlags0: cuint);
        1: (
          oldIsResizable: 0..1;
          isEditable_: 0..1;
          resizedPostingDisableCount: 0..((1 shl 8)-1);
          canUseReorderResizeImageCache: 0..1;
          userResizingAllowed: 0..1;
          autoResizingAllowed: 0..1;
          hidden: 0..1;
          RESERVED: 0..((1 shl 18)-1);
        );
      end;
    _tcAuxiliaryStorage: id;
  public
    function initWithIdentifier (identifier: NSString): id; message 'initWithIdentifier:';
    procedure setIdentifier (identifier: NSString); message 'setIdentifier:';
    function identifier: NSString; message 'identifier';
    procedure setTableView (tableView: NSTableView); message 'setTableView:';
    function tableView: NSTableView; message 'tableView';
    procedure setWidth (width: CGFloat); message 'setWidth:';
    function width: CGFloat; message 'width';
    procedure setMinWidth (minWidth: CGFloat); message 'setMinWidth:';
    function minWidth: CGFloat; message 'minWidth';
    procedure setMaxWidth (maxWidth: CGFloat); message 'setMaxWidth:';
    function maxWidth: CGFloat; message 'maxWidth';
    procedure setHeaderCell (cell: NSCell); message 'setHeaderCell:';
    function headerCell: id; message 'headerCell';
    procedure setDataCell (cell: NSCell); message 'setDataCell:';
    function dataCell: id; message 'dataCell';
    function dataCellForRow (row: NSInteger): id; message 'dataCellForRow:';
    procedure setEditable (flag: boolean); message 'setEditable:';
    function isEditable: boolean; message 'isEditable';
    procedure sizeToFit; message 'sizeToFit';
    procedure setSortDescriptorPrototype (sortDescriptor: NSSortDescriptor); message 'setSortDescriptorPrototype:';
    function sortDescriptorPrototype: NSSortDescriptor; message 'sortDescriptorPrototype';
    procedure setResizingMask (resizingMask: NSUInteger); message 'setResizingMask:';
    function resizingMask: NSUInteger; message 'resizingMask';
    procedure setHeaderToolTip (string_: NSString); message 'setHeaderToolTip:'; { available in 10_5 }
    function headerToolTip: NSString; message 'headerToolTip'; { available in 10_5 }
    function isHidden: boolean; message 'isHidden'; { available in 10_5 }
    procedure setHidden (hidden: boolean); message 'setHidden:'; { available in 10_5 }

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  NSTableColumn_NSDeprecated = objccategory external name 'NSDeprecated' (NSTableColumn)
    procedure setResizable (flag: boolean); message 'setResizable:'; deprecated 'in 10_0, 10_4';
    function isResizable: boolean; message 'isResizable'; deprecated 'in 10_0, 10_4';
  end;
{$endif}

