{ Parsed from AppKit.framework (MacOSX10.8) NSTextAttachment.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSTextAttachmentCellPtr = ^NSTextAttachmentCell;
  NSTextAttachmentPtr = ^NSTextAttachment;
  NSTextAttachmentCellProtocolPtr = ^NSTextAttachmentCellProtocol;
{$endif}

{$ifdef TYPES}
const
  NSAttachmentCharacter = $fffc;
{$endif}

{$ifdef PROTOCOLS}

type
  NSTextAttachmentCellProtocol = objcprotocol external name 'NSTextAttachmentCell' (NSObjectProtocol)
    procedure drawWithFrame_inView (cellFrame: NSRect; controlView: NSView); message 'drawWithFrame:inView:';
    function wantsToTrackMouse: boolean; message 'wantsToTrackMouse';
    procedure highlight_withFrame_inView (flag: boolean; cellFrame: NSRect; controlView: NSView); message 'highlight:withFrame:inView:';
    function trackMouse_inRect_ofView_untilMouseUp (theEvent: NSEvent; cellFrame: NSRect; controlView: NSView; flag: boolean): boolean; message 'trackMouse:inRect:ofView:untilMouseUp:';
    function cellSize: NSSize; message 'cellSize';
    function cellBaselineOffset: NSPoint; message 'cellBaselineOffset';
    procedure setAttachment (anObject: NSTextAttachment); message 'setAttachment:';
    function attachment: NSTextAttachment; message 'attachment';
    procedure drawWithFrame_inView_characterIndex (cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger); message 'drawWithFrame:inView:characterIndex:';
    procedure drawWithFrame_inView_characterIndex_layoutManager (cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger; layoutManager: NSLayoutManager); message 'drawWithFrame:inView:characterIndex:layoutManager:';
    function wantsToTrackMouseForEvent_inRect_ofView_atCharacterIndex (theEvent: NSEvent; cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger): boolean; message 'wantsToTrackMouseForEvent:inRect:ofView:atCharacterIndex:';
    function trackMouse_inRect_ofView_atCharacterIndex_untilMouseUp (theEvent: NSEvent; cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger; flag: boolean): boolean; message 'trackMouse:inRect:ofView:atCharacterIndex:untilMouseUp:';
    function cellFrameForTextContainer_proposedLineFragment_glyphPosition_characterIndex (textContainer: NSTextContainer; lineFrag: NSRect; position: NSPoint; charIndex: NSUInteger): NSRect; message 'cellFrameForTextContainer:proposedLineFragment:glyphPosition:characterIndex:';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSTextAttachmentCell = objcclass external (NSCell, NSTextAttachmentCellProtocol)
  private
    _attachment: NSTextAttachment;

    { Adopted protocols }
    function attachment: NSTextAttachment; message 'attachment';
    function autorelease: id; message 'autorelease';
    function cellBaselineOffset: NSPoint; message 'cellBaselineOffset';
    function cellFrameForTextContainer_proposedLineFragment_glyphPosition_characterIndex (textContainer: NSTextContainer; lineFrag: NSRect; position: NSPoint; charIndex: NSUInteger): NSRect; message 'cellFrameForTextContainer:proposedLineFragment:glyphPosition:characterIndex:';
    function class_: pobjc_class; message 'class';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    procedure drawWithFrame_inView_characterIndex (cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger); message 'drawWithFrame:inView:characterIndex:';
    procedure drawWithFrame_inView_characterIndex_layoutManager (cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger; layoutManager: NSLayoutManager); message 'drawWithFrame:inView:characterIndex:layoutManager:';
    function hash: NSUInteger; message 'hash';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function isProxy: boolean; message 'isProxy';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    procedure release; message 'release';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    function retainCount: NSUInteger; message 'retainCount';
    function self_: id; message 'self';
    procedure setAttachment (anObject: NSTextAttachment); message 'setAttachment:';
    function superclass: pobjc_class; message 'superclass';
    function trackMouse_inRect_ofView_atCharacterIndex_untilMouseUp (theEvent: NSEvent; cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger; flag: boolean): boolean; message 'trackMouse:inRect:ofView:atCharacterIndex:untilMouseUp:';
    function wantsToTrackMouse: boolean; message 'wantsToTrackMouse';
    function wantsToTrackMouseForEvent_inRect_ofView_atCharacterIndex (theEvent: NSEvent; cellFrame: NSRect; controlView: NSView; charIndex: NSUInteger): boolean; message 'wantsToTrackMouseForEvent:inRect:ofView:atCharacterIndex:';
    function zone: NSZonePtr; message 'zone';
  end;

type
  NSTextAttachment = objcclass external (NSObject, NSCodingProtocol)
  private
    _fileWrapper: NSFileWrapper;
    _flags: bitpacked record
      case byte of
        0: (_anonBitField__flags0: cuint);
        1: (
          cellWasExplicitlySet: 0..1;
          ignoresOrientation: 0..1;
          int: 0..((1 shl 30)-1);
        );
      end;
  public
    function initWithFileWrapper (fileWrapper: NSFileWrapper): id; message 'initWithFileWrapper:';
    procedure setFileWrapper (fileWrapper: NSFileWrapper); message 'setFileWrapper:';
    function fileWrapper: NSFileWrapper; message 'fileWrapper';
    function attachmentCell: NSTextAttachmentCellProtocol; message 'attachmentCell';
    procedure setAttachmentCell (cell: NSTextAttachmentCellProtocol); message 'setAttachmentCell:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  NSAttributedStringAttachmentConveniences = objccategory external (NSAttributedString)
    class function attributedStringWithAttachment (attachment: NSTextAttachment): NSAttributedString; message 'attributedStringWithAttachment:';
  end;

type
  NSMutableAttributedStringAttachmentConveniences = objccategory external (NSMutableAttributedString)
    procedure updateAttachmentsFromPath (path: NSString); message 'updateAttachmentsFromPath:';
  end;
{$endif}

