{ Parsed from AppKit.framework (MacOSX10.8) NSTextContainer.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSTextContainerPtr = ^NSTextContainer;
{$endif}

{$ifdef TYPES}
const
  NSLineSweepLeft = 0;
  NSLineSweepRight = 1;
  NSLineSweepDown = 2;
  NSLineSweepUp = 3;

type
  NSLineSweepDirection = NSUInteger;
  NSLineSweepDirectionPtr = ^NSLineSweepDirection;

const
  NSLineDoesntMove = 0;
  NSLineMovesLeft = 1;
  NSLineMovesRight = 2;
  NSLineMovesDown = 3;
  NSLineMovesUp = 4;

type
  NSLineMovementDirection = NSUInteger;
  NSLineMovementDirectionPtr = ^NSLineMovementDirection;
{$endif}

{$ifdef CLASSES}

type
  NSTextContainer = objcclass external (NSObject, NSCodingProtocol, NSTextLayoutOrientationProviderProtocol)
  private
    _layoutManager: NSLayoutManager;
    _textView: NSTextView;
    _size: NSSize;
    _lineFragmentPadding: CGFloat;
    __tcFlags: bitpacked record
      case byte of
        0: (_anonBitField___tcFlags0: cuint);
        1: (
          widthTracksTextView_: 0..1;
          heightTracksTextView_: 0..1;
          observingFrameChanges: 0..1;
          _reserved: 0..((1 shl 13)-1);
        );
      end;
  public
    function initWithContainerSize (size: NSSize): id; message 'initWithContainerSize:';
    function layoutManager: NSLayoutManager; message 'layoutManager';
    procedure setLayoutManager (layoutManager_: NSLayoutManager); message 'setLayoutManager:';
    procedure replaceLayoutManager (newLayoutManager: NSLayoutManager); message 'replaceLayoutManager:';
    function textView: NSTextView; message 'textView';
    procedure setTextView (textView_: NSTextView); message 'setTextView:';
    procedure setWidthTracksTextView (flag: boolean); message 'setWidthTracksTextView:';
    function widthTracksTextView: boolean; message 'widthTracksTextView';
    procedure setHeightTracksTextView (flag: boolean); message 'setHeightTracksTextView:';
    function heightTracksTextView: boolean; message 'heightTracksTextView';
    procedure setContainerSize (size: NSSize); message 'setContainerSize:';
    function containerSize: NSSize; message 'containerSize';
    procedure setLineFragmentPadding (pad: CGFloat); message 'setLineFragmentPadding:';
    function lineFragmentPadding: CGFloat; message 'lineFragmentPadding';
    function lineFragmentRectForProposedRect_sweepDirection_movementDirection_remainingRect (proposedRect: NSRect; sweepDirection: NSLineSweepDirection; movementDirection: NSLineMovementDirection; remainingRect: NSRectPointer): NSRect; message 'lineFragmentRectForProposedRect:sweepDirection:movementDirection:remainingRect:';
    function isSimpleRectangularTextContainer: boolean; message 'isSimpleRectangularTextContainer';
    function containsPoint (point: NSPoint): boolean; message 'containsPoint:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function layoutOrientation: NSTextLayoutOrientation; message 'layoutOrientation'; { available in 10_7 }
  end;
{$endif}

