{ Parsed from AppKit.framework (MacOSX10.8) NSTextField.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSTextFieldPtr = ^NSTextField;
  NSTextFieldDelegateProtocolPtr = ^NSTextFieldDelegateProtocol;
{$endif}

{$ifdef CLASSES}

type
  NSTextField = objcclass external (NSControl, NSUserInterfaceValidationsProtocol)
  private
    _delegate: id;
    _errorAction: SEL;
    {$if defined(__LP64__)}
    _maxLayoutWidth: CGFloat;
    {$endif}
  public
    procedure setBackgroundColor (color: NSColor); message 'setBackgroundColor:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setDrawsBackground (flag: boolean); message 'setDrawsBackground:';
    function drawsBackground: boolean; message 'drawsBackground';
    procedure setTextColor (color: NSColor); message 'setTextColor:';
    function textColor: NSColor; message 'textColor';
    function isBordered: boolean; message 'isBordered';
    procedure setBordered (flag: boolean); message 'setBordered:';
    function isBezeled: boolean; message 'isBezeled';
    procedure setBezeled (flag: boolean); message 'setBezeled:';
    function isEditable: boolean; message 'isEditable';
    procedure setEditable (flag: boolean); message 'setEditable:';
    function isSelectable: boolean; message 'isSelectable';
    procedure setSelectable (flag: boolean); message 'setSelectable:';
    procedure selectText (sender: id); message 'selectText:';
    function delegate: NSTextFieldDelegateProtocol; message 'delegate';
    procedure setDelegate (anObject: NSTextFieldDelegateProtocol); message 'setDelegate:';
    function textShouldBeginEditing (textObject: NSText): boolean; message 'textShouldBeginEditing:';
    function textShouldEndEditing (textObject: NSText): boolean; message 'textShouldEndEditing:';
    procedure textDidBeginEditing (notification: NSNotification); message 'textDidBeginEditing:';
    procedure textDidEndEditing (notification: NSNotification); message 'textDidEndEditing:';
    procedure textDidChange (notification: NSNotification); message 'textDidChange:';
    function acceptsFirstResponder: boolean; message 'acceptsFirstResponder';
    procedure setBezelStyle (style: NSTextFieldBezelStyle); message 'setBezelStyle:';
    function bezelStyle: NSTextFieldBezelStyle; message 'bezelStyle';
    procedure setPreferredMaxLayoutWidth (width: CGFloat); message 'setPreferredMaxLayoutWidth:'; { available in 10_8 }
    function preferredMaxLayoutWidth: CGFloat; message 'preferredMaxLayoutWidth'; { available in 10_8 }

    { Adopted protocols }
    function validateUserInterfaceItem (anItem: NSValidatedUserInterfaceItemProtocol): boolean; message 'validateUserInterfaceItem:';
  end;


type
  NSTextFieldAttributedStringMethods = objccategory external (NSTextField)
    function allowsEditingTextAttributes: boolean; message 'allowsEditingTextAttributes';
    procedure setAllowsEditingTextAttributes (flag: boolean); message 'setAllowsEditingTextAttributes:';
    function importsGraphics: boolean; message 'importsGraphics';
    procedure setImportsGraphics (flag: boolean); message 'setImportsGraphics:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSTextFieldDelegateProtocol = objcprotocol external name 'NSTextFieldDelegate' (NSControlTextEditingDelegateProtocol)
  end;
{$endif}

{$ifdef CLASSES}

type
  NSTextField_NSDeprecated = objccategory external name 'NSDeprecated' (NSTextField)
    procedure setTitleWithMnemonic (stringWithAmpersand: NSString); message 'setTitleWithMnemonic:'; deprecated 'in 10_0, 10_8';
  end;
{$endif}

