{ Parsed from AppKit.framework (MacOSX10.8) NSTextView.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{ Types from NSTextViewDelegateProtocol }
{$ifdef TYPES}

{$endif}


{$ifdef TYPES}
type
  NSTextViewPtr = ^NSTextView;
  NSTextViewDelegateProtocolPtr = ^NSTextViewDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSSelectByCharacter = 0;
  NSSelectByWord = 1;
  NSSelectByParagraph = 2;

type
  NSSelectionGranularity = NSUInteger;
  NSSelectionGranularityPtr = ^NSSelectionGranularity;

const
  NSSelectionAffinityUpstream = 0;
  NSSelectionAffinityDownstream = 1;

type
  NSSelectionAffinity = NSUInteger;
  NSSelectionAffinityPtr = ^NSSelectionAffinity;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSAllRomanInputSourcesLocaleIdentifier: NSString { available in 10_5 }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSTextView = objcclass external (NSText, NSTextInputProtocol, NSUserInterfaceValidationsProtocol, NSTextInputClientProtocol, NSTextLayoutOrientationProviderProtocol, NSDraggingSourceProtocol)
  public
    function initWithFrame_textContainer (frameRect: NSRect; container: NSTextContainer): id; message 'initWithFrame:textContainer:';
    function initWithFrame (frameRect: NSRect): id; message 'initWithFrame:';
    function textContainer: NSTextContainer; message 'textContainer';
    procedure setTextContainer (container: NSTextContainer); message 'setTextContainer:';
    procedure replaceTextContainer (newContainer: NSTextContainer); message 'replaceTextContainer:';
    procedure setTextContainerInset (inset: NSSize); message 'setTextContainerInset:';
    function textContainerInset: NSSize; message 'textContainerInset';
    function textContainerOrigin: NSPoint; message 'textContainerOrigin';
    procedure invalidateTextContainerOrigin; message 'invalidateTextContainerOrigin';
    function layoutManager: NSLayoutManager; message 'layoutManager';
    function textStorage: NSTextStorage; message 'textStorage';
    procedure insertText (insertString: id); message 'insertText:';
    procedure setConstrainedFrameSize (desiredSize: NSSize); message 'setConstrainedFrameSize:';
    procedure setAlignment_range (alignment_: NSTextAlignment; range: NSRange); message 'setAlignment:range:';
    procedure setBaseWritingDirection_range (writingDirection: NSWritingDirection; range: NSRange); message 'setBaseWritingDirection:range:';
    procedure turnOffKerning (sender: id); message 'turnOffKerning:';
    procedure tightenKerning (sender: id); message 'tightenKerning:';
    procedure loosenKerning (sender: id); message 'loosenKerning:';
    procedure useStandardKerning (sender: id); message 'useStandardKerning:';
    procedure turnOffLigatures (sender: id); message 'turnOffLigatures:';
    procedure useStandardLigatures (sender: id); message 'useStandardLigatures:';
    procedure useAllLigatures (sender: id); message 'useAllLigatures:';
    procedure raiseBaseline (sender: id); message 'raiseBaseline:';
    procedure lowerBaseline (sender: id); message 'lowerBaseline:';
    procedure toggleTraditionalCharacterShape (sender: id); message 'toggleTraditionalCharacterShape:';
    procedure outline (sender: id); message 'outline:';
    procedure performFindPanelAction (sender: id); message 'performFindPanelAction:';
    procedure alignJustified (sender: id); message 'alignJustified:';
    procedure changeColor (sender: id); message 'changeColor:';
    procedure changeAttributes (sender: id); message 'changeAttributes:';
    procedure changeDocumentBackgroundColor (sender: id); message 'changeDocumentBackgroundColor:';
    procedure orderFrontSpacingPanel (sender: id); message 'orderFrontSpacingPanel:';
    procedure orderFrontLinkPanel (sender: id); message 'orderFrontLinkPanel:';
    procedure orderFrontListPanel (sender: id); message 'orderFrontListPanel:';
    procedure orderFrontTablePanel (sender: id); message 'orderFrontTablePanel:';
    procedure rulerView_didMoveMarker (ruler: NSRulerView; marker: NSRulerMarker); message 'rulerView:didMoveMarker:';
    procedure rulerView_didRemoveMarker (ruler: NSRulerView; marker: NSRulerMarker); message 'rulerView:didRemoveMarker:';
    procedure rulerView_didAddMarker (ruler: NSRulerView; marker: NSRulerMarker); message 'rulerView:didAddMarker:';
    function rulerView_shouldMoveMarker (ruler: NSRulerView; marker: NSRulerMarker): boolean; message 'rulerView:shouldMoveMarker:';
    function rulerView_shouldAddMarker (ruler: NSRulerView; marker: NSRulerMarker): boolean; message 'rulerView:shouldAddMarker:';
    function rulerView_willMoveMarker_toLocation (ruler: NSRulerView; marker: NSRulerMarker; location: CGFloat): CGFloat; message 'rulerView:willMoveMarker:toLocation:';
    function rulerView_shouldRemoveMarker (ruler: NSRulerView; marker: NSRulerMarker): boolean; message 'rulerView:shouldRemoveMarker:';
    function rulerView_willAddMarker_atLocation (ruler: NSRulerView; marker: NSRulerMarker; location: CGFloat): CGFloat; message 'rulerView:willAddMarker:atLocation:';
    procedure rulerView_handleMouseDown (ruler: NSRulerView; event: NSEvent); message 'rulerView:handleMouseDown:';
    procedure setNeedsDisplayInRect_avoidAdditionalLayout (rect: NSRect; flag: boolean); message 'setNeedsDisplayInRect:avoidAdditionalLayout:';
    function shouldDrawInsertionPoint: boolean; message 'shouldDrawInsertionPoint';
    procedure drawInsertionPointInRect_color_turnedOn (rect: NSRect; color: NSColor; flag: boolean); message 'drawInsertionPointInRect:color:turnedOn:';
    procedure drawViewBackgroundInRect (rect: NSRect); message 'drawViewBackgroundInRect:';
    procedure updateRuler; message 'updateRuler';
    procedure updateFontPanel; message 'updateFontPanel';
    procedure updateDragTypeRegistration; message 'updateDragTypeRegistration';
    function selectionRangeForProposedRange_granularity (proposedCharRange: NSRange; granularity: NSSelectionGranularity): NSRange; message 'selectionRangeForProposedRange:granularity:';
    procedure clickedOnLink_atIndex (link: id; charIndex: NSUInteger); message 'clickedOnLink:atIndex:';
    procedure startSpeaking (sender: id); message 'startSpeaking:';
    procedure stopSpeaking (sender: id); message 'stopSpeaking:';
    procedure setLayoutOrientation (theOrientation: NSTextLayoutOrientation); message 'setLayoutOrientation:'; { available in 10_7 }
    procedure changeLayoutOrientation (sender: id); message 'changeLayoutOrientation:'; { available in 10_7 }
    function characterIndexForInsertionAtPoint (point: NSPoint): NSUInteger; message 'characterIndexForInsertionAtPoint:'; { available in 10_5 }

    { Adopted protocols }
    function attributedString: NSAttributedString; message 'attributedString';
    function attributedSubstringForProposedRange_actualRange (aRange: NSRange; actualRange: NSRangePointer): NSAttributedString; message 'attributedSubstringForProposedRange:actualRange:';
    function attributedSubstringFromRange (theRange: NSRange): NSAttributedString; message 'attributedSubstringFromRange:';
    function baselineDeltaForCharacterAtIndex (anIndex: NSUInteger): CGFloat; message 'baselineDeltaForCharacterAtIndex:';
    function characterIndexForPoint (thePoint: NSPoint): NSUInteger; message 'characterIndexForPoint:';
    function conversationIdentifier: NSInteger; message 'conversationIdentifier';
    procedure doCommandBySelector (aSelector: SEL); message 'doCommandBySelector:';
    procedure draggingSession_endedAtPoint_operation (session: NSDraggingSession; screenPoint: NSPoint; operation: NSDragOperation); message 'draggingSession:endedAtPoint:operation:';
    procedure draggingSession_movedToPoint (session: NSDraggingSession; screenPoint: NSPoint); message 'draggingSession:movedToPoint:';
    function draggingSession_sourceOperationMaskForDraggingContext (session: NSDraggingSession; context: NSDraggingContext): NSDragOperation; message 'draggingSession:sourceOperationMaskForDraggingContext:';
    procedure draggingSession_willBeginAtPoint (session: NSDraggingSession; screenPoint: NSPoint); message 'draggingSession:willBeginAtPoint:';
    function drawsVerticallyForCharacterAtIndex (charIndex: NSUInteger): boolean; message 'drawsVerticallyForCharacterAtIndex:'; { available in 10_6 }
    function firstRectForCharacterRange (theRange: NSRange): NSRect; message 'firstRectForCharacterRange:';
    function firstRectForCharacterRange_actualRange (aRange: NSRange; actualRange: NSRangePointer): NSRect; message 'firstRectForCharacterRange:actualRange:';
    function fractionOfDistanceThroughGlyphForPoint (aPoint: NSPoint): CGFloat; message 'fractionOfDistanceThroughGlyphForPoint:';
    function hasMarkedText: boolean; message 'hasMarkedText';
    function ignoreModifierKeysForDraggingSession (session: NSDraggingSession): boolean; message 'ignoreModifierKeysForDraggingSession:';
    procedure insertText_replacementRange (aString: id; replacementRange: NSRange); message 'insertText:replacementRange:';
    function layoutOrientation: NSTextLayoutOrientation; message 'layoutOrientation'; { available in 10_7 }
    function markedRange: NSRange; message 'markedRange';
    procedure setMarkedText_selectedRange (aString: id; selRange: NSRange); message 'setMarkedText:selectedRange:';
    procedure setMarkedText_selectedRange_replacementRange (aString: id; selectedRange: NSRange; replacementRange: NSRange); message 'setMarkedText:selectedRange:replacementRange:';
    procedure unmarkText; message 'unmarkText';
    function validateUserInterfaceItem (anItem: NSValidatedUserInterfaceItemProtocol): boolean; message 'validateUserInterfaceItem:';
    function validAttributesForMarkedText: NSArray; message 'validAttributesForMarkedText';
    function windowLevel: NSInteger; message 'windowLevel';
  end;


type
  NSCompletion = objccategory external (NSTextView)
    procedure complete (sender: id); message 'complete:';
    function rangeForUserCompletion: NSRange; message 'rangeForUserCompletion';
    function completionsForPartialWordRange_indexOfSelectedItem (charRange: NSRange; index: NSIntegerPtr): NSArray; message 'completionsForPartialWordRange:indexOfSelectedItem:';
    procedure insertCompletion_forPartialWordRange_movement_isFinal (word: NSString; charRange: NSRange; movement: NSInteger; flag: boolean); message 'insertCompletion:forPartialWordRange:movement:isFinal:';
  end;

type
  NSTextView_NSPasteboard = objccategory external name 'NSPasteboard' (NSTextView)
    function writablePasteboardTypes: NSArray; message 'writablePasteboardTypes';
    function writeSelectionToPasteboard_type (pboard: NSPasteboard; type_: NSString): boolean; message 'writeSelectionToPasteboard:type:';
    function writeSelectionToPasteboard_types (pboard: NSPasteboard; types: NSArray): boolean; message 'writeSelectionToPasteboard:types:';
    function readablePasteboardTypes: NSArray; message 'readablePasteboardTypes';
    function preferredPasteboardTypeFromArray_restrictedToTypesFromArray (availableTypes: NSArray; allowedTypes: NSArray): NSString; message 'preferredPasteboardTypeFromArray:restrictedToTypesFromArray:';
    function readSelectionFromPasteboard_type (pboard: NSPasteboard; type_: NSString): boolean; message 'readSelectionFromPasteboard:type:';
    function readSelectionFromPasteboard (pboard: NSPasteboard): boolean; message 'readSelectionFromPasteboard:';
    class procedure registerForServices; message 'registerForServices';
    function validRequestorForSendType_returnType (sendType: NSString; returnType: NSString): id; message 'validRequestorForSendType:returnType:';
    procedure pasteAsPlainText (sender: id); message 'pasteAsPlainText:';
    procedure pasteAsRichText (sender: id); message 'pasteAsRichText:';
  end;

type
  NSDragging = objccategory external (NSTextView)
    function dragSelectionWithEvent_offset_slideBack (event: NSEvent; mouseOffset: NSSize; slideBack: boolean): boolean; message 'dragSelectionWithEvent:offset:slideBack:';
    function dragImageForSelectionWithEvent_origin (event: NSEvent; origin: NSPointPointer): NSImage; message 'dragImageForSelectionWithEvent:origin:';
    function acceptableDragTypes: NSArray; message 'acceptableDragTypes';
    function dragOperationForDraggingInfo_type (dragInfo: NSDraggingInfoProtocol; type_: NSString): NSDragOperation; message 'dragOperationForDraggingInfo:type:';
    procedure cleanUpAfterDragOperation; message 'cleanUpAfterDragOperation';
  end;

type
  NSSharing = objccategory external (NSTextView)
    function selectedRanges: NSArray; message 'selectedRanges';
    procedure setSelectedRanges_affinity_stillSelecting (ranges: NSArray; affinity: NSSelectionAffinity; stillSelectingFlag: boolean); message 'setSelectedRanges:affinity:stillSelecting:';
    procedure setSelectedRanges (ranges: NSArray); message 'setSelectedRanges:';
    procedure setSelectedRange_affinity_stillSelecting (charRange: NSRange; affinity: NSSelectionAffinity; stillSelectingFlag: boolean); message 'setSelectedRange:affinity:stillSelecting:';
    function selectionAffinity: NSSelectionAffinity; message 'selectionAffinity';
    function selectionGranularity: NSSelectionGranularity; message 'selectionGranularity';
    procedure setSelectionGranularity (granularity: NSSelectionGranularity); message 'setSelectionGranularity:';
    procedure setSelectedTextAttributes (attributeDictionary: NSDictionary); message 'setSelectedTextAttributes:';
    function selectedTextAttributes: NSDictionary; message 'selectedTextAttributes';
    procedure setInsertionPointColor (color: NSColor); message 'setInsertionPointColor:';
    function insertionPointColor: NSColor; message 'insertionPointColor';
    procedure updateInsertionPointStateAndRestartTimer (restartFlag: boolean); message 'updateInsertionPointStateAndRestartTimer:';
    procedure setMarkedTextAttributes (attributeDictionary: NSDictionary); message 'setMarkedTextAttributes:';
    function markedTextAttributes: NSDictionary; message 'markedTextAttributes';
    procedure setLinkTextAttributes (attributeDictionary: NSDictionary); message 'setLinkTextAttributes:';
    function linkTextAttributes: NSDictionary; message 'linkTextAttributes';
    function displaysLinkToolTips: boolean; message 'displaysLinkToolTips'; { available in 10_5 }
    procedure setDisplaysLinkToolTips (flag: boolean); message 'setDisplaysLinkToolTips:'; { available in 10_5 }
    function acceptsGlyphInfo: boolean; message 'acceptsGlyphInfo';
    procedure setAcceptsGlyphInfo (flag: boolean); message 'setAcceptsGlyphInfo:';
    procedure setRulerVisible (flag: boolean); message 'setRulerVisible:';
    function usesRuler: boolean; message 'usesRuler';
    procedure setUsesRuler (flag: boolean); message 'setUsesRuler:';
    function usesInspectorBar: boolean; message 'usesInspectorBar'; { available in 10_7 }
    procedure setUsesInspectorBar (flag: boolean); message 'setUsesInspectorBar:'; { available in 10_7 }
    procedure setContinuousSpellCheckingEnabled (flag: boolean); message 'setContinuousSpellCheckingEnabled:';
    function isContinuousSpellCheckingEnabled: boolean; message 'isContinuousSpellCheckingEnabled';
    procedure toggleContinuousSpellChecking (sender: id); message 'toggleContinuousSpellChecking:';
    function spellCheckerDocumentTag: NSInteger; message 'spellCheckerDocumentTag';
    procedure setGrammarCheckingEnabled (flag: boolean); message 'setGrammarCheckingEnabled:'; { available in 10_5 }
    function isGrammarCheckingEnabled: boolean; message 'isGrammarCheckingEnabled'; { available in 10_5 }
    procedure toggleGrammarChecking (sender: id); message 'toggleGrammarChecking:'; { available in 10_5 }
    procedure setSpellingState_range (value: NSInteger; charRange: NSRange); message 'setSpellingState:range:'; { available in 10_5 }
    function typingAttributes: NSDictionary; message 'typingAttributes';
    procedure setTypingAttributes (attrs: NSDictionary); message 'setTypingAttributes:';
    function shouldChangeTextInRanges_replacementStrings (affectedRanges: NSArray; replacementStrings: NSArray): boolean; message 'shouldChangeTextInRanges:replacementStrings:';
    function rangesForUserTextChange: NSArray; message 'rangesForUserTextChange';
    function rangesForUserCharacterAttributeChange: NSArray; message 'rangesForUserCharacterAttributeChange';
    function rangesForUserParagraphAttributeChange: NSArray; message 'rangesForUserParagraphAttributeChange';
    function shouldChangeTextInRange_replacementString (affectedCharRange: NSRange; replacementString: NSString): boolean; message 'shouldChangeTextInRange:replacementString:';
    procedure didChangeText; message 'didChangeText';
    function rangeForUserTextChange: NSRange; message 'rangeForUserTextChange';
    function rangeForUserCharacterAttributeChange: NSRange; message 'rangeForUserCharacterAttributeChange';
    function rangeForUserParagraphAttributeChange: NSRange; message 'rangeForUserParagraphAttributeChange';
    procedure setAllowsDocumentBackgroundColorChange (flag: boolean); message 'setAllowsDocumentBackgroundColorChange:';
    function allowsDocumentBackgroundColorChange: boolean; message 'allowsDocumentBackgroundColorChange';
    procedure setDefaultParagraphStyle (paragraphStyle: NSParagraphStyle); message 'setDefaultParagraphStyle:';
    function defaultParagraphStyle: NSParagraphStyle; message 'defaultParagraphStyle';
    procedure setAllowsUndo (flag: boolean); message 'setAllowsUndo:';
    function allowsUndo: boolean; message 'allowsUndo';
    procedure breakUndoCoalescing; message 'breakUndoCoalescing';
    function isCoalescingUndo: boolean; message 'isCoalescingUndo'; { available in 10_6 }
    function allowsImageEditing: boolean; message 'allowsImageEditing'; { available in 10_5 }
    procedure setAllowsImageEditing (flag: boolean); message 'setAllowsImageEditing:'; { available in 10_5 }
    procedure showFindIndicatorForRange (charRange: NSRange); message 'showFindIndicatorForRange:'; { available in 10_5 }
    function delegate: NSTextViewDelegateProtocol; message 'delegate';
    procedure setDelegate (anObject: NSTextViewDelegateProtocol); message 'setDelegate:';
    function isEditable: boolean; message 'isEditable';
    procedure setEditable (flag: boolean); message 'setEditable:';
    function isSelectable: boolean; message 'isSelectable';
    procedure setSelectable (flag: boolean); message 'setSelectable:';
    function isRichText: boolean; message 'isRichText';
    procedure setRichText (flag: boolean); message 'setRichText:';
    function importsGraphics: boolean; message 'importsGraphics';
    procedure setImportsGraphics (flag: boolean); message 'setImportsGraphics:';
    function drawsBackground: boolean; message 'drawsBackground';
    procedure setDrawsBackground (flag: boolean); message 'setDrawsBackground:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setBackgroundColor (color: NSColor); message 'setBackgroundColor:';
    function isFieldEditor: boolean; message 'isFieldEditor';
    procedure setFieldEditor (flag: boolean); message 'setFieldEditor:';
    function usesFontPanel: boolean; message 'usesFontPanel';
    procedure setUsesFontPanel (flag: boolean); message 'setUsesFontPanel:';
    function isRulerVisible: boolean; message 'isRulerVisible';
    procedure setSelectedRange (charRange: NSRange); message 'setSelectedRange:';
    function allowedInputSourceLocales: NSArray; message 'allowedInputSourceLocales'; { available in 10_5 }
    procedure setAllowedInputSourceLocales (localeIdentifiers: NSArray); message 'setAllowedInputSourceLocales:'; { available in 10_5 }
  end;

type
  NSTextChecking = objccategory external (NSTextView)
    function smartInsertDeleteEnabled: boolean; message 'smartInsertDeleteEnabled';
    procedure setSmartInsertDeleteEnabled (flag: boolean); message 'setSmartInsertDeleteEnabled:';
    function smartDeleteRangeForProposedRange (proposedCharRange: NSRange): NSRange; message 'smartDeleteRangeForProposedRange:';
    procedure toggleSmartInsertDelete (sender: id); message 'toggleSmartInsertDelete:';
    procedure smartInsertForString_replacingRange_beforeString_afterString (pasteString: NSString; charRangeToReplace: NSRange; beforeString: NSStringPtr; afterString: NSStringPtr); message 'smartInsertForString:replacingRange:beforeString:afterString:';
    function smartInsertBeforeStringForString_replacingRange (pasteString: NSString; charRangeToReplace: NSRange): NSString; message 'smartInsertBeforeStringForString:replacingRange:';
    function smartInsertAfterStringForString_replacingRange (pasteString: NSString; charRangeToReplace: NSRange): NSString; message 'smartInsertAfterStringForString:replacingRange:';
    procedure setAutomaticQuoteSubstitutionEnabled (flag: boolean); message 'setAutomaticQuoteSubstitutionEnabled:'; { available in 10_5 }
    function isAutomaticQuoteSubstitutionEnabled: boolean; message 'isAutomaticQuoteSubstitutionEnabled'; { available in 10_5 }
    procedure toggleAutomaticQuoteSubstitution (sender: id); message 'toggleAutomaticQuoteSubstitution:'; { available in 10_5 }
    procedure setAutomaticLinkDetectionEnabled (flag: boolean); message 'setAutomaticLinkDetectionEnabled:'; { available in 10_5 }
    function isAutomaticLinkDetectionEnabled: boolean; message 'isAutomaticLinkDetectionEnabled'; { available in 10_5 }
    procedure toggleAutomaticLinkDetection (sender: id); message 'toggleAutomaticLinkDetection:'; { available in 10_5 }
    procedure setAutomaticDataDetectionEnabled (flag: boolean); message 'setAutomaticDataDetectionEnabled:'; { available in 10_6 }
    function isAutomaticDataDetectionEnabled: boolean; message 'isAutomaticDataDetectionEnabled'; { available in 10_6 }
    procedure toggleAutomaticDataDetection (sender: id); message 'toggleAutomaticDataDetection:'; { available in 10_6 }
    procedure setAutomaticDashSubstitutionEnabled (flag: boolean); message 'setAutomaticDashSubstitutionEnabled:'; { available in 10_6 }
    function isAutomaticDashSubstitutionEnabled: boolean; message 'isAutomaticDashSubstitutionEnabled'; { available in 10_6 }
    procedure toggleAutomaticDashSubstitution (sender: id); message 'toggleAutomaticDashSubstitution:'; { available in 10_6 }
    procedure setAutomaticTextReplacementEnabled (flag: boolean); message 'setAutomaticTextReplacementEnabled:'; { available in 10_6 }
    function isAutomaticTextReplacementEnabled: boolean; message 'isAutomaticTextReplacementEnabled'; { available in 10_6 }
    procedure toggleAutomaticTextReplacement (sender: id); message 'toggleAutomaticTextReplacement:'; { available in 10_6 }
    procedure setAutomaticSpellingCorrectionEnabled (flag: boolean); message 'setAutomaticSpellingCorrectionEnabled:'; { available in 10_6 }
    function isAutomaticSpellingCorrectionEnabled: boolean; message 'isAutomaticSpellingCorrectionEnabled'; { available in 10_6 }
    procedure toggleAutomaticSpellingCorrection (sender: id); message 'toggleAutomaticSpellingCorrection:'; { available in 10_6 }
    function enabledTextCheckingTypes: NSTextCheckingTypes; message 'enabledTextCheckingTypes'; { available in 10_6 }
    procedure setEnabledTextCheckingTypes (checkingTypes: NSTextCheckingTypes); message 'setEnabledTextCheckingTypes:'; { available in 10_6 }
    procedure checkTextInRange_types_options (range: NSRange; checkingTypes: NSTextCheckingTypes; options: NSDictionary); message 'checkTextInRange:types:options:'; { available in 10_6 }
    procedure handleTextCheckingResults_forRange_types_options_orthography_wordCount (results: NSArray; range: NSRange; checkingTypes: NSTextCheckingTypes; options: NSDictionary; orthography: NSOrthography; wordCount: NSInteger); message 'handleTextCheckingResults:forRange:types:options:orthography:wordCount:'; { available in 10_6 }
    procedure orderFrontSubstitutionsPanel (sender: id); message 'orderFrontSubstitutionsPanel:'; { available in 10_6 }
    procedure checkTextInSelection (sender: id); message 'checkTextInSelection:'; { available in 10_6 }
    procedure checkTextInDocument (sender: id); message 'checkTextInDocument:'; { available in 10_6 }
    procedure setUsesFindPanel (flag: boolean); message 'setUsesFindPanel:';
    function usesFindPanel: boolean; message 'usesFindPanel';
    procedure setUsesFindBar (flag: boolean); message 'setUsesFindBar:'; { available in 10_7 }
    function usesFindBar: boolean; message 'usesFindBar'; { available in 10_7 }
    procedure setIncrementalSearchingEnabled (flag: boolean); message 'setIncrementalSearchingEnabled:'; { available in 10_7 }
    function isIncrementalSearchingEnabled: boolean; message 'isIncrementalSearchingEnabled'; { available in 10_7 }
  end;

type
  NSQuickLookPreview = objccategory external (NSTextView)
    procedure toggleQuickLookPreviewPanel (sender: id); message 'toggleQuickLookPreviewPanel:'; { available in 10_7 }
    function quickLookPreviewableItemsInRanges (ranges: NSArray): NSArray; message 'quickLookPreviewableItemsInRanges:'; { available in 10_7 }
    procedure updateQuickLookPreviewPanel; message 'updateQuickLookPreviewPanel'; { available in 10_7 }
  end;

type
  NSTextView_SharingService = objccategory external (NSTextView)
    procedure orderFrontSharingServicePicker (sender: id); message 'orderFrontSharingServicePicker:'; { available in 10_8 }
  end;

type
  NSTextView_NSDeprecated = objccategory external name 'NSDeprecated' (NSTextView)
    procedure toggleBaseWritingDirection (sender: id); message 'toggleBaseWritingDirection:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSTextViewDelegateProtocol = objcprotocol external name 'NSTextViewDelegate' (NSTextDelegateProtocol)
  optional
    function textView_clickedOnLink_atIndex (textView: NSTextView; link: id; charIndex: NSUInteger): boolean; message 'textView:clickedOnLink:atIndex:';
    procedure textView_clickedOnCell_inRect_atIndex (textView: NSTextView; cell: NSTextAttachmentCellProtocol; cellFrame: NSRect; charIndex: NSUInteger); message 'textView:clickedOnCell:inRect:atIndex:';
    procedure textView_doubleClickedOnCell_inRect_atIndex (textView: NSTextView; cell: NSTextAttachmentCellProtocol; cellFrame: NSRect; charIndex: NSUInteger); message 'textView:doubleClickedOnCell:inRect:atIndex:';
    procedure textView_draggedCell_inRect_event_atIndex (view: NSTextView; cell: NSTextAttachmentCellProtocol; rect: NSRect; event: NSEvent; charIndex: NSUInteger); message 'textView:draggedCell:inRect:event:atIndex:';
    function textView_writablePasteboardTypesForCell_atIndex (view: NSTextView; cell: NSTextAttachmentCellProtocol; charIndex: NSUInteger): NSArray; message 'textView:writablePasteboardTypesForCell:atIndex:';
    function textView_writeCell_atIndex_toPasteboard_type (view: NSTextView; cell: NSTextAttachmentCellProtocol; charIndex: NSUInteger; pboard: NSPasteboard; type_: NSString): boolean; message 'textView:writeCell:atIndex:toPasteboard:type:';
    function textView_willChangeSelectionFromCharacterRange_toCharacterRange (textView: NSTextView; oldSelectedCharRange: NSRange; newSelectedCharRange: NSRange): NSRange; message 'textView:willChangeSelectionFromCharacterRange:toCharacterRange:';
    function textView_willChangeSelectionFromCharacterRanges_toCharacterRanges (textView: NSTextView; oldSelectedCharRanges: NSArray; newSelectedCharRanges: NSArray): NSArray; message 'textView:willChangeSelectionFromCharacterRanges:toCharacterRanges:';
    function textView_shouldChangeTextInRanges_replacementStrings (textView: NSTextView; affectedRanges: NSArray; replacementStrings: NSArray): boolean; message 'textView:shouldChangeTextInRanges:replacementStrings:';
    function textView_shouldChangeTypingAttributes_toAttributes (textView: NSTextView; oldTypingAttributes: NSDictionary; newTypingAttributes: NSDictionary): NSDictionary; message 'textView:shouldChangeTypingAttributes:toAttributes:';
    procedure textViewDidChangeSelection (notification: NSNotification); message 'textViewDidChangeSelection:';
    procedure textViewDidChangeTypingAttributes (notification: NSNotification); message 'textViewDidChangeTypingAttributes:';
    function textView_willDisplayToolTip_forCharacterAtIndex (textView: NSTextView; tooltip: NSString; characterIndex: NSUInteger): NSString; message 'textView:willDisplayToolTip:forCharacterAtIndex:';
    function textView_completions_forPartialWordRange_indexOfSelectedItem (textView: NSTextView; words: NSArray; charRange: NSRange; index: NSIntegerPtr): NSArray; message 'textView:completions:forPartialWordRange:indexOfSelectedItem:';
    function textView_shouldChangeTextInRange_replacementString (textView: NSTextView; affectedCharRange: NSRange; replacementString: NSString): boolean; message 'textView:shouldChangeTextInRange:replacementString:';
    function textView_doCommandBySelector (textView: NSTextView; commandSelector: SEL): boolean; message 'textView:doCommandBySelector:';
    function textView_shouldSetSpellingState_range (textView: NSTextView; value: NSInteger; affectedCharRange: NSRange): NSInteger; message 'textView:shouldSetSpellingState:range:'; { available in 10_5 }
    function textView_menu_forEvent_atIndex (view: NSTextView; menu: NSMenu; event: NSEvent; charIndex: NSUInteger): NSMenu; message 'textView:menu:forEvent:atIndex:'; { available in 10_5 }
    {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
    function textView_willCheckTextInRange_options_types (view: NSTextView; range: NSRange; options: NSDictionary; checkingTypes: NSTextCheckingTypesPtr): NSDictionary; message 'textView:willCheckTextInRange:options:types:';
    function textView_didCheckTextInRange_types_options_results_orthography_wordCount (view: NSTextView; range: NSRange; checkingTypes: NSTextCheckingTypes; options: NSDictionary; results: NSArray; orthography: NSOrthography; wordCount: NSInteger): NSArray; message 'textView:didCheckTextInRange:types:options:results:orthography:wordCount:';
    {$endif}
    function textView_URLForContentsOfTextAttachment_atIndex (textView: NSTextView; textAttachment: NSTextAttachment; charIndex: NSUInteger): NSURL; message 'textView:URLForContentsOfTextAttachment:atIndex:'; { available in 10_7 }
    function textView_willShowSharingServicePicker_forItems (textView: NSTextView; servicePicker: NSSharingServicePicker; items: NSArray): NSSharingServicePicker; message 'textView:willShowSharingServicePicker:forItems:'; { available in 10_8 }
    function textView_clickedOnLink (textView: NSTextView; link: id): boolean; message 'textView:clickedOnLink:';
    procedure textView_clickedOnCell_inRect (textView: NSTextView; cell: NSTextAttachmentCellProtocol; cellFrame: NSRect); message 'textView:clickedOnCell:inRect:';
    procedure textView_doubleClickedOnCell_inRect (textView: NSTextView; cell: NSTextAttachmentCellProtocol; cellFrame: NSRect); message 'textView:doubleClickedOnCell:inRect:';
    procedure textView_draggedCell_inRect_event (view: NSTextView; cell: NSTextAttachmentCellProtocol; rect: NSRect; event: NSEvent); message 'textView:draggedCell:inRect:event:';
    function undoManagerForTextView (view: NSTextView): NSUndoManager; message 'undoManagerForTextView:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSTextViewWillChangeNotifyingTextViewNotification: NSString; cvar; external;
  NSTextViewDidChangeSelectionNotification: NSString; cvar; external;
  NSTextViewDidChangeTypingAttributesNotification: NSString; cvar; external;
{$endif}

{$ifdef TYPES}
const
  NSFindPanelActionShowFindPanel = 1;
  NSFindPanelActionNext = 2;
  NSFindPanelActionPrevious = 3;
  NSFindPanelActionReplaceAll = 4;
  NSFindPanelActionReplace = 5;
  NSFindPanelActionReplaceAndFind = 6;
  NSFindPanelActionSetFindString = 7;
  NSFindPanelActionReplaceAllInSelection = 8;
  NSFindPanelActionSelectAll = 9;
  NSFindPanelActionSelectAllInSelection = 10;

type
  NSFindPanelAction = NSUInteger;
  NSFindPanelActionPtr = ^NSFindPanelAction;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSFindPanelSearchOptionsPboardType: NSString { available in 10_5 }; cvar; external;
  NSFindPanelCaseInsensitiveSearch: NSString { available in 10_5 }; cvar; external;
  NSFindPanelSubstringMatch: NSString { available in 10_5 }; cvar; external;
{$endif}

{$ifdef TYPES}
const
  NSFindPanelSubstringMatchTypeContains = 0;
  NSFindPanelSubstringMatchTypeStartsWith = 1;
  NSFindPanelSubstringMatchTypeFullWord = 2;
  NSFindPanelSubstringMatchTypeEndsWith = 3;

type
  NSFindPanelSubstringMatchType = NSUInteger;
  NSFindPanelSubstringMatchTypePtr = ^NSFindPanelSubstringMatchType;
{$endif}

