{ Parsed from AppKit.framework (MacOSX10.8) NSTokenFieldCell.h }
{ Created on Mon Sep 10 11:47:56 2012 }


{$ifdef TYPES}
type
  NSTokenFieldCellPtr = ^NSTokenFieldCell;
  NSTokenFieldCellDelegateProtocolPtr = ^NSTokenFieldCellDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSDefaultTokenStyle = 0;
  NSPlainTextTokenStyle = 1;
  NSRoundedTokenStyle = 2;

type
  NSTokenStyle = NSUInteger;
  NSTokenStylePtr = ^NSTokenStyle;
{$endif}

{$ifdef CLASSES}

type
  NSTokenFieldCell = objcclass external (NSTextFieldCell)
  private
    _tokenizingCharacterSet: NSCharacterSet;
    _delegate: id;
    _completionDelay: NSTimeInterval;
    _cache: id;
    _defaultTerminator: id;
    _trackingArea: id;
    _lastCell: id;
    _lastCellFrame: NSRect;
    _autoCompleteCancel: pboolean;
    _reserved:array[0..5] of id;
    _tfcFlags: bitpacked record
      case byte of
        0: (_anonBitField__tfcFlags0: cuint);
        1: (
          _style: 0..((1 shl 4)-1);
          _invalidCache: 0..1;
          _inDidChange: 0..1;
          _validationDisabled: 0..1;
          _reserved1: 0..1;
          _autoCompleteMode: 0..((1 shl 2)-1);
          _inValidateEditing: 0..1;
          _performingDrop: 0..1;
          _reserved: 0..((1 shl 20)-1);
        );
      end;
  public
    procedure setTokenStyle (style: NSTokenStyle); message 'setTokenStyle:';
    function tokenStyle: NSTokenStyle; message 'tokenStyle';
    procedure setCompletionDelay (delay: NSTimeInterval); message 'setCompletionDelay:';
    function completionDelay: NSTimeInterval; message 'completionDelay';
    class function defaultCompletionDelay: NSTimeInterval; message 'defaultCompletionDelay';
    procedure setTokenizingCharacterSet (characterSet: NSCharacterSet); message 'setTokenizingCharacterSet:';
    function tokenizingCharacterSet: NSCharacterSet; message 'tokenizingCharacterSet';
    class function defaultTokenizingCharacterSet: NSCharacterSet; message 'defaultTokenizingCharacterSet';
    procedure setDelegate (anObject: NSTokenFieldCellDelegateProtocol); message 'setDelegate:';
    function delegate: NSTokenFieldCellDelegateProtocol; message 'delegate';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSTokenFieldCellDelegateProtocol = objcprotocol external name 'NSTokenFieldCellDelegate' (NSObjectProtocol)
  optional
    function tokenFieldCell_completionsForSubstring_indexOfToken_indexOfSelectedItem (tokenFieldCell: NSTokenFieldCell; substring: NSString; tokenIndex: NSInteger; selectedIndex: NSIntegerPtr): NSArray; message 'tokenFieldCell:completionsForSubstring:indexOfToken:indexOfSelectedItem:';
    function tokenFieldCell_shouldAddObjects_atIndex (tokenFieldCell: NSTokenFieldCell; tokens: NSArray; index: NSUInteger): NSArray; message 'tokenFieldCell:shouldAddObjects:atIndex:';
    function tokenFieldCell_displayStringForRepresentedObject (tokenFieldCell: NSTokenFieldCell; representedObject: id): NSString; message 'tokenFieldCell:displayStringForRepresentedObject:';
    function tokenFieldCell_editingStringForRepresentedObject (tokenFieldCell: NSTokenFieldCell; representedObject: id): NSString; message 'tokenFieldCell:editingStringForRepresentedObject:';
    function tokenFieldCell_representedObjectForEditingString (tokenFieldCell: NSTokenFieldCell; editingString: NSString): id; message 'tokenFieldCell:representedObjectForEditingString:';
    function tokenFieldCell_writeRepresentedObjects_toPasteboard (tokenFieldCell: NSTokenFieldCell; objects: NSArray; pboard: NSPasteboard): boolean; message 'tokenFieldCell:writeRepresentedObjects:toPasteboard:';
    function tokenFieldCell_readFromPasteboard (tokenFieldCell: NSTokenFieldCell; pboard: NSPasteboard): NSArray; message 'tokenFieldCell:readFromPasteboard:';
    function tokenFieldCell_menuForRepresentedObject (tokenFieldCell: NSTokenFieldCell; representedObject: id): NSMenu; message 'tokenFieldCell:menuForRepresentedObject:';
    function tokenFieldCell_hasMenuForRepresentedObject (tokenFieldCell: NSTokenFieldCell; representedObject: id): boolean; message 'tokenFieldCell:hasMenuForRepresentedObject:';
    function tokenFieldCell_styleForRepresentedObject (tokenFieldCell: NSTokenFieldCell; representedObject: id): NSTokenStyle; message 'tokenFieldCell:styleForRepresentedObject:';
  end;
{$endif}

