{ Parsed from AppKit.framework (MacOSX10.8) NSToolbar.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{$ifdef TYPES}
type
  NSToolbarPtr = ^NSToolbar;
  NSToolbarDelegateProtocolPtr = ^NSToolbarDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSToolbarDisplayModeDefault = 0;
  NSToolbarDisplayModeIconAndLabel = 1;
  NSToolbarDisplayModeIconOnly = 2;
  NSToolbarDisplayModeLabelOnly = 3;

type
  NSToolbarDisplayMode = NSUInteger;
  NSToolbarDisplayModePtr = ^NSToolbarDisplayMode;

const
  NSToolbarSizeModeDefault = 0;
  NSToolbarSizeModeRegular = 1;
  NSToolbarSizeModeSmall = 2;

type
  NSToolbarSizeMode = NSUInteger;
  NSToolbarSizeModePtr = ^NSToolbarSizeMode;
{$endif}

{$ifdef CLASSES}

type
  NSToolbar = objcclass external (NSObject)
  private
    _toolbarIdentifier: NSString;
    _currentItems: NSMutableArray;
    _currentItemIdentifiers: NSMutableArray;
    _res1: id;
    _res2: id;
    _selectedItemIdentifier: NSString;
    _metrics: pointer;
    _delegate: id;
    _logicalWindow: NSWindow;
    _configPalette: id;
    _toolbarView: id;
    _syncPostEnabledCount: NSInteger;
    __tbFlags: bitpacked record
      case byte of
        0: (_anonBitField___tbFlags0: cuint);
        1: (
          allowsUserCustomization_: 0..1;
          autosavesUsingIdentifier: 0..1;
          initialConfigurationDone: 0..1;
          doesNotAttachToMenuBar: 0..1;
          delegateDefaultItemIdentifiers: 0..1;
          delegateAllowedItemIdentifiers: 0..1;
          delegateItemWithItemIdentifier: 0..1;
          delegateNotificationsEnabled: 0..1;
          prefersToBeShown: 0..1;
          loadItemsImmediately: 0..1;
          currentItemsContainsPlaceholder: 0..1;
          customizationPanelIsRunning: 0..1;
          usesCustomSheetWidth: 0..1;
          clickAndDragPerformsCustomization: 0..1;
          showsNoContextMenu: 0..1;
          currentlyLoadingPlaceholders: 0..1;
          delegateItemWithItemIdentifier2: 0..1;
          inGlobalWindow: 0..1;
          reserved: 0..((1 shl 2)-1);
          usingFSMetrics: 0..1;
          keyboardLoopNeedsUpdating: 0..1;
          showHideDuringConfigurationChangeDisabled: 0..1;
          displayMode_: 0..((1 shl 2)-1);
          sizeMode_: 0..((1 shl 2)-1);
          doNotShowBaselineSeparator: 0..1;
          hideWithoutResizingWindowHint: 0..1;
          autovalidatesItemsDisabled: 0..1;
          inAutovalidation: 0..1;
          loadedMetrics: 0..1;
        );
      end;
    _customizationSheetWidth: NSInteger;
    _tbReserved: id;
  public
    function initWithIdentifier (identifier: NSString): id; message 'initWithIdentifier:';
    procedure insertItemWithItemIdentifier_atIndex (itemIdentifier: NSString; index: NSInteger); message 'insertItemWithItemIdentifier:atIndex:';
    procedure removeItemAtIndex (index: NSInteger); message 'removeItemAtIndex:';
    procedure setDelegate (delegate: NSToolbarDelegateProtocol); message 'setDelegate:';
    function delegate: NSToolbarDelegateProtocol; message 'delegate';
    procedure setVisible (shown: boolean); message 'setVisible:';
    function isVisible: boolean; message 'isVisible';
    procedure runCustomizationPalette (sender: id); message 'runCustomizationPalette:';
    function customizationPaletteIsRunning: boolean; message 'customizationPaletteIsRunning';
    procedure setDisplayMode (displayMode: NSToolbarDisplayMode); message 'setDisplayMode:';
    function displayMode: NSToolbarDisplayMode; message 'displayMode';
    procedure setSelectedItemIdentifier (itemIdentifier: NSString); message 'setSelectedItemIdentifier:';
    function selectedItemIdentifier: NSString; message 'selectedItemIdentifier';
    procedure setSizeMode (sizeMode: NSToolbarSizeMode); message 'setSizeMode:';
    function sizeMode: NSToolbarSizeMode; message 'sizeMode';
    procedure setShowsBaselineSeparator (flag: boolean); message 'setShowsBaselineSeparator:';
    function showsBaselineSeparator: boolean; message 'showsBaselineSeparator';
    procedure setAllowsUserCustomization (allowCustomization: boolean); message 'setAllowsUserCustomization:';
    function allowsUserCustomization: boolean; message 'allowsUserCustomization';
    procedure setFullScreenAccessoryView (view: NSView); message 'setFullScreenAccessoryView:'; { available in 10_7 }
    function fullScreenAccessoryView: NSView; message 'fullScreenAccessoryView'; { available in 10_7 }
    procedure setFullScreenAccessoryViewMinHeight (minHeight: CGFloat); message 'setFullScreenAccessoryViewMinHeight:'; { available in 10_7 }
    procedure setFullScreenAccessoryViewMaxHeight (maxHeight: CGFloat); message 'setFullScreenAccessoryViewMaxHeight:'; { available in 10_7 }
    function fullScreenAccessoryViewMinHeight: CGFloat; message 'fullScreenAccessoryViewMinHeight'; { available in 10_7 }
    function fullScreenAccessoryViewMaxHeight: CGFloat; message 'fullScreenAccessoryViewMaxHeight'; { available in 10_7 }
    function identifier: NSString; message 'identifier';
    function items: NSArray; message 'items';
    function visibleItems: NSArray; message 'visibleItems';
    procedure setAutosavesConfiguration (flag: boolean); message 'setAutosavesConfiguration:';
    function autosavesConfiguration: boolean; message 'autosavesConfiguration';
    procedure setConfigurationFromDictionary (configDict: NSDictionary); message 'setConfigurationFromDictionary:';
    function configurationDictionary: NSDictionary; message 'configurationDictionary';
    procedure validateVisibleItems; message 'validateVisibleItems';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSToolbarDelegateProtocol = objcprotocol external name 'NSToolbarDelegate' (NSObjectProtocol)
  optional
    function toolbar_itemForItemIdentifier_willBeInsertedIntoToolbar (toolbar: NSToolbar; itemIdentifier: NSString; flag: boolean): NSToolbarItem; message 'toolbar:itemForItemIdentifier:willBeInsertedIntoToolbar:';
    function toolbarDefaultItemIdentifiers (toolbar: NSToolbar): NSArray; message 'toolbarDefaultItemIdentifiers:';
    function toolbarAllowedItemIdentifiers (toolbar: NSToolbar): NSArray; message 'toolbarAllowedItemIdentifiers:';
  optional
    function toolbarSelectableItemIdentifiers (toolbar: NSToolbar): NSArray; message 'toolbarSelectableItemIdentifiers:';
    procedure toolbarWillAddItem (notification: NSNotification); message 'toolbarWillAddItem:';
    procedure toolbarDidRemoveItem (notification: NSNotification); message 'toolbarDidRemoveItem:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSToolbarWillAddItemNotification: NSString; cvar; external;
  NSToolbarDidRemoveItemNotification: NSString; cvar; external;
{$endif}

