{ Parsed from AppKit.framework (MacOSX10.8) NSToolbarItem.h }
{ Created on Mon Sep 10 11:47:57 2012 }


{ Types from NSToolbarItem }
{$ifdef TYPES}

const
  NSToolbarItemVisibilityPriorityStandard = 0;
  NSToolbarItemVisibilityPriorityLow = -1000;
  NSToolbarItemVisibilityPriorityHigh = 1000;
  NSToolbarItemVisibilityPriorityUser = 2000;
{$endif}


{$ifdef TYPES}
type
  NSToolbarItemPtr = ^NSToolbarItem;
{$endif}

{$ifdef CLASSES}

type
  NSToolbarItem = objcclass external (NSObject, NSCopyingProtocol, NSValidatedUserInterfaceItemProtocol)
  private
    _toolbar: NSToolbar;
    _image: NSImage;
    _itemIdentifier: NSString;
    _label: NSString;
    _labelAlignment: NSTextAlignment;
    _paletteLabel: NSString;
    _toolTip: NSString;
    _menuItemRep: NSMenuItem;
    _tag: NSInteger;
    __tbiFlags: bitpacked record
      case byte of
        0: (_anonBitField___tbiFlags0: cuint);
        1: (
          viewRespondsToIsEnabled: 0..1;
          viewRespondsToSetEnabled: 0..1;
          viewRespondsToTag: 0..1;
          viewRespondsToSetTag: 0..1;
          viewRespondsToAction: 0..1;
          viewRespondsToSetAction: 0..1;
          viewRespondsToTarget: 0..1;
          viewRespondsToSetTarget: 0..1;
          viewRespondsToImage: 0..1;
          viewRespondsToSetImage: 0..1;
          isEnabled_: 0..1;
          isUserRemovable: 0..1;
          menuHasBeenSet: 0..1;
          menuRepIsDefault: 0..1;
          viewHasBeenLoaded: 0..1;
          drawingForDragImage: 0..1;
          isCustomItemType: 0..1;
          hasValidatedAutoModeConfiguration: 0..1;
          useAutoModeConfiguration: 0..1;
          RESERVED2: 0..1;
          autovalidationDisabled: 0..1;
          tagHasBeenSet: 0..1;
          sizeHasBeenSet: 0..1;
          stateWasDisabledBeforeSheet: 0..1;
          RESERVED: 0..((1 shl 8)-1);
        );
      end;
    _tbiReserved: id;
    _itemViewer: id;
    _view: NSView;
    _minSize: NSSize;
    _maxSize: NSSize;
    {$if defined(__LP64__)}
    _toolbarItemReserved: id;
    {$endif}
  public
    function initWithItemIdentifier (itemIdentifier: NSString): id; message 'initWithItemIdentifier:';
    function itemIdentifier: NSString; message 'itemIdentifier';
    function toolbar: NSToolbar; message 'toolbar';
    procedure setLabel (label_: NSString); message 'setLabel:';
    function label_: NSString; message 'label';
    procedure setPaletteLabel (paletteLabel: NSString); message 'setPaletteLabel:';
    function paletteLabel: NSString; message 'paletteLabel';
    procedure setToolTip (toolTip: NSString); message 'setToolTip:';
    function toolTip: NSString; message 'toolTip';
    procedure setMenuFormRepresentation (menuItem: NSMenuItem); message 'setMenuFormRepresentation:';
    function menuFormRepresentation: NSMenuItem; message 'menuFormRepresentation';
    procedure setTag (tag: NSInteger); message 'setTag:';
    function tag: NSInteger; message 'tag';
    procedure setTarget (target: id); message 'setTarget:';
    function target: id; message 'target';
    procedure setAction (action: SEL); message 'setAction:';
    function action: SEL; message 'action';
    procedure setEnabled (enabled: boolean); message 'setEnabled:';
    function isEnabled: boolean; message 'isEnabled';
    procedure setImage (image: NSImage); message 'setImage:';
    function image: NSImage; message 'image';
    procedure setView (view: NSView); message 'setView:';
    function view: NSView; message 'view';
    procedure setMinSize (size: NSSize); message 'setMinSize:';
    function minSize: NSSize; message 'minSize';
    procedure setMaxSize (size: NSSize); message 'setMaxSize:';
    function maxSize: NSSize; message 'maxSize';
    procedure setVisibilityPriority (visibilityPriority: NSInteger); message 'setVisibilityPriority:';
    function visibilityPriority: NSInteger; message 'visibilityPriority';
    procedure validate; message 'validate';
    procedure setAutovalidates (resistance: boolean); message 'setAutovalidates:';
    function autovalidates: boolean; message 'autovalidates';
    function allowsDuplicatesInToolbar: boolean; message 'allowsDuplicatesInToolbar';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;


type
  NSToolbarItemValidation = objccategory external (NSObject)
    function validateToolbarItem (theItem: NSToolbarItem): boolean; message 'validateToolbarItem:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSToolbarSeparatorItemIdentifier: NSString; cvar; external;
  NSToolbarSpaceItemIdentifier: NSString; cvar; external;
  NSToolbarFlexibleSpaceItemIdentifier: NSString; cvar; external;
  NSToolbarShowColorsItemIdentifier: NSString; cvar; external;
  NSToolbarShowFontsItemIdentifier: NSString; cvar; external;
  NSToolbarCustomizeToolbarItemIdentifier: NSString; cvar; external;
  NSToolbarPrintItemIdentifier: NSString; cvar; external;
{$endif}

