{ Parsed from AppKit.framework (MacOSX10.8) NSWindow.h }
{ Created on Mon Sep 10 11:47:55 2012 }


{$ifdef TYPES}
type
  NSWindowPtr = ^NSWindow;
  NSWindowDelegateProtocolPtr = ^NSWindowDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  NSAppKitVersionNumberWithCustomSheetPosition = 686.0;
  NSAppKitVersionNumberWithDeferredWindowDisplaySupport = 1019.0;

const
  NSBorderlessWindowMask = 0;
  NSTitledWindowMask = 1 shl 0;
  NSClosableWindowMask = 1 shl 1;
  NSMiniaturizableWindowMask = 1 shl 2;
  NSResizableWindowMask = 1 shl 3;
const
  NSTexturedBackgroundWindowMask = 1 shl 8;
const
  NSUnscaledWindowMask = 1 shl 11;
const
  NSUnifiedTitleAndToolbarWindowMask = 1 shl 12;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
{$ifdef TYPES}
const
  NSFullScreenWindowMask = 1 shl 14;
{$endif}

{$endif}
{$ifdef TYPES}
const
  NSDisplayWindowRunLoopOrdering = 600000;
  NSResetCursorRectsRunLoopOrdering = 700000;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef TYPES}
const
  NSWindowSharingNone = 0;
  NSWindowSharingReadOnly = 1;
  NSWindowSharingReadWrite = 2;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSWindowSharingType = NSUInteger;
  NSWindowSharingTypePtr = ^NSWindowSharingType;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef TYPES}
const
  NSWindowBackingLocationDefault = 0;
  NSWindowBackingLocationVideoMemory = 1;
  NSWindowBackingLocationMainMemory = 2;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSWindowBackingLocation = NSUInteger;
  NSWindowBackingLocationPtr = ^NSWindowBackingLocation;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef TYPES}
const
  NSWindowCollectionBehaviorDefault = 0;
  NSWindowCollectionBehaviorCanJoinAllSpaces = 1 shl 0;
  NSWindowCollectionBehaviorMoveToActiveSpace = 1 shl 1;
{$endif}

{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
{$ifdef TYPES}
const
  NSWindowCollectionBehaviorManaged = 1 shl 2;
  NSWindowCollectionBehaviorTransient = 1 shl 3;
  NSWindowCollectionBehaviorStationary = 1 shl 4;
const
  NSWindowCollectionBehaviorParticipatesInCycle = 1 shl 5;
  NSWindowCollectionBehaviorIgnoresCycle = 1 shl 6;
{$endif}

{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
{$ifdef TYPES}
const
  NSWindowCollectionBehaviorFullScreenPrimary = 1 shl 7;
  NSWindowCollectionBehaviorFullScreenAuxiliary = 1 shl 8;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSWindowCollectionBehavior = NSUInteger;
  NSWindowCollectionBehaviorPtr = ^NSWindowCollectionBehavior;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
{$ifdef TYPES}
const
  NSWindowAnimationBehaviorDefault = 0;
  NSWindowAnimationBehaviorNone = 2;
  NSWindowAnimationBehaviorDocumentWindow = 3;
  NSWindowAnimationBehaviorUtilityWindow = 4;
  NSWindowAnimationBehaviorAlertPanel = 5;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSWindowAnimationBehavior = NSInteger;
  NSWindowAnimationBehaviorPtr = ^NSWindowAnimationBehavior;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
{$ifdef TYPES}
const
  NSWindowNumberListAllApplications = 1 shl 0;
  NSWindowNumberListAllSpaces = 1 shl 4;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSWindowNumberListOptions = NSUInteger;
  NSWindowNumberListOptionsPtr = ^NSWindowNumberListOptions;

const
  NSNormalWindowLevel = kCGNormalWindowLevel;
  NSFloatingWindowLevel = kCGFloatingWindowLevel;
  NSSubmenuWindowLevel = kCGTornOffMenuWindowLevel;
  NSTornOffMenuWindowLevel = kCGTornOffMenuWindowLevel;
  NSMainMenuWindowLevel = kCGMainMenuWindowLevel;
  NSStatusWindowLevel = kCGStatusWindowLevel;
  NSDockWindowLevel = kCGDockWindowLevel;
  NSModalPanelWindowLevel = kCGModalPanelWindowLevel;
  NSPopUpMenuWindowLevel = kCGPopUpMenuWindowLevel;
  NSScreenSaverWindowLevel = kCGScreenSaverWindowLevel;

const
  NSDirectSelection = 0;
  NSSelectingNext = 1;
  NSSelectingPrevious = 2;

type
  NSSelectionDirection = NSUInteger;
  NSSelectionDirectionPtr = ^NSSelectionDirection;

const
  NSWindowCloseButton = 0;
  NSWindowMiniaturizeButton = 1;
  NSWindowZoomButton = 2;
  NSWindowToolbarButton = 3;
  NSWindowDocumentIconButton = 4;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_7)}
{$ifdef TYPES}
const
  NSWindowDocumentVersionsButton = 6;
  NSWindowFullScreenButton = 7;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSWindowButton = NSUInteger;
  NSWindowButtonPtr = ^NSWindowButton;
{$endif}

{$ifdef CLASSES}

type
  NSWindow = objcclass external (NSResponder, NSAnimatablePropertyContainerProtocol, NSUserInterfaceValidationsProtocol, NSUserInterfaceItemIdentificationProtocol)
  private
    _frame: NSRect;
    _contentView: id;
    _delegate: id;
    _firstResponder: NSResponder;
    _lastLeftHit: NSView;
    _lastRightHit: NSView;
    _counterpart: id;
    _fieldEditor: id;
    _winEventMask: cint;
    _windowNum: NSInteger;
    _level: cint;
    _backgroundColor: NSColor;
    _borderView: id;
    _postingDisabled: char;
    _styleMask: char;
    _flushDisabled: char;
    _reservedWindow1: char;
    _cursorRects: pointer;
    _trectTable: pointer;
    _miniIcon: NSImage;
    _bamboo: cint32;
    _dragTypes: NSMutableSet;
    _representedURL: NSURL;
    _sizeLimits: NSSizePtr;
    _frameSaveName: NSString;
    _regDragTypes: NSSet;
    __wFlags: bitpacked record
      case byte of
        0: (_anonBitField___wFlags0: cuint);
        1: (
          backing: 0..((1 shl 2)-1);
          visible: 0..1;
          isMainWindow_: 0..1;
          isKeyWindow_: 0..1;
          hidesOnDeactivate_: 0..1;
          dontFreeWhenClosed: 0..1;
          oneShot: 0..1;
          deferred: 0..1;
          cursorRectsDisabled: 0..1;
          haveFreeCursorRects: 0..1;
          validCursorRects: 0..1;
          docEdited: 0..1;
          dynamicDepthLimit: 0..1;
          worksWhenModal_: 0..1;
          limitedBecomeKey: 0..1;
          needsFlush: 0..1;
          viewsNeedDisplay_: 0..1;
          ignoredFirstMouse: 0..1;
          repostedFirstMouse: 0..1;
          windowDying: 0..1;
          tempHidden: 0..1;
          floatingPanel: 0..1;
          wantsToBeOnMainScreen: 0..1;
          optimizedDrawingOk: 0..1;
          optimizeDrawing: 0..1;
          titleIsRepresentedFilename: 0..1;
          excludedFromWindowsMenu: 0..1;
          depthLimit_: 0..((1 shl 4)-1);
          delegateReturnsValidRequestor: 0..1;
          lmouseupPending: 0..1;
          rmouseupPending: 0..1;
          wantsToDestroyRealWindow: 0..1;
          wantsToRegDragTypes: 0..1;
          sentInvalidateCursorRectsMsg: 0..1;
          avoidsActivation: 0..1;
          frameSavedUsingTitle: 0..1;
          didRegDragTypes: 0..1;
          delayedOneShot: 0..1;
          postedNeedsDisplayNote: 0..1;
          postedInvalidCursorRectsNote: 0..1;
          initialFirstResponderTempSet: 0..1;
          autodisplay: 0..1;
          tossedFirstEvent: 0..1;
          isImageCache: 0..1;
          _unused: 0..((1 shl 3)-1);
          keyViewSelectionDirection_: 0..((1 shl 2)-1);
          defaultButtonCellKETemporarilyDisabled: 0..1;
          defaultButtonCellKEDisabled: 0..1;
          menuHasBeenSet: 0..1;
          wantsToBeModal: 0..1;
          showingModalFrame: 0..1;
          isTerminating: 0..1;
          win32MouseActivationInProgress: 0..1;
          makingFirstResponderForMouseDown: 0..1;
          needsZoom: 0..1;
          sentWindowNeedsDisplayMsg: 0..1;
          liveResizeActive: 0..1;
        );
      end;
    _defaultButtonCell: id;
    _initialFirstResponder: NSView;
    _auxiliaryStorage: NSWindowAuxiliary;
  public
    class function frameRectForContentRect_styleMask (cRect: NSRect; aStyle: NSUInteger): NSRect; message 'frameRectForContentRect:styleMask:';
    class function contentRectForFrameRect_styleMask (fRect: NSRect; aStyle: NSUInteger): NSRect; message 'contentRectForFrameRect:styleMask:';
    class function minFrameWidthWithTitle_styleMask (aTitle: NSString; aStyle: NSUInteger): CGFloat; message 'minFrameWidthWithTitle:styleMask:';
    class function defaultDepthLimit: NSWindowDepth; message 'defaultDepthLimit';
    function frameRectForContentRect (contentRect: NSRect): NSRect; message 'frameRectForContentRect:';
    function contentRectForFrameRect (frameRect: NSRect): NSRect; message 'contentRectForFrameRect:';
    function initWithContentRect_styleMask_backing_defer (contentRect: NSRect; aStyle: NSUInteger; bufferingType: NSBackingStoreType; flag: boolean): id; message 'initWithContentRect:styleMask:backing:defer:';
    function initWithContentRect_styleMask_backing_defer_screen (contentRect: NSRect; aStyle: NSUInteger; bufferingType: NSBackingStoreType; flag: boolean; screen: NSScreen): id; message 'initWithContentRect:styleMask:backing:defer:screen:';
    function title: NSString; message 'title';
    procedure setTitle (aString: NSString); message 'setTitle:';
    procedure setRepresentedURL (url: NSURL); message 'setRepresentedURL:'; { available in 10_5 }
    function representedURL: NSURL; message 'representedURL'; { available in 10_5 }
    function representedFilename: NSString; message 'representedFilename';
    procedure setRepresentedFilename (aString: NSString); message 'setRepresentedFilename:';
    procedure setTitleWithRepresentedFilename (filename: NSString); message 'setTitleWithRepresentedFilename:';
    procedure setExcludedFromWindowsMenu (flag: boolean); message 'setExcludedFromWindowsMenu:';
    function isExcludedFromWindowsMenu: boolean; message 'isExcludedFromWindowsMenu';
    procedure setContentView (aView: NSView); message 'setContentView:';
    function contentView: id; message 'contentView';
    procedure setDelegate (anObject: NSWindowDelegateProtocol); message 'setDelegate:';
    function delegate: NSWindowDelegateProtocol; message 'delegate';
    function windowNumber: NSInteger; message 'windowNumber';
    function styleMask: NSUInteger; message 'styleMask';
    procedure setStyleMask (styleMask_: NSUInteger); message 'setStyleMask:'; { available in 10_6 }
    function fieldEditor_forObject (createFlag: boolean; anObject: id): NSText; message 'fieldEditor:forObject:';
    procedure endEditingFor (anObject: id); message 'endEditingFor:';
    function constrainFrameRect_toScreen (frameRect: NSRect; screen: NSScreen): NSRect; message 'constrainFrameRect:toScreen:';
    procedure setFrame_display (frameRect: NSRect; flag: boolean); message 'setFrame:display:';
    procedure setContentSize (aSize: NSSize); message 'setContentSize:';
    procedure setFrameOrigin (aPoint: NSPoint); message 'setFrameOrigin:';
    procedure setFrameTopLeftPoint (aPoint: NSPoint); message 'setFrameTopLeftPoint:';
    function cascadeTopLeftFromPoint (topLeftPoint: NSPoint): NSPoint; message 'cascadeTopLeftFromPoint:';
    function frame: NSRect; message 'frame';
    function animationResizeTime (newFrame: NSRect): NSTimeInterval; message 'animationResizeTime:';
    procedure setFrame_display_animate (frameRect: NSRect; displayFlag: boolean; animateFlag: boolean); message 'setFrame:display:animate:';
    function inLiveResize: boolean; message 'inLiveResize'; { available in 10_6 }
    procedure setShowsResizeIndicator (show: boolean); message 'setShowsResizeIndicator:';
    function showsResizeIndicator: boolean; message 'showsResizeIndicator';
    procedure setResizeIncrements (increments: NSSize); message 'setResizeIncrements:';
    function resizeIncrements: NSSize; message 'resizeIncrements';
    procedure setAspectRatio (ratio: NSSize); message 'setAspectRatio:';
    function aspectRatio: NSSize; message 'aspectRatio';
    procedure setContentResizeIncrements (increments: NSSize); message 'setContentResizeIncrements:';
    function contentResizeIncrements: NSSize; message 'contentResizeIncrements';
    procedure setContentAspectRatio (ratio: NSSize); message 'setContentAspectRatio:';
    function contentAspectRatio: NSSize; message 'contentAspectRatio';
    procedure useOptimizedDrawing (flag: boolean); message 'useOptimizedDrawing:';
    procedure disableFlushWindow; message 'disableFlushWindow';
    procedure enableFlushWindow; message 'enableFlushWindow';
    function isFlushWindowDisabled: boolean; message 'isFlushWindowDisabled';
    procedure flushWindow; message 'flushWindow';
    procedure flushWindowIfNeeded; message 'flushWindowIfNeeded';
    procedure setViewsNeedDisplay (flag: boolean); message 'setViewsNeedDisplay:';
    function viewsNeedDisplay: boolean; message 'viewsNeedDisplay';
    procedure displayIfNeeded; message 'displayIfNeeded';
    procedure display; message 'display';
    procedure setAutodisplay (flag: boolean); message 'setAutodisplay:';
    function isAutodisplay: boolean; message 'isAutodisplay';
    function preservesContentDuringLiveResize: boolean; message 'preservesContentDuringLiveResize';
    procedure setPreservesContentDuringLiveResize (flag: boolean); message 'setPreservesContentDuringLiveResize:';
    procedure update; message 'update';
    function makeFirstResponder (aResponder: NSResponder): boolean; message 'makeFirstResponder:';
    function firstResponder: NSResponder; message 'firstResponder';
    function resizeFlags: NSInteger; message 'resizeFlags';
    procedure keyDown (theEvent: NSEvent); message 'keyDown:';
    procedure close; message 'close';
    procedure setReleasedWhenClosed (flag: boolean); message 'setReleasedWhenClosed:';
    function isReleasedWhenClosed: boolean; message 'isReleasedWhenClosed';
    procedure miniaturize (sender: id); message 'miniaturize:';
    procedure deminiaturize (sender: id); message 'deminiaturize:';
    function isZoomed: boolean; message 'isZoomed';
    procedure zoom (sender: id); message 'zoom:';
    function isMiniaturized: boolean; message 'isMiniaturized';
    function tryToPerform_with (anAction: SEL; anObject: id): boolean; message 'tryToPerform:with:';
    function validRequestorForSendType_returnType (sendType: NSString; returnType: NSString): id; message 'validRequestorForSendType:returnType:';
    procedure setBackgroundColor (color: NSColor); message 'setBackgroundColor:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setContentBorderThickness_forEdge (thickness: CGFloat; edge: NSRectEdge); message 'setContentBorderThickness:forEdge:'; { available in 10_5 }
    function contentBorderThicknessForEdge (edge: NSRectEdge): CGFloat; message 'contentBorderThicknessForEdge:'; { available in 10_5 }
    procedure setAutorecalculatesContentBorderThickness_forEdge (flag: boolean; edge: NSRectEdge); message 'setAutorecalculatesContentBorderThickness:forEdge:'; { available in 10_5 }
    function autorecalculatesContentBorderThicknessForEdge (edge: NSRectEdge): boolean; message 'autorecalculatesContentBorderThicknessForEdge:'; { available in 10_5 }
    procedure setMovable (flag: boolean); message 'setMovable:'; { available in 10_6 }
    function isMovable: boolean; message 'isMovable'; { available in 10_6 }
    procedure setMovableByWindowBackground (flag: boolean); message 'setMovableByWindowBackground:';
    function isMovableByWindowBackground: boolean; message 'isMovableByWindowBackground';
    procedure setHidesOnDeactivate (flag: boolean); message 'setHidesOnDeactivate:';
    function hidesOnDeactivate: boolean; message 'hidesOnDeactivate';
    procedure setCanHide (flag: boolean); message 'setCanHide:';
    function canHide: boolean; message 'canHide';
    procedure center; message 'center';
    procedure makeKeyAndOrderFront (sender: id); message 'makeKeyAndOrderFront:';
    procedure orderFront (sender: id); message 'orderFront:';
    procedure orderBack (sender: id); message 'orderBack:';
    procedure orderOut (sender: id); message 'orderOut:';
    procedure orderWindow_relativeTo (place: NSWindowOrderingMode; otherWin: NSInteger); message 'orderWindow:relativeTo:';
    procedure orderFrontRegardless; message 'orderFrontRegardless';
    procedure setMiniwindowImage (image: NSImage); message 'setMiniwindowImage:';
    procedure setMiniwindowTitle (title_: NSString); message 'setMiniwindowTitle:';
    function miniwindowImage: NSImage; message 'miniwindowImage';
    function miniwindowTitle: NSString; message 'miniwindowTitle';
    function dockTile: NSDockTile; message 'dockTile'; { available in 10_5 }
    procedure setDocumentEdited (flag: boolean); message 'setDocumentEdited:';
    function isDocumentEdited: boolean; message 'isDocumentEdited';
    function isVisible: boolean; message 'isVisible';
    function isKeyWindow: boolean; message 'isKeyWindow';
    function isMainWindow: boolean; message 'isMainWindow';
    function canBecomeKeyWindow: boolean; message 'canBecomeKeyWindow';
    function canBecomeMainWindow: boolean; message 'canBecomeMainWindow';
    procedure makeKeyWindow; message 'makeKeyWindow';
    procedure makeMainWindow; message 'makeMainWindow';
    procedure becomeKeyWindow; message 'becomeKeyWindow';
    procedure resignKeyWindow; message 'resignKeyWindow';
    procedure becomeMainWindow; message 'becomeMainWindow';
    procedure resignMainWindow; message 'resignMainWindow';
    function worksWhenModal: boolean; message 'worksWhenModal';
    function preventsApplicationTerminationWhenModal: boolean; message 'preventsApplicationTerminationWhenModal'; { available in 10_6 }
    procedure setPreventsApplicationTerminationWhenModal (flag: boolean); message 'setPreventsApplicationTerminationWhenModal:'; { available in 10_6 }
    function convertRectToScreen (aRect: NSRect): NSRect; message 'convertRectToScreen:'; { available in 10_7 }
    function convertRectFromScreen (aRect: NSRect): NSRect; message 'convertRectFromScreen:'; { available in 10_7 }
    function convertRectToBacking (aRect: NSRect): NSRect; message 'convertRectToBacking:'; { available in 10_7 }
    function convertRectFromBacking (aRect: NSRect): NSRect; message 'convertRectFromBacking:'; { available in 10_7 }
    function backingAlignedRect_options (aRect: NSRect; options: NSAlignmentOptions): NSRect; message 'backingAlignedRect:options:'; { available in 10_7 }
    function backingScaleFactor: CGFloat; message 'backingScaleFactor'; { available in 10_7 }
    function convertBaseToScreen (aPoint: NSPoint): NSPoint; message 'convertBaseToScreen:';
    function convertScreenToBase (aPoint: NSPoint): NSPoint; message 'convertScreenToBase:';
    procedure performClose (sender: id); message 'performClose:';
    procedure performMiniaturize (sender: id); message 'performMiniaturize:';
    procedure performZoom (sender: id); message 'performZoom:';
    function gState: NSInteger; message 'gState';
    procedure setOneShot (flag: boolean); message 'setOneShot:';
    function isOneShot: boolean; message 'isOneShot';
    function dataWithEPSInsideRect (rect: NSRect): NSData; message 'dataWithEPSInsideRect:';
    function dataWithPDFInsideRect (rect: NSRect): NSData; message 'dataWithPDFInsideRect:';
    procedure print (sender: id); message 'print:';
    procedure disableCursorRects; message 'disableCursorRects';
    procedure enableCursorRects; message 'enableCursorRects';
    procedure discardCursorRects; message 'discardCursorRects';
    function areCursorRectsEnabled: boolean; message 'areCursorRectsEnabled';
    procedure invalidateCursorRectsForView (aView: NSView); message 'invalidateCursorRectsForView:';
    procedure resetCursorRects; message 'resetCursorRects';
    procedure setAllowsToolTipsWhenApplicationIsInactive (allowWhenInactive: boolean); message 'setAllowsToolTipsWhenApplicationIsInactive:';
    function allowsToolTipsWhenApplicationIsInactive: boolean; message 'allowsToolTipsWhenApplicationIsInactive';
    procedure setBackingType (bufferingType: NSBackingStoreType); message 'setBackingType:';
    function backingType: NSBackingStoreType; message 'backingType';
    procedure setLevel (newLevel: NSInteger); message 'setLevel:';
    function level: NSInteger; message 'level';
    procedure setDepthLimit (limit: NSWindowDepth); message 'setDepthLimit:';
    function depthLimit: NSWindowDepth; message 'depthLimit';
    procedure setDynamicDepthLimit (flag: boolean); message 'setDynamicDepthLimit:';
    function hasDynamicDepthLimit: boolean; message 'hasDynamicDepthLimit';
    function screen: NSScreen; message 'screen';
    function deepestScreen: NSScreen; message 'deepestScreen';
    function canStoreColor: boolean; message 'canStoreColor';
    procedure setHasShadow (hasShadow: boolean); message 'setHasShadow:';
    function hasShadow: boolean; message 'hasShadow';
    procedure invalidateShadow; message 'invalidateShadow';
    procedure setAlphaValue (windowAlpha: CGFloat); message 'setAlphaValue:';
    function alphaValue: CGFloat; message 'alphaValue';
    procedure setOpaque (isOpaque: boolean); message 'setOpaque:';
    function isOpaque: boolean; message 'isOpaque';
    procedure setSharingType (type_: NSWindowSharingType); message 'setSharingType:'; { available in 10_5 }
    function sharingType: NSWindowSharingType; message 'sharingType'; { available in 10_5 }
    procedure setPreferredBackingLocation (backingLocation: NSWindowBackingLocation); message 'setPreferredBackingLocation:'; { available in 10_5 }
    function preferredBackingLocation: NSWindowBackingLocation; message 'preferredBackingLocation'; { available in 10_5 }
    function backingLocation: NSWindowBackingLocation; message 'backingLocation'; { available in 10_5 }
    function allowsConcurrentViewDrawing: boolean; message 'allowsConcurrentViewDrawing'; { available in 10_6 }
    procedure setAllowsConcurrentViewDrawing (flag: boolean); message 'setAllowsConcurrentViewDrawing:'; { available in 10_6 }
    function displaysWhenScreenProfileChanges: boolean; message 'displaysWhenScreenProfileChanges';
    procedure setDisplaysWhenScreenProfileChanges (flag: boolean); message 'setDisplaysWhenScreenProfileChanges:';
    procedure disableScreenUpdatesUntilFlush; message 'disableScreenUpdatesUntilFlush';
    function canBecomeVisibleWithoutLogin: boolean; message 'canBecomeVisibleWithoutLogin'; { available in 10_5 }
    procedure setCanBecomeVisibleWithoutLogin (flag: boolean); message 'setCanBecomeVisibleWithoutLogin:'; { available in 10_5 }
    procedure setCollectionBehavior (behavior: NSWindowCollectionBehavior); message 'setCollectionBehavior:'; { available in 10_5 }
    function collectionBehavior: NSWindowCollectionBehavior; message 'collectionBehavior'; { available in 10_5 }
    function animationBehavior: NSWindowAnimationBehavior; message 'animationBehavior'; { available in 10_7 }
    procedure setAnimationBehavior (newAnimationBehavior: NSWindowAnimationBehavior); message 'setAnimationBehavior:'; { available in 10_7 }
    function canBeVisibleOnAllSpaces: boolean; message 'canBeVisibleOnAllSpaces'; deprecated 'in 10_5, 10_5';
    procedure setCanBeVisibleOnAllSpaces (flag: boolean); message 'setCanBeVisibleOnAllSpaces:'; deprecated 'in 10_5, 10_5';
    function isOnActiveSpace: boolean; message 'isOnActiveSpace'; { available in 10_6 }
    procedure toggleFullScreen (sender: id); message 'toggleFullScreen:'; { available in 10_7 }
    function stringWithSavedFrame: NSString; message 'stringWithSavedFrame';
    procedure setFrameFromString (string_: NSString); message 'setFrameFromString:';
    procedure saveFrameUsingName (name: NSString); message 'saveFrameUsingName:';
    function setFrameUsingName_force (name: NSString; force: boolean): boolean; message 'setFrameUsingName:force:';
    function setFrameUsingName (name: NSString): boolean; message 'setFrameUsingName:';
    function setFrameAutosaveName (name: NSString): boolean; message 'setFrameAutosaveName:';
    function frameAutosaveName: NSString; message 'frameAutosaveName';
    class procedure removeFrameUsingName (name: NSString); message 'removeFrameUsingName:';
    procedure cacheImageInRect (aRect: NSRect); message 'cacheImageInRect:';
    procedure restoreCachedImage; message 'restoreCachedImage';
    procedure discardCachedImage; message 'discardCachedImage';
    function minSize: NSSize; message 'minSize';
    function maxSize: NSSize; message 'maxSize';
    procedure setMinSize (size: NSSize); message 'setMinSize:';
    procedure setMaxSize (size: NSSize); message 'setMaxSize:';
    function contentMinSize: NSSize; message 'contentMinSize';
    function contentMaxSize: NSSize; message 'contentMaxSize';
    procedure setContentMinSize (size: NSSize); message 'setContentMinSize:';
    procedure setContentMaxSize (size: NSSize); message 'setContentMaxSize:';
    function nextEventMatchingMask (mask: NSUInteger): NSEvent; message 'nextEventMatchingMask:';
    function nextEventMatchingMask_untilDate_inMode_dequeue (mask: NSUInteger; expiration: NSDate; mode: NSString; deqFlag: boolean): NSEvent; message 'nextEventMatchingMask:untilDate:inMode:dequeue:';
    procedure discardEventsMatchingMask_beforeEvent (mask: NSUInteger; lastEvent: NSEvent); message 'discardEventsMatchingMask:beforeEvent:';
    procedure postEvent_atStart (event: NSEvent; flag: boolean); message 'postEvent:atStart:';
    function currentEvent: NSEvent; message 'currentEvent';
    procedure setAcceptsMouseMovedEvents (flag: boolean); message 'setAcceptsMouseMovedEvents:';
    function acceptsMouseMovedEvents: boolean; message 'acceptsMouseMovedEvents';
    procedure setIgnoresMouseEvents (flag: boolean); message 'setIgnoresMouseEvents:';
    function ignoresMouseEvents: boolean; message 'ignoresMouseEvents';
    function deviceDescription: NSDictionary; message 'deviceDescription';
    procedure sendEvent (theEvent: NSEvent); message 'sendEvent:';
    function mouseLocationOutsideOfEventStream: NSPoint; message 'mouseLocationOutsideOfEventStream';
    class procedure menuChanged (menu_: NSMenu); message 'menuChanged:';
    function windowController: id; message 'windowController';
    procedure setWindowController (windowController_: NSWindowController); message 'setWindowController:';
    function isSheet: boolean; message 'isSheet';
    function attachedSheet: NSWindow; message 'attachedSheet';
    class function standardWindowButton_forStyleMask (b: NSWindowButton; styleMask_: NSUInteger): NSButton; message 'standardWindowButton:forStyleMask:';
    function standardWindowButton (b: NSWindowButton): NSButton; message 'standardWindowButton:';
    procedure addChildWindow_ordered (childWin: NSWindow; place: NSWindowOrderingMode); message 'addChildWindow:ordered:';
    procedure removeChildWindow (childWin: NSWindow); message 'removeChildWindow:';
    function childWindows: NSArray; message 'childWindows';
    function parentWindow: NSWindow; message 'parentWindow';
    procedure setParentWindow (window: NSWindow); message 'setParentWindow:';
    function graphicsContext: NSGraphicsContext; message 'graphicsContext';
    function userSpaceScaleFactor: CGFloat; message 'userSpaceScaleFactor';
    procedure setColorSpace (colorSpace: NSColorSpace); message 'setColorSpace:'; { available in 10_6 }
    function colorSpace: NSColorSpace; message 'colorSpace'; { available in 10_6 }
    class function windowNumbersWithOptions (options: NSWindowNumberListOptions): NSArray; message 'windowNumbersWithOptions:'; { available in 10_6 }
    class function windowNumberAtPoint_belowWindowWithWindowNumber (point: NSPoint; windowNumber_: NSInteger): NSInteger; message 'windowNumberAtPoint:belowWindowWithWindowNumber:'; { available in 10_6 }

    { Adopted protocols }
    function animationForKey (key: NSString): id; message 'animationForKey:';
    function animations: NSDictionary; message 'animations';
    function animator: id; message 'animator';
    class function defaultAnimationForKey (key: NSString): id; message 'defaultAnimationForKey:';
    procedure setIdentifier(newValue: NSString); message 'setIdentifier:';
    function identifier: NSString; message 'identifier';
    procedure setAnimations (animations_: NSDictionary); message 'setAnimations:';
    function validateUserInterfaceItem (anItem: NSValidatedUserInterfaceItemProtocol): boolean; message 'validateUserInterfaceItem:';
  end;


type
  NSWindow_NSKeyboardUI = objccategory external name 'NSKeyboardUI' (NSWindow)
    procedure setInitialFirstResponder (view: NSView); message 'setInitialFirstResponder:';
    function initialFirstResponder: NSView; message 'initialFirstResponder';
    procedure selectNextKeyView (sender: id); message 'selectNextKeyView:';
    procedure selectPreviousKeyView (sender: id); message 'selectPreviousKeyView:';
    procedure selectKeyViewFollowingView (aView: NSView); message 'selectKeyViewFollowingView:';
    procedure selectKeyViewPrecedingView (aView: NSView); message 'selectKeyViewPrecedingView:';
    function keyViewSelectionDirection: NSSelectionDirection; message 'keyViewSelectionDirection';
    procedure setDefaultButtonCell (defButt: NSButtonCell); message 'setDefaultButtonCell:';
    function defaultButtonCell: NSButtonCell; message 'defaultButtonCell';
    procedure disableKeyEquivalentForDefaultButtonCell; message 'disableKeyEquivalentForDefaultButtonCell';
    procedure enableKeyEquivalentForDefaultButtonCell; message 'enableKeyEquivalentForDefaultButtonCell';
    procedure setAutorecalculatesKeyViewLoop (flag: boolean); message 'setAutorecalculatesKeyViewLoop:';
    function autorecalculatesKeyViewLoop: boolean; message 'autorecalculatesKeyViewLoop';
    procedure recalculateKeyViewLoop; message 'recalculateKeyViewLoop';
  end;

type
  NSToolbarSupport = objccategory external (NSWindow)
    procedure setToolbar (toolbar: NSToolbar); message 'setToolbar:';
    function toolbar: NSToolbar; message 'toolbar';
    procedure toggleToolbarShown (sender: id); message 'toggleToolbarShown:';
    procedure runToolbarCustomizationPalette (sender: id); message 'runToolbarCustomizationPalette:';
    procedure setShowsToolbarButton (show: boolean); message 'setShowsToolbarButton:';
    function showsToolbarButton: boolean; message 'showsToolbarButton';
  end;

type
  NSDrag = objccategory external (NSWindow)
    procedure dragImage_at_offset_event_pasteboard_source_slideBack (anImage: NSImage; baseLocation: NSPoint; initialOffset: NSSize; event: NSEvent; pboard: NSPasteboard; sourceObj: id; slideFlag: boolean); message 'dragImage:at:offset:event:pasteboard:source:slideBack:';
    procedure registerForDraggedTypes (newTypes: NSArray); message 'registerForDraggedTypes:';
    procedure unregisterDraggedTypes; message 'unregisterDraggedTypes';
  end;

type
  NSCarbonExtensions = objccategory external (NSWindow)
    function initWithWindowRef (windowRef: pointer): NSWindow; message 'initWithWindowRef:';
    function windowRef: pointer; message 'windowRef';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSWindowDelegateProtocol = objcprotocol external name 'NSWindowDelegate' (NSObjectProtocol)
  optional
    function windowShouldClose (sender: id): boolean; message 'windowShouldClose:';
    function windowWillReturnFieldEditor_toObject (sender: NSWindow; client: id): id; message 'windowWillReturnFieldEditor:toObject:';
    function windowWillResize_toSize (sender: NSWindow; frameSize: NSSize): NSSize; message 'windowWillResize:toSize:';
    function windowWillUseStandardFrame_defaultFrame (window: NSWindow; newFrame: NSRect): NSRect; message 'windowWillUseStandardFrame:defaultFrame:';
    function windowShouldZoom_toFrame (window: NSWindow; newFrame: NSRect): boolean; message 'windowShouldZoom:toFrame:';
    function windowWillReturnUndoManager (window: NSWindow): NSUndoManager; message 'windowWillReturnUndoManager:';
    function window_willPositionSheet_usingRect (window: NSWindow; sheet: NSWindow; rect: NSRect): NSRect; message 'window:willPositionSheet:usingRect:';
    function window_shouldPopUpDocumentPathMenu (window: NSWindow; menu: NSMenu): boolean; message 'window:shouldPopUpDocumentPathMenu:'; { available in 10_5 }
    function window_shouldDragDocumentWithEvent_from_withPasteboard (window: NSWindow; event: NSEvent; dragImageLocation: NSPoint; pasteboard: NSPasteboard): boolean; message 'window:shouldDragDocumentWithEvent:from:withPasteboard:'; { available in 10_5 }
    function window_willUseFullScreenContentSize (window: NSWindow; proposedSize: NSSize): NSSize; message 'window:willUseFullScreenContentSize:'; { available in 10_7 }
    function window_willUseFullScreenPresentationOptions (window: NSWindow; proposedOptions: NSApplicationPresentationOptions): NSApplicationPresentationOptions; message 'window:willUseFullScreenPresentationOptions:'; { available in 10_7 }
    function customWindowsToEnterFullScreenForWindow (window: NSWindow): NSArray; message 'customWindowsToEnterFullScreenForWindow:'; { available in 10_7 }
    procedure window_startCustomAnimationToEnterFullScreenWithDuration (window: NSWindow; duration: NSTimeInterval); message 'window:startCustomAnimationToEnterFullScreenWithDuration:'; { available in 10_7 }
    procedure windowDidFailToEnterFullScreen (window: NSWindow); message 'windowDidFailToEnterFullScreen:'; { available in 10_7 }
    function customWindowsToExitFullScreenForWindow (window: NSWindow): NSArray; message 'customWindowsToExitFullScreenForWindow:'; { available in 10_7 }
    procedure window_startCustomAnimationToExitFullScreenWithDuration (window: NSWindow; duration: NSTimeInterval); message 'window:startCustomAnimationToExitFullScreenWithDuration:'; { available in 10_7 }
    procedure windowDidFailToExitFullScreen (window: NSWindow); message 'windowDidFailToExitFullScreen:'; { available in 10_7 }
    function window_willResizeForVersionBrowserWithMaxPreferredSize_maxAllowedSize (window: NSWindow; maxPreferredFrameSize: NSSize; maxAllowedFrameSize: NSSize): NSSize; message 'window:willResizeForVersionBrowserWithMaxPreferredSize:maxAllowedSize:'; { available in 10_7 }
    procedure window_willEncodeRestorableState (window: NSWindow; state: NSCoder); message 'window:willEncodeRestorableState:'; { available in 10_7 }
    procedure window_didDecodeRestorableState (window: NSWindow; state: NSCoder); message 'window:didDecodeRestorableState:'; { available in 10_7 }
    procedure windowDidResize (notification: NSNotification); message 'windowDidResize:';
    procedure windowDidExpose (notification: NSNotification); message 'windowDidExpose:';
    procedure windowWillMove (notification: NSNotification); message 'windowWillMove:';
    procedure windowDidMove (notification: NSNotification); message 'windowDidMove:';
    procedure windowDidBecomeKey (notification: NSNotification); message 'windowDidBecomeKey:';
    procedure windowDidResignKey (notification: NSNotification); message 'windowDidResignKey:';
    procedure windowDidBecomeMain (notification: NSNotification); message 'windowDidBecomeMain:';
    procedure windowDidResignMain (notification: NSNotification); message 'windowDidResignMain:';
    procedure windowWillClose (notification: NSNotification); message 'windowWillClose:';
    procedure windowWillMiniaturize (notification: NSNotification); message 'windowWillMiniaturize:';
    procedure windowDidMiniaturize (notification: NSNotification); message 'windowDidMiniaturize:';
    procedure windowDidDeminiaturize (notification: NSNotification); message 'windowDidDeminiaturize:';
    procedure windowDidUpdate (notification: NSNotification); message 'windowDidUpdate:';
    procedure windowDidChangeScreen (notification: NSNotification); message 'windowDidChangeScreen:';
    procedure windowDidChangeScreenProfile (notification: NSNotification); message 'windowDidChangeScreenProfile:';
    procedure windowDidChangeBackingProperties (notification: NSNotification); message 'windowDidChangeBackingProperties:'; { available in 10_7 }
    procedure windowWillBeginSheet (notification: NSNotification); message 'windowWillBeginSheet:';
    procedure windowDidEndSheet (notification: NSNotification); message 'windowDidEndSheet:';
    procedure windowWillStartLiveResize (notification: NSNotification); message 'windowWillStartLiveResize:'; { available in 10_6 }
    procedure windowDidEndLiveResize (notification: NSNotification); message 'windowDidEndLiveResize:'; { available in 10_6 }
    procedure windowWillEnterFullScreen (notification: NSNotification); message 'windowWillEnterFullScreen:'; { available in 10_7 }
    procedure windowDidEnterFullScreen (notification: NSNotification); message 'windowDidEnterFullScreen:'; { available in 10_7 }
    procedure windowWillExitFullScreen (notification: NSNotification); message 'windowWillExitFullScreen:'; { available in 10_7 }
    procedure windowDidExitFullScreen (notification: NSNotification); message 'windowDidExitFullScreen:'; { available in 10_7 }
    procedure windowWillEnterVersionBrowser (notification: NSNotification); message 'windowWillEnterVersionBrowser:'; { available in 10_7 }
    procedure windowDidEnterVersionBrowser (notification: NSNotification); message 'windowDidEnterVersionBrowser:'; { available in 10_7 }
    procedure windowWillExitVersionBrowser (notification: NSNotification); message 'windowWillExitVersionBrowser:'; { available in 10_7 }
    procedure windowDidExitVersionBrowser (notification: NSNotification); message 'windowDidExitVersionBrowser:'; { available in 10_7 }
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSWindowDidBecomeKeyNotification: NSString; cvar; external;
  NSWindowDidBecomeMainNotification: NSString; cvar; external;
  NSWindowDidChangeScreenNotification: NSString; cvar; external;
  NSWindowDidDeminiaturizeNotification: NSString; cvar; external;
  NSWindowDidExposeNotification: NSString; cvar; external;
  NSWindowDidMiniaturizeNotification: NSString; cvar; external;
  NSWindowDidMoveNotification: NSString; cvar; external;
  NSWindowDidResignKeyNotification: NSString; cvar; external;
  NSWindowDidResignMainNotification: NSString; cvar; external;
  NSWindowDidResizeNotification: NSString; cvar; external;
  NSWindowDidUpdateNotification: NSString; cvar; external;
  NSWindowWillCloseNotification: NSString; cvar; external;
  NSWindowWillMiniaturizeNotification: NSString; cvar; external;
  NSWindowWillMoveNotification: NSString; cvar; external;
  NSWindowWillBeginSheetNotification: NSString; cvar; external;
  NSWindowDidEndSheetNotification: NSString; cvar; external;
  NSWindowDidChangeBackingPropertiesNotification: NSString { available in 10_7 }; cvar; external;
  NSBackingPropertyOldScaleFactorKey: NSString { available in 10_7 }; cvar; external;
  NSBackingPropertyOldColorSpaceKey: NSString { available in 10_7 }; cvar; external;
  NSWindowDidChangeScreenProfileNotification: NSString; cvar; external;
  NSWindowWillStartLiveResizeNotification: NSString { available in 10_6 }; cvar; external;
  NSWindowDidEndLiveResizeNotification: NSString { available in 10_6 }; cvar; external;
  NSWindowWillEnterFullScreenNotification: NSString { available in 10_7 }; cvar; external;
  NSWindowDidEnterFullScreenNotification: NSString { available in 10_7 }; cvar; external;
  NSWindowWillExitFullScreenNotification: NSString { available in 10_7 }; cvar; external;
  NSWindowDidExitFullScreenNotification: NSString { available in 10_7 }; cvar; external;
  NSWindowWillEnterVersionBrowserNotification: NSString { available in 10_7 }; cvar; external;
  NSWindowDidEnterVersionBrowserNotification: NSString { available in 10_7 }; cvar; external;
  NSWindowWillExitVersionBrowserNotification: NSString { available in 10_7 }; cvar; external;
  NSWindowDidExitVersionBrowserNotification: NSString { available in 10_7 }; cvar; external;
{$endif}

