{ Parsed from AVFoundation.framework (MacOSX10.8) AVMetadataItem.h }
{ Created on Mon Sep 10 11:46:24 2012 }


{$ifdef TYPES}
type
  AVMetadataItemPtr = ^AVMetadataItem;
  AVMutableMetadataItemPtr = ^AVMutableMetadataItem;
{$endif}

{$ifdef CLASSES}

type
  AVMetadataItem = objcclass external (NSObject, AVAsynchronousKeyValueLoadingProtocol, NSCopyingProtocol, NSMutableCopyingProtocol)
  private
    _priv: AVMetadataItemInternal;
  public
    function key: id; message 'key';
    function commonKey: NSString; message 'commonKey';
    function keySpace: NSString; message 'keySpace';
    function locale: NSLocale; message 'locale';
    function time: CMTime; message 'time';
    function duration: CMTime; message 'duration';
    function value: id; message 'value';
    function extraAttributes: NSDictionary; message 'extraAttributes';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure loadValuesAsynchronouslyForKeys_completionHandler (keys: NSArray; handler: OpaqueCBlock); message 'loadValuesAsynchronouslyForKeys:completionHandler:';
    function mutableCopyWithZone (zone: NSZonePtr): id; message 'mutableCopyWithZone:';
    function statusOfValueForKey_error (key: NSString; outError: NSErrorPtr): AVKeyValueStatus; message 'statusOfValueForKey:error:';
  end;


type
  AVMetadataItemTypeCoercion = objccategory external (AVMetadataItem)
    function stringValue: NSString; message 'stringValue';
    function numberValue: NSNumber; message 'numberValue';
    function dateValue: NSDate; message 'dateValue';
    function dataValue: NSData; message 'dataValue';
  end;

type
  AVAsynchronousKeyValueLoading = objccategory external (AVMetadataItem)
    function statusOfValueForKey_error (key_: NSString; outError: NSErrorPtr): AVKeyValueStatus; message 'statusOfValueForKey:error:'; { available in 10_7, 4_2 }
    procedure loadValuesAsynchronouslyForKeys_completionHandler (keys: NSArray; handler: OpaqueCBlock); message 'loadValuesAsynchronouslyForKeys:completionHandler:'; { available in 10_7, 4_2 }
  end;

type
  AVMetadataItemArrayFiltering = objccategory external (AVMetadataItem)
    class function metadataItemsFromArray_filteredAndSortedAccordingToPreferredLanguages (metadataItems: NSArray; preferredLanguages: NSArray): NSArray; message 'metadataItemsFromArray:filteredAndSortedAccordingToPreferredLanguages:'; { available in 10_8, TBD }
    class function metadataItemsFromArray_withLocale (metadataItems: NSArray; locale_: NSLocale): NSArray; message 'metadataItemsFromArray:withLocale:';
    class function metadataItemsFromArray_withKey_keySpace (metadataItems: NSArray; key_: id; keySpace_: NSString): NSArray; message 'metadataItemsFromArray:withKey:keySpace:';
  end;


type
  AVMutableMetadataItem = objcclass external (AVMetadataItem)
  private
    _mutablePriv: AVMutableMetadataItemInternal;
  public
    procedure setKey(newValue: id); message 'setKey:';
    function key: id; message 'key';
    procedure setKeySpace(newValue: NSString); message 'setKeySpace:';
    function keySpace: NSString; message 'keySpace';
    procedure setLocale(newValue: NSLocale); message 'setLocale:';
    function locale: NSLocale; message 'locale';
    procedure setTime(newValue: CMTime); message 'setTime:';
    function time: CMTime; message 'time';
    procedure setDuration(newValue: CMTime); message 'setDuration:';
    function duration: CMTime; message 'duration';
    procedure setValue(newValue: id); message 'setValue:';
    function value: id; message 'value';
    procedure setExtraAttributes(newValue: NSDictionary); message 'setExtraAttributes:';
    function extraAttributes: NSDictionary; message 'extraAttributes';
    class function metadataItem: AVMutableMetadataItem; message 'metadataItem';
  end;
{$endif}

