{ Parsed from CoreBluetooth.framework (MacOSX10.8) CBCentralManager.h }
{ Created on Mon Sep 10 11:47:07 2012 }


{$ifdef TYPES}
type
  CBCentralManagerPtr = ^CBCentralManager;
  CBCentralManagerDelegateProtocolPtr = ^CBCentralManagerDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  CBCentralManagerStateUnknown = 0;
  CBCentralManagerStateResetting = 1;
  CBCentralManagerStateUnsupported = 2;
  CBCentralManagerStateUnauthorized = 3;
  CBCentralManagerStatePoweredOff = 4;
  CBCentralManagerStatePoweredOn = 5;

type
  CBCentralManagerState = NSInteger;
  CBCentralManagerStatePtr = ^CBCentralManagerState;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  CBCentralManagerScanOptionAllowDuplicatesKey: NSString; cvar; external;
  CBConnectPeripheralOptionNotifyOnDisconnectionKey: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  CBCentralManager = objcclass external (NSObject)
  private
    _delegate: CBCentralManagerDelegateProtocol;
    _state: CBCentralManagerState;
  public
    procedure setDelegate(newValue: CBCentralManagerDelegateProtocol); message 'setDelegate:';
    function delegate: CBCentralManagerDelegateProtocol; message 'delegate';
    function state: CBCentralManagerState; message 'state';
    function initWithDelegate_queue (delegate_: CBCentralManagerDelegateProtocol; queue: dispatch_queue_t): CBCentralManager; message 'initWithDelegate:queue:';
    procedure retrievePeripherals (peripheralUUIDs: NSArray); message 'retrievePeripherals:';
    procedure retrieveConnectedPeripherals; message 'retrieveConnectedPeripherals';
    procedure scanForPeripheralsWithServices_options (serviceUUIDs: NSArray; options: NSDictionary); message 'scanForPeripheralsWithServices:options:';
    procedure stopScan; message 'stopScan';
    procedure connectPeripheral_options (peripheral: CBPeripheral; options: NSDictionary); message 'connectPeripheral:options:';
    procedure cancelPeripheralConnection (peripheral: CBPeripheral); message 'cancelPeripheralConnection:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  CBAdvertisementDataServiceUUIDsKey: NSString; cvar; external;
  CBAdvertisementDataLocalNameKey: NSString; cvar; external;
  CBAdvertisementDataTxPowerLevelKey: NSString; cvar; external;
  CBAdvertisementDataManufacturerDataKey: NSString; cvar; external;
  CBAdvertisementDataServiceDataKey: NSString; cvar; external;
{$endif}

{$ifdef PROTOCOLS}

type
  CBCentralManagerDelegateProtocol = objcprotocol external name 'CBCentralManagerDelegate' (NSObjectProtocol)
  required
    procedure centralManagerDidUpdateState (central: CBCentralManager); message 'centralManagerDidUpdateState:';
  optional
    procedure centralManager_didRetrievePeripherals (central: CBCentralManager; peripherals: NSArray); message 'centralManager:didRetrievePeripherals:';
    procedure centralManager_didRetrieveConnectedPeripherals (central: CBCentralManager; peripherals: NSArray); message 'centralManager:didRetrieveConnectedPeripherals:';
    procedure centralManager_didDiscoverPeripheral_advertisementData_RSSI (central: CBCentralManager; peripheral: CBPeripheral; advertisementData: NSDictionary; RSSI: NSNumber); message 'centralManager:didDiscoverPeripheral:advertisementData:RSSI:';
    procedure centralManager_didConnectPeripheral (central: CBCentralManager; peripheral: CBPeripheral); message 'centralManager:didConnectPeripheral:';
    procedure centralManager_didFailToConnectPeripheral_error (central: CBCentralManager; peripheral: CBPeripheral; error: NSError); message 'centralManager:didFailToConnectPeripheral:error:';
    procedure centralManager_didDisconnectPeripheral_error (central: CBCentralManager; peripheral: CBPeripheral; error: NSError); message 'centralManager:didDisconnectPeripheral:error:';
  end;
{$endif}

