{ Parsed from CoreBluetooth.framework (MacOSX10.8) CBPeripheral.h }
{ Created on Mon Sep 10 11:47:07 2012 }


{$ifdef TYPES}
type
  CBPeripheralPtr = ^CBPeripheral;
  CBPeripheralDelegateProtocolPtr = ^CBPeripheralDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  CBCharacteristicWriteWithResponse = 0;
  CBCharacteristicWriteWithoutResponse = 1;

type
  CBCharacteristicWriteType = NSInteger;
  CBCharacteristicWriteTypePtr = ^CBCharacteristicWriteType;
{$endif}

{$ifdef CLASSES}

type
  CBPeripheral = objcclass external (NSObject)
  private
    _delegate: CBPeripheralDelegateProtocol;
    _UUID: CFUUIDRef;
    _name: NSString;
    _RSSI: NSNumber;
    _isConnected: boolean;
    _services: NSArray;
  public
    procedure setDelegate(newValue: CBPeripheralDelegateProtocol); message 'setDelegate:';
    function delegate: CBPeripheralDelegateProtocol; message 'delegate';
    function UUID: CFUUIDRef; message 'UUID';
    function name: NSString; message 'name';
    function RSSI: NSNumber; message 'RSSI';
    function isConnected: boolean; message 'isConnected';
    function services: NSArray; message 'services';
    procedure readRSSI; message 'readRSSI';
    procedure discoverServices (serviceUUIDs: NSArray); message 'discoverServices:';
    procedure discoverIncludedServices_forService (includedServiceUUIDs: NSArray; service: CBService); message 'discoverIncludedServices:forService:';
    procedure discoverCharacteristics_forService (characteristicUUIDs: NSArray; service: CBService); message 'discoverCharacteristics:forService:';
    procedure readValueForCharacteristic (characteristic: CBCharacteristic); message 'readValueForCharacteristic:';
    procedure writeValue_forCharacteristic_type (data: NSData; characteristic: CBCharacteristic; type_: CBCharacteristicWriteType); message 'writeValue:forCharacteristic:type:';
    procedure reliablyWriteValues_forCharacteristics (values: NSArray; array_: NSArray); message 'reliablyWriteValues:forCharacteristics:';
    procedure setBroadcastValue_forCharacteristic (broadcastValue: boolean; characteristic: CBCharacteristic); message 'setBroadcastValue:forCharacteristic:';
    procedure setNotifyValue_forCharacteristic (notifyValue: boolean; characteristic: CBCharacteristic); message 'setNotifyValue:forCharacteristic:';
    procedure discoverDescriptorsForCharacteristic (characteristic: CBCharacteristic); message 'discoverDescriptorsForCharacteristic:';
    procedure readValueForDescriptor (descriptor: CBDescriptor); message 'readValueForDescriptor:';
    procedure writeValue_forDescriptor (data: NSData; descriptor: CBDescriptor); message 'writeValue:forDescriptor:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  CBPeripheralDelegateProtocol = objcprotocol external name 'CBPeripheralDelegate' (NSObjectProtocol)
  optional
    procedure peripheralDidUpdateRSSI_error (peripheral: CBPeripheral; error: NSError); message 'peripheralDidUpdateRSSI:error:';
    procedure peripheral_didDiscoverServices (peripheral: CBPeripheral; error: NSError); message 'peripheral:didDiscoverServices:';
    procedure peripheral_didDiscoverIncludedServicesForService_error (peripheral: CBPeripheral; service: CBService; error: NSError); message 'peripheral:didDiscoverIncludedServicesForService:error:';
    procedure peripheral_didDiscoverCharacteristicsForService_error (peripheral: CBPeripheral; service: CBService; error: NSError); message 'peripheral:didDiscoverCharacteristicsForService:error:';
    procedure peripheral_didUpdateValueForCharacteristic_error (peripheral: CBPeripheral; characteristic: CBCharacteristic; error: NSError); message 'peripheral:didUpdateValueForCharacteristic:error:';
    procedure peripheral_didWriteValueForCharacteristic_error (peripheral: CBPeripheral; characteristic: CBCharacteristic; error: NSError); message 'peripheral:didWriteValueForCharacteristic:error:';
    procedure peripheral_didReliablyWriteValuesForCharacteristics_error (peripheral: CBPeripheral; characteristics: NSArray; error: NSError); message 'peripheral:didReliablyWriteValuesForCharacteristics:error:';
    procedure peripheral_didUpdateBroadcastStateForCharacteristic_error (peripheral: CBPeripheral; characteristic: CBCharacteristic; error: NSError); message 'peripheral:didUpdateBroadcastStateForCharacteristic:error:';
    procedure peripheral_didUpdateNotificationStateForCharacteristic_error (peripheral: CBPeripheral; characteristic: CBCharacteristic; error: NSError); message 'peripheral:didUpdateNotificationStateForCharacteristic:error:';
    procedure peripheral_didDiscoverDescriptorsForCharacteristic_error (peripheral: CBPeripheral; characteristic: CBCharacteristic; error: NSError); message 'peripheral:didDiscoverDescriptorsForCharacteristic:error:';
    procedure peripheral_didUpdateValueForDescriptor_error (peripheral: CBPeripheral; descriptor: CBDescriptor; error: NSError); message 'peripheral:didUpdateValueForDescriptor:error:';
    procedure peripheral_didWriteValueForDescriptor_error (peripheral: CBPeripheral; descriptor: CBDescriptor; error: NSError); message 'peripheral:didWriteValueForDescriptor:error:';
  end;
{$endif}

