{ Parsed from Foundation.framework (MacOSX10.8) NSData.h }
{ Created on Mon Sep 10 11:48:03 2012 }


{$ifdef TYPES}
type
  NSDataPtr = ^NSData;
  NSMutableDataPtr = ^NSMutableData;
  NSPurgeableDataPtr = ^NSPurgeableData;
{$endif}

{$ifdef TYPES}
type
  NSDataReadingOptions = NSUInteger;
  NSDataReadingOptionsPtr = ^NSDataReadingOptions;

const
  NSDataReadingMappedIfSafe = 1 shl 0;
  NSDataReadingUncached = 1 shl 1;
  NSDataReadingMappedAlways = 1 shl 3 { available in 10_7, 5_0 };
  NSDataReadingMapped = NSDataReadingMappedIfSafe;
  NSMappedRead = NSDataReadingMapped;
  NSUncachedRead = NSDataReadingUncached;

type
  NSDataWritingOptions = NSUInteger;
  NSDataWritingOptionsPtr = ^NSDataWritingOptions;

const
  NSDataWritingAtomic = 1 shl 0;
  NSDataWritingWithoutOverwriting = 1 shl 1 { available in 10_8, 6_0 };
  NSDataWritingFileProtectionNone = $10000000 { available in 4_0 };
  NSDataWritingFileProtectionComplete = $20000000 { available in 4_0 };
  NSDataWritingFileProtectionCompleteUnlessOpen = $30000000 { available in 5_0 };
  NSDataWritingFileProtectionCompleteUntilFirstUserAuthentication = $40000000 { available in 5_0 };
  NSDataWritingFileProtectionMask = $f0000000 { available in 4_0 };
  NSAtomicWrite = NSDataWritingAtomic;

type
  NSDataSearchOptions = NSUInteger;
  NSDataSearchOptionsPtr = ^NSDataSearchOptions;

const
  NSDataSearchBackwards = 1 shl 0;
  NSDataSearchAnchored = 1 shl 1;
{$endif}

{$ifdef CLASSES}

type
  NSData = objcclass external (NSObject, NSCopyingProtocol, NSMutableCopyingProtocol, NSSecureCodingProtocol)
  public
    function length: NSUInteger; message 'length';
    function bytes: pointer; message 'bytes';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function mutableCopyWithZone (zone: NSZonePtr): id; message 'mutableCopyWithZone:';
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;


type
  NSExtendedData = objccategory external (NSData)
    function description: NSString; message 'description';
    procedure getBytes_length (buffer: pointer; length_: NSUInteger); message 'getBytes:length:';
    procedure getBytes_range (buffer: pointer; range: NSRange); message 'getBytes:range:';
    function isEqualToData (other: NSData): boolean; message 'isEqualToData:';
    function subdataWithRange (range: NSRange): NSData; message 'subdataWithRange:';
    function writeToFile_atomically (path: NSString; useAuxiliaryFile: boolean): boolean; message 'writeToFile:atomically:';
    function writeToURL_atomically (url: NSURL; atomically: boolean): boolean; message 'writeToURL:atomically:';
    function writeToFile_options_error (path: NSString; writeOptionsMask: NSDataWritingOptions; errorPtr: NSErrorPtr): boolean; message 'writeToFile:options:error:';
    function writeToURL_options_error (url: NSURL; writeOptionsMask: NSDataWritingOptions; errorPtr: NSErrorPtr): boolean; message 'writeToURL:options:error:';
    function rangeOfData_options_range (dataToFind: NSData; mask: NSDataSearchOptions; searchRange: NSRange): NSRange; message 'rangeOfData:options:range:'; { available in 10_6, 4_0 }
  end;

type
  NSDataCreation = objccategory external (NSData)
    class function data: id; message 'data';
    class function dataWithBytes_length (bytes_: pointer; length_: NSUInteger): id; message 'dataWithBytes:length:';
    class function dataWithBytesNoCopy_length (bytes_: pointer; length_: NSUInteger): id; message 'dataWithBytesNoCopy:length:';
    class function dataWithBytesNoCopy_length_freeWhenDone (bytes_: pointer; length_: NSUInteger; b: boolean): id; message 'dataWithBytesNoCopy:length:freeWhenDone:';
    class function dataWithContentsOfFile_options_error (path: NSString; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'dataWithContentsOfFile:options:error:';
    class function dataWithContentsOfURL_options_error (url: NSURL; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'dataWithContentsOfURL:options:error:';
    class function dataWithContentsOfFile (path: NSString): id; message 'dataWithContentsOfFile:';
    class function dataWithContentsOfURL (url: NSURL): id; message 'dataWithContentsOfURL:';
    function initWithBytes_length (bytes_: pointer; length_: NSUInteger): id; message 'initWithBytes:length:';
    function initWithBytesNoCopy_length (bytes_: pointer; length_: NSUInteger): id; message 'initWithBytesNoCopy:length:';
    function initWithBytesNoCopy_length_freeWhenDone (bytes_: pointer; length_: NSUInteger; b: boolean): id; message 'initWithBytesNoCopy:length:freeWhenDone:';
    function initWithContentsOfFile_options_error (path: NSString; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'initWithContentsOfFile:options:error:';
    function initWithContentsOfURL_options_error (url: NSURL; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'initWithContentsOfURL:options:error:';
    function initWithContentsOfFile (path: NSString): id; message 'initWithContentsOfFile:';
    function initWithContentsOfURL (url: NSURL): id; message 'initWithContentsOfURL:';
    function initWithData (data_: NSData): id; message 'initWithData:';
    class function dataWithData (data_: NSData): id; message 'dataWithData:';
  end;

type
  NSData_NSDeprecated = objccategory external name 'NSDeprecated' (NSData)
    procedure getBytes (buffer: pointer); message 'getBytes:';
    class function dataWithContentsOfMappedFile (path: NSString): id; message 'dataWithContentsOfMappedFile:';
    function initWithContentsOfMappedFile (path: NSString): id; message 'initWithContentsOfMappedFile:';
  end;


type
  NSMutableData = objcclass external (NSData)
  public
    function mutableBytes: pointer; message 'mutableBytes';
    procedure setLength (length_: NSUInteger); message 'setLength:';
  end;


type
  NSExtendedMutableData = objccategory external (NSMutableData)
    procedure appendBytes_length (bytes_: pointer; length_: NSUInteger); message 'appendBytes:length:';
    procedure appendData (other: NSData); message 'appendData:';
    procedure increaseLengthBy (extraLength: NSUInteger); message 'increaseLengthBy:';
    procedure replaceBytesInRange_withBytes (range: NSRange; bytes_: pointer); message 'replaceBytesInRange:withBytes:';
    procedure resetBytesInRange (range: NSRange); message 'resetBytesInRange:';
    procedure setData (data: NSData); message 'setData:';
    procedure replaceBytesInRange_withBytes_length (range: NSRange; replacementBytes: pointer; replacementLength: NSUInteger); message 'replaceBytesInRange:withBytes:length:';
  end;

type
  NSMutableDataCreation = objccategory external (NSMutableData)
    class function dataWithCapacity (aNumItems: NSUInteger): id; message 'dataWithCapacity:';
    class function dataWithLength (length_: NSUInteger): id; message 'dataWithLength:';
    function initWithCapacity (capacity: NSUInteger): id; message 'initWithCapacity:';
    function initWithLength (length_: NSUInteger): id; message 'initWithLength:';
  end;


type
  NSPurgeableData = objcclass external (NSMutableData, NSDiscardableContentProtocol)
  private
    _length: NSUInteger;
    _accessCount: cint32;
    _private:array[0..31] of cuint8;
    _reserved: pointer;

    { Adopted protocols }
    function beginContentAccess: boolean; message 'beginContentAccess';
    procedure discardContentIfPossible; message 'discardContentIfPossible';
    procedure endContentAccess; message 'endContentAccess';
    function isContentDiscarded: boolean; message 'isContentDiscarded';
  end;
{$endif}

