{ Parsed from Foundation.framework (MacOSX10.8) NSLocale.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{ Types from NSLocaleGeneralInfo }
{$ifdef TYPES}

type
  NSLocaleLanguageDirection = NSUInteger;
type
  NSLocaleLanguageDirectionPtr = ^NSLocaleLanguageDirection;

const
  NSLocaleLanguageDirectionUnknown = kCFLocaleLanguageDirectionUnknown;
  NSLocaleLanguageDirectionLeftToRight = kCFLocaleLanguageDirectionLeftToRight;
  NSLocaleLanguageDirectionRightToLeft = kCFLocaleLanguageDirectionRightToLeft;
  NSLocaleLanguageDirectionTopToBottom = kCFLocaleLanguageDirectionTopToBottom;
  NSLocaleLanguageDirectionBottomToTop = kCFLocaleLanguageDirectionBottomToTop;
{$endif}


{$ifdef TYPES}
type
  NSLocalePtr = ^NSLocale;
{$endif}

{$ifdef CLASSES}

type
  NSLocale = objcclass external (NSObject, NSCopyingProtocol, NSSecureCodingProtocol)
  public
    function objectForKey (key: id): id; message 'objectForKey:';
    function displayNameForKey_value (key: id; value: id): NSString; message 'displayNameForKey:value:';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;


type
  NSExtendedLocale = objccategory external (NSLocale)
    function localeIdentifier: NSString; message 'localeIdentifier';
  end;

type
  NSLocaleCreation = objccategory external (NSLocale)
    class function systemLocale: id; message 'systemLocale';
    class function currentLocale: id; message 'currentLocale';
    class function autoupdatingCurrentLocale: id; message 'autoupdatingCurrentLocale'; { available in 10_5, 2_0 }
    function initWithLocaleIdentifier (string_: NSString): id; message 'initWithLocaleIdentifier:';
  end;

type
  NSLocaleGeneralInfo = objccategory external (NSLocale)
    class function availableLocaleIdentifiers: NSArray; message 'availableLocaleIdentifiers';
    class function ISOLanguageCodes: NSArray; message 'ISOLanguageCodes';
    class function ISOCountryCodes: NSArray; message 'ISOCountryCodes';
    class function ISOCurrencyCodes: NSArray; message 'ISOCurrencyCodes';
    class function commonISOCurrencyCodes: NSArray; message 'commonISOCurrencyCodes'; { available in 10_5, 2_0 }
    class function preferredLanguages: NSArray; message 'preferredLanguages'; { available in 10_5, 2_0 }
    class function componentsFromLocaleIdentifier (string_: NSString): NSDictionary; message 'componentsFromLocaleIdentifier:';
    class function localeIdentifierFromComponents (dict: NSDictionary): NSString; message 'localeIdentifierFromComponents:';
    class function canonicalLocaleIdentifierFromString (string_: NSString): NSString; message 'canonicalLocaleIdentifierFromString:';
    class function canonicalLanguageIdentifierFromString (string_: NSString): NSString; message 'canonicalLanguageIdentifierFromString:';
    class function localeIdentifierFromWindowsLocaleCode (lcid: cuint32): NSString; message 'localeIdentifierFromWindowsLocaleCode:'; { available in 10_6, 4_0 }
    class function windowsLocaleCodeFromLocaleIdentifier (localeIdentifier: NSString): cuint32; message 'windowsLocaleCodeFromLocaleIdentifier:'; { available in 10_6, 4_0 }
    class function characterDirectionForLanguage (isoLangCode: NSString): NSLocaleLanguageDirection; message 'characterDirectionForLanguage:'; { available in 10_6, 4_0 }
    class function lineDirectionForLanguage (isoLangCode: NSString): NSLocaleLanguageDirection; message 'lineDirectionForLanguage:'; { available in 10_6, 4_0 }
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSCurrentLocaleDidChangeNotification: NSString { available in 10_5, 2_0 }; cvar; external;
  NSLocaleIdentifier: NSString; cvar; external;
  NSLocaleLanguageCode: NSString; cvar; external;
  NSLocaleCountryCode: NSString; cvar; external;
  NSLocaleScriptCode: NSString; cvar; external;
  NSLocaleVariantCode: NSString; cvar; external;
  NSLocaleExemplarCharacterSet: NSString; cvar; external;
  NSLocaleCalendar: NSString; cvar; external;
  NSLocaleCollationIdentifier: NSString; cvar; external;
  NSLocaleUsesMetricSystem: NSString; cvar; external;
  NSLocaleMeasurementSystem: NSString; cvar; external;
  NSLocaleDecimalSeparator: NSString; cvar; external;
  NSLocaleGroupingSeparator: NSString; cvar; external;
  NSLocaleCurrencySymbol: NSString; cvar; external;
  NSLocaleCurrencyCode: NSString; cvar; external;
  NSLocaleCollatorIdentifier: NSString { available in 10_6, 4_0 }; cvar; external;
  NSLocaleQuotationBeginDelimiterKey: NSString { available in 10_6, 4_0 }; cvar; external;
  NSLocaleQuotationEndDelimiterKey: NSString { available in 10_6, 4_0 }; cvar; external;
  NSLocaleAlternateQuotationBeginDelimiterKey: NSString { available in 10_6, 4_0 }; cvar; external;
  NSLocaleAlternateQuotationEndDelimiterKey: NSString { available in 10_6, 4_0 }; cvar; external;
  NSGregorianCalendar: NSString; cvar; external;
  NSBuddhistCalendar: NSString; cvar; external;
  NSChineseCalendar: NSString; cvar; external;
  NSHebrewCalendar: NSString; cvar; external;
  NSIslamicCalendar: NSString; cvar; external;
  NSIslamicCivilCalendar: NSString; cvar; external;
  NSJapaneseCalendar: NSString; cvar; external;
  NSRepublicOfChinaCalendar: NSString { available in 10_6, 4_0 }; cvar; external;
  NSPersianCalendar: NSString { available in 10_6, 4_0 }; cvar; external;
  NSIndianCalendar: NSString { available in 10_6, 4_0 }; cvar; external;
  NSISO8601Calendar: NSString { available in 10_6, 4_0 }; cvar; external;
{$endif}

