{ Parsed from Foundation.framework (MacOSX10.8) NSLock.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{$ifdef TYPES}
type
  NSLockPtr = ^NSLock;
  NSConditionLockPtr = ^NSConditionLock;
  NSRecursiveLockPtr = ^NSRecursiveLock;
  NSConditionPtr = ^NSCondition;
  NSLockingProtocolPtr = ^NSLockingProtocol;
{$endif}

{$ifdef PROTOCOLS}

type
  NSLockingProtocol = objcprotocol external name 'NSLocking'
    procedure lock; message 'lock';
    procedure unlock; message 'unlock';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSLock = objcclass external (NSObject, NSLockingProtocol)
  private
    _priv: pointer;
  public
    function tryLock: boolean; message 'tryLock';
    function lockBeforeDate (limit: NSDate): boolean; message 'lockBeforeDate:';
    procedure setName (n: NSString); message 'setName:'; { available in 10_5, 2_0 }
    function name: NSString; message 'name'; { available in 10_5, 2_0 }

    { Adopted protocols }
    procedure lock; message 'lock';
    procedure unlock; message 'unlock';
  end;

type
  NSConditionLock = objcclass external (NSObject, NSLockingProtocol)
  private
    _priv: pointer;
  public
    function initWithCondition (condition: NSInteger): id; message 'initWithCondition:';
    function condition: NSInteger; message 'condition';
    procedure lockWhenCondition (condition_: NSInteger); message 'lockWhenCondition:';
    function tryLock: boolean; message 'tryLock';
    function tryLockWhenCondition (condition_: NSInteger): boolean; message 'tryLockWhenCondition:';
    procedure unlockWithCondition (condition_: NSInteger); message 'unlockWithCondition:';
    function lockBeforeDate (limit: NSDate): boolean; message 'lockBeforeDate:';
    function lockWhenCondition_beforeDate (condition_: NSInteger; limit: NSDate): boolean; message 'lockWhenCondition:beforeDate:';
    procedure setName (n: NSString); message 'setName:'; { available in 10_5, 2_0 }
    function name: NSString; message 'name'; { available in 10_5, 2_0 }

    { Adopted protocols }
    procedure lock; message 'lock';
    procedure unlock; message 'unlock';
  end;

type
  NSRecursiveLock = objcclass external (NSObject, NSLockingProtocol)
  private
    _priv: pointer;
  public
    function tryLock: boolean; message 'tryLock';
    function lockBeforeDate (limit: NSDate): boolean; message 'lockBeforeDate:';
    procedure setName (n: NSString); message 'setName:'; { available in 10_5, 2_0 }
    function name: NSString; message 'name'; { available in 10_5, 2_0 }

    { Adopted protocols }
    procedure lock; message 'lock';
    procedure unlock; message 'unlock';
  end;

type
  NSCondition = objcclass external (NSObject, NSLockingProtocol)
  private
    _priv: pointer;
  public
    procedure wait; message 'wait';
    function waitUntilDate (limit: NSDate): boolean; message 'waitUntilDate:';
    procedure signal; message 'signal';
    procedure broadcast; message 'broadcast';
    procedure setName (n: NSString); message 'setName:';
    function name: NSString; message 'name';

    { Adopted protocols }
    procedure lock; message 'lock';
    procedure unlock; message 'unlock';
  end;
{$endif}

