{ Parsed from Foundation.framework (MacOSX10.8) NSNumberFormatter.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{ Types from NSNumberFormatter }
{$ifdef TYPES}

type
  NSNumberFormatterStyle = NSUInteger;
type
  NSNumberFormatterStylePtr = ^NSNumberFormatterStyle;

const
  NSNumberFormatterNoStyle = kCFNumberFormatterNoStyle;
  NSNumberFormatterDecimalStyle = kCFNumberFormatterDecimalStyle;
  NSNumberFormatterCurrencyStyle = kCFNumberFormatterCurrencyStyle;
  NSNumberFormatterPercentStyle = kCFNumberFormatterPercentStyle;
  NSNumberFormatterScientificStyle = kCFNumberFormatterScientificStyle;
  NSNumberFormatterSpellOutStyle = kCFNumberFormatterSpellOutStyle;

type
  NSNumberFormatterBehavior = NSUInteger;
type
  NSNumberFormatterBehaviorPtr = ^NSNumberFormatterBehavior;

const
  NSNumberFormatterBehaviorDefault = 0;
  {$if (defined(TARGET_OS_MAC) and not (defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
  NSNumberFormatterBehavior10_0 = 1000;
  {$endif}
  NSNumberFormatterBehavior10_4 = 1040;

type
  NSNumberFormatterPadPosition = NSUInteger;
type
  NSNumberFormatterPadPositionPtr = ^NSNumberFormatterPadPosition;

const
  NSNumberFormatterPadBeforePrefix = kCFNumberFormatterPadBeforePrefix;
  NSNumberFormatterPadAfterPrefix = kCFNumberFormatterPadAfterPrefix;
  NSNumberFormatterPadBeforeSuffix = kCFNumberFormatterPadBeforeSuffix;
  NSNumberFormatterPadAfterSuffix = kCFNumberFormatterPadAfterSuffix;

type
  NSNumberFormatterRoundingMode = NSUInteger;
type
  NSNumberFormatterRoundingModePtr = ^NSNumberFormatterRoundingMode;

const
  NSNumberFormatterRoundCeiling = kCFNumberFormatterRoundCeiling;
  NSNumberFormatterRoundFloor = kCFNumberFormatterRoundFloor;
  NSNumberFormatterRoundDown = kCFNumberFormatterRoundDown;
  NSNumberFormatterRoundUp = kCFNumberFormatterRoundUp;
  NSNumberFormatterRoundHalfEven = kCFNumberFormatterRoundHalfEven;
  NSNumberFormatterRoundHalfDown = kCFNumberFormatterRoundHalfDown;
  NSNumberFormatterRoundHalfUp = kCFNumberFormatterRoundHalfUp;
{$endif}


{$ifdef TYPES}
type
  NSNumberFormatterPtr = ^NSNumberFormatter;
{$endif}

{$ifdef CLASSES}

type
  NSNumberFormatter = objcclass external (NSFormatter)
  private
    _attributes: NSMutableDictionary;
    _formatter: CFNumberFormatterRef;
    _counter: NSUInteger;
    _reserved:array[0..11] of pointer;
  public
    function getObjectValue_forString_range_error (obj: idPtr; string_: NSString; rangep: NSRangePtr; error: NSErrorPtr): boolean; message 'getObjectValue:forString:range:error:';
    function stringFromNumber (number: NSNumber): NSString; message 'stringFromNumber:';
    function numberFromString (string_: NSString): NSNumber; message 'numberFromString:';
    class function localizedStringFromNumber_numberStyle (num: NSNumber; nstyle: NSNumberFormatterStyle): NSString; message 'localizedStringFromNumber:numberStyle:'; { available in 10_6, 4_0 }
    function numberStyle: NSNumberFormatterStyle; message 'numberStyle';
    procedure setNumberStyle (style: NSNumberFormatterStyle); message 'setNumberStyle:';
    function locale: NSLocale; message 'locale';
    procedure setLocale (locale_: NSLocale); message 'setLocale:';
    function generatesDecimalNumbers: boolean; message 'generatesDecimalNumbers';
    procedure setGeneratesDecimalNumbers (b: boolean); message 'setGeneratesDecimalNumbers:';
    function formatterBehavior: NSNumberFormatterBehavior; message 'formatterBehavior';
    procedure setFormatterBehavior (behavior: NSNumberFormatterBehavior); message 'setFormatterBehavior:';
    class function defaultFormatterBehavior: NSNumberFormatterBehavior; message 'defaultFormatterBehavior';
    class procedure setDefaultFormatterBehavior (behavior: NSNumberFormatterBehavior); message 'setDefaultFormatterBehavior:';
    function negativeFormat: NSString; message 'negativeFormat';
    procedure setNegativeFormat (format: NSString); message 'setNegativeFormat:';
    function textAttributesForNegativeValues: NSDictionary; message 'textAttributesForNegativeValues';
    procedure setTextAttributesForNegativeValues (newAttributes: NSDictionary); message 'setTextAttributesForNegativeValues:';
    function positiveFormat: NSString; message 'positiveFormat';
    procedure setPositiveFormat (format: NSString); message 'setPositiveFormat:';
    function textAttributesForPositiveValues: NSDictionary; message 'textAttributesForPositiveValues';
    procedure setTextAttributesForPositiveValues (newAttributes: NSDictionary); message 'setTextAttributesForPositiveValues:';
    function allowsFloats: boolean; message 'allowsFloats';
    procedure setAllowsFloats (flag: boolean); message 'setAllowsFloats:';
    function decimalSeparator: NSString; message 'decimalSeparator';
    procedure setDecimalSeparator (string_: NSString); message 'setDecimalSeparator:';
    function alwaysShowsDecimalSeparator: boolean; message 'alwaysShowsDecimalSeparator';
    procedure setAlwaysShowsDecimalSeparator (b: boolean); message 'setAlwaysShowsDecimalSeparator:';
    function currencyDecimalSeparator: NSString; message 'currencyDecimalSeparator';
    procedure setCurrencyDecimalSeparator (string_: NSString); message 'setCurrencyDecimalSeparator:';
    function usesGroupingSeparator: boolean; message 'usesGroupingSeparator';
    procedure setUsesGroupingSeparator (b: boolean); message 'setUsesGroupingSeparator:';
    function groupingSeparator: NSString; message 'groupingSeparator';
    procedure setGroupingSeparator (string_: NSString); message 'setGroupingSeparator:';
    function zeroSymbol: NSString; message 'zeroSymbol';
    procedure setZeroSymbol (string_: NSString); message 'setZeroSymbol:';
    function textAttributesForZero: NSDictionary; message 'textAttributesForZero';
    procedure setTextAttributesForZero (newAttributes: NSDictionary); message 'setTextAttributesForZero:';
    function nilSymbol: NSString; message 'nilSymbol';
    procedure setNilSymbol (string_: NSString); message 'setNilSymbol:';
    function textAttributesForNil: NSDictionary; message 'textAttributesForNil';
    procedure setTextAttributesForNil (newAttributes: NSDictionary); message 'setTextAttributesForNil:';
    function notANumberSymbol: NSString; message 'notANumberSymbol';
    procedure setNotANumberSymbol (string_: NSString); message 'setNotANumberSymbol:';
    function textAttributesForNotANumber: NSDictionary; message 'textAttributesForNotANumber';
    procedure setTextAttributesForNotANumber (newAttributes: NSDictionary); message 'setTextAttributesForNotANumber:';
    function positiveInfinitySymbol: NSString; message 'positiveInfinitySymbol';
    procedure setPositiveInfinitySymbol (string_: NSString); message 'setPositiveInfinitySymbol:';
    function textAttributesForPositiveInfinity: NSDictionary; message 'textAttributesForPositiveInfinity';
    procedure setTextAttributesForPositiveInfinity (newAttributes: NSDictionary); message 'setTextAttributesForPositiveInfinity:';
    function negativeInfinitySymbol: NSString; message 'negativeInfinitySymbol';
    procedure setNegativeInfinitySymbol (string_: NSString); message 'setNegativeInfinitySymbol:';
    function textAttributesForNegativeInfinity: NSDictionary; message 'textAttributesForNegativeInfinity';
    procedure setTextAttributesForNegativeInfinity (newAttributes: NSDictionary); message 'setTextAttributesForNegativeInfinity:';
    function positivePrefix: NSString; message 'positivePrefix';
    procedure setPositivePrefix (string_: NSString); message 'setPositivePrefix:';
    function positiveSuffix: NSString; message 'positiveSuffix';
    procedure setPositiveSuffix (string_: NSString); message 'setPositiveSuffix:';
    function negativePrefix: NSString; message 'negativePrefix';
    procedure setNegativePrefix (string_: NSString); message 'setNegativePrefix:';
    function negativeSuffix: NSString; message 'negativeSuffix';
    procedure setNegativeSuffix (string_: NSString); message 'setNegativeSuffix:';
    function currencyCode: NSString; message 'currencyCode';
    procedure setCurrencyCode (string_: NSString); message 'setCurrencyCode:';
    function currencySymbol: NSString; message 'currencySymbol';
    procedure setCurrencySymbol (string_: NSString); message 'setCurrencySymbol:';
    function internationalCurrencySymbol: NSString; message 'internationalCurrencySymbol';
    procedure setInternationalCurrencySymbol (string_: NSString); message 'setInternationalCurrencySymbol:';
    function percentSymbol: NSString; message 'percentSymbol';
    procedure setPercentSymbol (string_: NSString); message 'setPercentSymbol:';
    function perMillSymbol: NSString; message 'perMillSymbol';
    procedure setPerMillSymbol (string_: NSString); message 'setPerMillSymbol:';
    function minusSign: NSString; message 'minusSign';
    procedure setMinusSign (string_: NSString); message 'setMinusSign:';
    function plusSign: NSString; message 'plusSign';
    procedure setPlusSign (string_: NSString); message 'setPlusSign:';
    function exponentSymbol: NSString; message 'exponentSymbol';
    procedure setExponentSymbol (string_: NSString); message 'setExponentSymbol:';
    function groupingSize: NSUInteger; message 'groupingSize';
    procedure setGroupingSize (number: NSUInteger); message 'setGroupingSize:';
    function secondaryGroupingSize: NSUInteger; message 'secondaryGroupingSize';
    procedure setSecondaryGroupingSize (number: NSUInteger); message 'setSecondaryGroupingSize:';
    function multiplier: NSNumber; message 'multiplier';
    procedure setMultiplier (number: NSNumber); message 'setMultiplier:';
    function formatWidth: NSUInteger; message 'formatWidth';
    procedure setFormatWidth (number: NSUInteger); message 'setFormatWidth:';
    function paddingCharacter: NSString; message 'paddingCharacter';
    procedure setPaddingCharacter (string_: NSString); message 'setPaddingCharacter:';
    function paddingPosition: NSNumberFormatterPadPosition; message 'paddingPosition';
    procedure setPaddingPosition (position: NSNumberFormatterPadPosition); message 'setPaddingPosition:';
    function roundingMode: NSNumberFormatterRoundingMode; message 'roundingMode';
    procedure setRoundingMode (mode: NSNumberFormatterRoundingMode); message 'setRoundingMode:';
    function roundingIncrement: NSNumber; message 'roundingIncrement';
    procedure setRoundingIncrement (number: NSNumber); message 'setRoundingIncrement:';
    function minimumIntegerDigits: NSUInteger; message 'minimumIntegerDigits';
    procedure setMinimumIntegerDigits (number: NSUInteger); message 'setMinimumIntegerDigits:';
    function maximumIntegerDigits: NSUInteger; message 'maximumIntegerDigits';
    procedure setMaximumIntegerDigits (number: NSUInteger); message 'setMaximumIntegerDigits:';
    function minimumFractionDigits: NSUInteger; message 'minimumFractionDigits';
    procedure setMinimumFractionDigits (number: NSUInteger); message 'setMinimumFractionDigits:';
    function maximumFractionDigits: NSUInteger; message 'maximumFractionDigits';
    procedure setMaximumFractionDigits (number: NSUInteger); message 'setMaximumFractionDigits:';
    function minimum: NSNumber; message 'minimum';
    procedure setMinimum (number: NSNumber); message 'setMinimum:';
    function maximum: NSNumber; message 'maximum';
    procedure setMaximum (number: NSNumber); message 'setMaximum:';
    function currencyGroupingSeparator: NSString; message 'currencyGroupingSeparator'; { available in 10_5, 2_0 }
    procedure setCurrencyGroupingSeparator (string_: NSString); message 'setCurrencyGroupingSeparator:'; { available in 10_5, 2_0 }
    function isLenient: boolean; message 'isLenient'; { available in 10_5, 2_0 }
    procedure setLenient (b: boolean); message 'setLenient:'; { available in 10_5, 2_0 }
    function usesSignificantDigits: boolean; message 'usesSignificantDigits'; { available in 10_5, 2_0 }
    procedure setUsesSignificantDigits (b: boolean); message 'setUsesSignificantDigits:'; { available in 10_5, 2_0 }
    function minimumSignificantDigits: NSUInteger; message 'minimumSignificantDigits'; { available in 10_5, 2_0 }
    procedure setMinimumSignificantDigits (number: NSUInteger); message 'setMinimumSignificantDigits:'; { available in 10_5, 2_0 }
    function maximumSignificantDigits: NSUInteger; message 'maximumSignificantDigits'; { available in 10_5, 2_0 }
    procedure setMaximumSignificantDigits (number: NSUInteger); message 'setMaximumSignificantDigits:'; { available in 10_5, 2_0 }
    function isPartialStringValidationEnabled: boolean; message 'isPartialStringValidationEnabled'; { available in 10_5, 2_0 }
    procedure setPartialStringValidationEnabled (b: boolean); message 'setPartialStringValidationEnabled:'; { available in 10_5, 2_0 }
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) and not (defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSNumberFormatterCompatibility = objccategory external (NSNumberFormatter)
    function hasThousandSeparators: boolean; message 'hasThousandSeparators';
    procedure setHasThousandSeparators (flag: boolean); message 'setHasThousandSeparators:';
    function thousandSeparator: NSString; message 'thousandSeparator';
    procedure setThousandSeparator (newSeparator: NSString); message 'setThousandSeparator:';
    function localizesFormat: boolean; message 'localizesFormat';
    procedure setLocalizesFormat (flag: boolean); message 'setLocalizesFormat:';
    function format: NSString; message 'format';
    procedure setFormat (string_: NSString); message 'setFormat:';
    function attributedStringForZero: NSAttributedString; message 'attributedStringForZero';
    procedure setAttributedStringForZero (newAttributedString: NSAttributedString); message 'setAttributedStringForZero:';
    function attributedStringForNil: NSAttributedString; message 'attributedStringForNil';
    procedure setAttributedStringForNil (newAttributedString: NSAttributedString); message 'setAttributedStringForNil:';
    function attributedStringForNotANumber: NSAttributedString; message 'attributedStringForNotANumber';
    procedure setAttributedStringForNotANumber (newAttributedString: NSAttributedString); message 'setAttributedStringForNotANumber:';
    function roundingBehavior: NSDecimalNumberHandler; message 'roundingBehavior';
    procedure setRoundingBehavior (newRoundingBehavior: NSDecimalNumberHandler); message 'setRoundingBehavior:';
  end;
{$endif}

{$endif}
