{ Parsed from Foundation.framework (MacOSX10.8) NSOperation.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{ Types from NSOperation }
{$ifdef TYPES}

type
  NSOperationQueuePriority = NSInteger;
type
  NSOperationQueuePriorityPtr = ^NSOperationQueuePriority;

const
  NSOperationQueuePriorityVeryLow = -8;
  NSOperationQueuePriorityLow = -4;
  NSOperationQueuePriorityNormal = 0;
  NSOperationQueuePriorityHigh = 4;
  NSOperationQueuePriorityVeryHigh = 8;

{$endif}


{ Types from NSBlockOperation }
{$ifdef TYPES}

{$endif}


{ Types from NSOperationQueue }
{$ifdef TYPES}


const
  NSOperationQueueDefaultMaxConcurrentOperationCount = -1;
{$endif}


{$ifdef TYPES}
type
  NSOperationPtr = ^NSOperation;
  NSBlockOperationPtr = ^NSBlockOperation;
  NSInvocationOperationPtr = ^NSInvocationOperation;
  NSOperationQueuePtr = ^NSOperationQueue;
{$endif}

{$ifdef CLASSES}

type
  NSOperation = objcclass external (NSObject)
  private
    _private: id;
    _private1: cint32;
    {$if defined(__LP64__)}
    _private1b: cint32;
    {$endif}
  public
    function init: id; message 'init';
    procedure start; message 'start';
    procedure main; message 'main';
    function isCancelled: boolean; message 'isCancelled';
    procedure cancel; message 'cancel';
    function isExecuting: boolean; message 'isExecuting';
    function isFinished: boolean; message 'isFinished';
    function isConcurrent: boolean; message 'isConcurrent';
    function isReady: boolean; message 'isReady';
    procedure addDependency (op: NSOperation); message 'addDependency:';
    procedure removeDependency (op: NSOperation); message 'removeDependency:';
    function dependencies: NSArray; message 'dependencies';
    function queuePriority: NSOperationQueuePriority; message 'queuePriority';
    procedure setQueuePriority (p: NSOperationQueuePriority); message 'setQueuePriority:';
    {$if defined(NS_BLOCKS_AVAILABLE)}
    function (void))completionBlock: void (^; message '(void))completionBlock'; { available in 10_6, 4_0 }
    procedure setCompletionBlock (block: OpaqueCBlock); message 'setCompletionBlock:'; { available in 10_6, 4_0 }
    {$endif}
    procedure waitUntilFinished; message 'waitUntilFinished'; { available in 10_6, 4_0 }
    function threadPriority: double; message 'threadPriority'; { available in 10_6, 4_0 }
    procedure setThreadPriority (p: double); message 'setThreadPriority:'; { available in 10_6, 4_0 }
  end;

type
  NSBlockOperation = objcclass external (NSOperation)
  private
    _private2: id;
    _reserved2: pointer;
  public
    {$if defined(NS_BLOCKS_AVAILABLE)}
    class function blockOperationWithBlock (block: OpaqueCBlock): id; message 'blockOperationWithBlock:';
    procedure addExecutionBlock (block: OpaqueCBlock); message 'addExecutionBlock:';
    function executionBlocks: NSArray; message 'executionBlocks';
    {$endif}
  end;

type
  NSInvocationOperation = objcclass external (NSOperation)
  private
    _inv: id;
    _exception: id;
    _reserved2: pointer;
  public
    function initWithTarget_selector_object (target: id; sel_: SEL; arg: id): id; message 'initWithTarget:selector:object:';
    function initWithInvocation (inv: NSInvocation): id; message 'initWithInvocation:';
    function invocation: NSInvocation; message 'invocation';
    function result_: id; message 'result';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSInvocationOperationVoidResultException: NSString { available in 10_5, 2_0 }; cvar; external;
  NSInvocationOperationCancelledException: NSString { available in 10_5, 2_0 }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSOperationQueue = objcclass external (NSObject)
  private
    _private: id;
    _reserved: pointer;
  public
    procedure addOperation (op: NSOperation); message 'addOperation:';
    procedure addOperations_waitUntilFinished (ops: NSArray; wait: boolean); message 'addOperations:waitUntilFinished:'; { available in 10_6, 4_0 }
    {$if defined(NS_BLOCKS_AVAILABLE)}
    procedure addOperationWithBlock (block: OpaqueCBlock); message 'addOperationWithBlock:'; { available in 10_6, 4_0 }
    {$endif}
    function operations: NSArray; message 'operations';
    function operationCount: NSUInteger; message 'operationCount'; { available in 10_6, 4_0 }
    function maxConcurrentOperationCount: NSInteger; message 'maxConcurrentOperationCount';
    procedure setMaxConcurrentOperationCount (cnt: NSInteger); message 'setMaxConcurrentOperationCount:';
    procedure setSuspended (b: boolean); message 'setSuspended:';
    function isSuspended: boolean; message 'isSuspended';
    procedure setName (n: NSString); message 'setName:'; { available in 10_6, 4_0 }
    function name: NSString; message 'name'; { available in 10_6, 4_0 }
    procedure cancelAllOperations; message 'cancelAllOperations';
    procedure waitUntilAllOperationsAreFinished; message 'waitUntilAllOperationsAreFinished';
    class function currentQueue: id; message 'currentQueue'; { available in 10_6, 4_0 }
    class function mainQueue: id; message 'mainQueue'; { available in 10_6, 4_0 }
  end;
{$endif}

