{ Parsed from Foundation.framework (MacOSX10.8) NSScriptObjectSpecifiers.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{$ifdef TYPES}
type
  NSScriptObjectSpecifierPtr = ^NSScriptObjectSpecifier;
  NSIndexSpecifierPtr = ^NSIndexSpecifier;
  NSMiddleSpecifierPtr = ^NSMiddleSpecifier;
  NSNameSpecifierPtr = ^NSNameSpecifier;
  NSPositionalSpecifierPtr = ^NSPositionalSpecifier;
  NSPropertySpecifierPtr = ^NSPropertySpecifier;
  NSRandomSpecifierPtr = ^NSRandomSpecifier;
  NSRangeSpecifierPtr = ^NSRangeSpecifier;
  NSRelativeSpecifierPtr = ^NSRelativeSpecifier;
  NSUniqueIDSpecifierPtr = ^NSUniqueIDSpecifier;
  NSWhoseSpecifierPtr = ^NSWhoseSpecifier;
{$endif}

{$ifdef TYPES}
const
  NSNoSpecifierError = 0;
  NSNoTopLevelContainersSpecifierError = 1;
  NSContainerSpecifierError = 2;
  NSUnknownKeySpecifierError = 3;
  NSInvalidIndexSpecifierError = 4;
  NSInternalSpecifierError = 5;
  NSOperationNotSupportedForKeySpecifierError = 6;

type
  NSInsertionPosition = NSUInteger;
  NSInsertionPositionPtr = ^NSInsertionPosition;

const
  NSPositionAfter = 0;
  NSPositionBefore = 1;
  NSPositionBeginning = 2;
  NSPositionEnd = 3;
  NSPositionReplace = 4;

type
  NSRelativePosition = NSUInteger;
  NSRelativePositionPtr = ^NSRelativePosition;

const
  NSRelativeAfter = 0;
  NSRelativeBefore = 1;

type
  NSWhoseSubelementIdentifier = NSUInteger;
  NSWhoseSubelementIdentifierPtr = ^NSWhoseSubelementIdentifier;

const
  NSIndexSubelement = 0;
  NSEverySubelement = 1;
  NSMiddleSubelement = 2;
  NSRandomSubelement = 3;
  NSNoSubelement = 4;
{$endif}

{$ifdef CLASSES}

type
  NSScriptObjectSpecifier = objcclass external (NSObject, NSCodingProtocol)
  private
    _container: NSScriptObjectSpecifier;
    _child: NSScriptObjectSpecifier;
    _key: NSString;
    _containerClassDescription: NSScriptClassDescription;
    _containerIsObjectBeingTested: boolean;
    _containerIsRangeContainerObject: boolean;
    _padding:array[0..1] of char;
    _descriptor: NSAppleEventDescriptor;
    _error: NSInteger;
  public
    class function objectSpecifierWithDescriptor (descriptor: NSAppleEventDescriptor): NSScriptObjectSpecifier; message 'objectSpecifierWithDescriptor:'; { available in 10_5, NA }
    function initWithContainerSpecifier_key (container: NSScriptObjectSpecifier; property_: NSString): id; message 'initWithContainerSpecifier:key:';
    function initWithContainerClassDescription_containerSpecifier_key (classDesc: NSScriptClassDescription; container: NSScriptObjectSpecifier; property_: NSString): id; message 'initWithContainerClassDescription:containerSpecifier:key:';
    function childSpecifier: NSScriptObjectSpecifier; message 'childSpecifier';
    procedure setChildSpecifier (child: NSScriptObjectSpecifier); message 'setChildSpecifier:';
    function containerSpecifier: NSScriptObjectSpecifier; message 'containerSpecifier';
    procedure setContainerSpecifier (subRef: NSScriptObjectSpecifier); message 'setContainerSpecifier:';
    function containerIsObjectBeingTested: boolean; message 'containerIsObjectBeingTested';
    procedure setContainerIsObjectBeingTested (flag: boolean); message 'setContainerIsObjectBeingTested:';
    function containerIsRangeContainerObject: boolean; message 'containerIsRangeContainerObject';
    procedure setContainerIsRangeContainerObject (flag: boolean); message 'setContainerIsRangeContainerObject:';
    function key: NSString; message 'key';
    procedure setKey (key_: NSString); message 'setKey:';
    function containerClassDescription: NSScriptClassDescription; message 'containerClassDescription';
    procedure setContainerClassDescription (classDesc: NSScriptClassDescription); message 'setContainerClassDescription:';
    function keyClassDescription: NSScriptClassDescription; message 'keyClassDescription';
    function indicesOfObjectsByEvaluatingWithContainer_count (container: id; count: NSIntegerPtr): NSIntegerPtr; message 'indicesOfObjectsByEvaluatingWithContainer:count:';
    function objectsByEvaluatingWithContainers (containers: id): id; message 'objectsByEvaluatingWithContainers:';
    function objectsByEvaluatingSpecifier: id; message 'objectsByEvaluatingSpecifier';
    function evaluationErrorNumber: NSInteger; message 'evaluationErrorNumber';
    procedure setEvaluationErrorNumber (error: NSInteger); message 'setEvaluationErrorNumber:';
    function evaluationErrorSpecifier: NSScriptObjectSpecifier; message 'evaluationErrorSpecifier';
    function descriptor: NSAppleEventDescriptor; message 'descriptor'; { available in 10_5, NA }

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  NSScriptObjectSpecifiers = objccategory external (NSObject)
    function objectSpecifier: NSScriptObjectSpecifier; message 'objectSpecifier';
    function indicesOfObjectsByEvaluatingObjectSpecifier (specifier: NSScriptObjectSpecifier): NSArray; message 'indicesOfObjectsByEvaluatingObjectSpecifier:';
  end;


type
  NSIndexSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
    _index: NSInteger;
  public
    function initWithContainerClassDescription_containerSpecifier_key_index (classDesc: NSScriptClassDescription; container: NSScriptObjectSpecifier; property_: NSString; index: NSInteger): id; message 'initWithContainerClassDescription:containerSpecifier:key:index:';
    function index: NSInteger; message 'index';
    procedure setIndex (index_: NSInteger); message 'setIndex:';
  end;

type
  NSMiddleSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
  end;

type
  NSNameSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
    _name: NSString;
  public
    function initWithContainerClassDescription_containerSpecifier_key_name (classDesc: NSScriptClassDescription; container: NSScriptObjectSpecifier; property_: NSString; name: NSString): id; message 'initWithContainerClassDescription:containerSpecifier:key:name:';
    function name: NSString; message 'name';
    procedure setName (name_: NSString); message 'setName:';
  end;

type
  NSPositionalSpecifier = objcclass external (NSObject)
  private
    _specifier: NSScriptObjectSpecifier;
    _unadjustedPosition: NSInsertionPosition;
    _insertionClassDescription: NSScriptClassDescription;
    _moreVars: id;
    _reserved0: pointer;
  public
    function initWithPosition_objectSpecifier (position: NSInsertionPosition; specifier: NSScriptObjectSpecifier): id; message 'initWithPosition:objectSpecifier:';
    function position: NSInsertionPosition; message 'position'; { available in 10_5, NA }
    function objectSpecifier: NSScriptObjectSpecifier; message 'objectSpecifier'; { available in 10_5, NA }
    procedure setInsertionClassDescription (classDescription_: NSScriptClassDescription); message 'setInsertionClassDescription:';
    procedure evaluate; message 'evaluate';
    function insertionContainer: id; message 'insertionContainer';
    function insertionKey: NSString; message 'insertionKey';
    function insertionIndex: NSInteger; message 'insertionIndex';
    function insertionReplaces: boolean; message 'insertionReplaces';
  end;

type
  NSPropertySpecifier = objcclass external (NSScriptObjectSpecifier)
  private
  end;

type
  NSRandomSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
  end;

type
  NSRangeSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
    _startSpec: NSScriptObjectSpecifier;
    _endSpec: NSScriptObjectSpecifier;
  public
    function initWithContainerClassDescription_containerSpecifier_key_startSpecifier_endSpecifier (classDesc: NSScriptClassDescription; container: NSScriptObjectSpecifier; property_: NSString; startSpec: NSScriptObjectSpecifier; endSpec: NSScriptObjectSpecifier): id; message 'initWithContainerClassDescription:containerSpecifier:key:startSpecifier:endSpecifier:';
    function startSpecifier: NSScriptObjectSpecifier; message 'startSpecifier';
    procedure setStartSpecifier (startSpec: NSScriptObjectSpecifier); message 'setStartSpecifier:';
    function endSpecifier: NSScriptObjectSpecifier; message 'endSpecifier';
    procedure setEndSpecifier (endSpec: NSScriptObjectSpecifier); message 'setEndSpecifier:';
  end;

type
  NSRelativeSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
    _relativePosition: NSRelativePosition;
    _baseSpecifier: NSScriptObjectSpecifier;
  public
    function initWithContainerClassDescription_containerSpecifier_key_relativePosition_baseSpecifier (classDesc: NSScriptClassDescription; container: NSScriptObjectSpecifier; property_: NSString; relPos: NSRelativePosition; baseSpecifier: NSScriptObjectSpecifier): id; message 'initWithContainerClassDescription:containerSpecifier:key:relativePosition:baseSpecifier:';
    function relativePosition: NSRelativePosition; message 'relativePosition';
    procedure setRelativePosition (relPos: NSRelativePosition); message 'setRelativePosition:';
    function baseSpecifier: NSScriptObjectSpecifier; message 'baseSpecifier';
    procedure setBaseSpecifier (baseSpecifier_: NSScriptObjectSpecifier); message 'setBaseSpecifier:';
  end;

type
  NSUniqueIDSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
    _uniqueID: id;
  public
    function initWithContainerClassDescription_containerSpecifier_key_uniqueID (classDesc: NSScriptClassDescription; container: NSScriptObjectSpecifier; property_: NSString; uniqueID: id): id; message 'initWithContainerClassDescription:containerSpecifier:key:uniqueID:';
    function uniqueID: id; message 'uniqueID';
    procedure setUniqueID (uniqueID_: id); message 'setUniqueID:';
  end;

type
  NSWhoseSpecifier = objcclass external (NSScriptObjectSpecifier)
  private
    _test: NSScriptWhoseTest;
    _startSubelementIdentifier: NSWhoseSubelementIdentifier;
    _startSubelementIndex: NSInteger;
    _endSubelementIdentifier: NSWhoseSubelementIdentifier;
    _endSubelementIndex: NSInteger;
  public
    function initWithContainerClassDescription_containerSpecifier_key_test (classDesc: NSScriptClassDescription; container: NSScriptObjectSpecifier; property_: NSString; test: NSScriptWhoseTest): id; message 'initWithContainerClassDescription:containerSpecifier:key:test:';
    function test: NSScriptWhoseTest; message 'test';
    procedure setTest (test_: NSScriptWhoseTest); message 'setTest:';
    function startSubelementIdentifier: NSWhoseSubelementIdentifier; message 'startSubelementIdentifier';
    procedure setStartSubelementIdentifier (subelement: NSWhoseSubelementIdentifier); message 'setStartSubelementIdentifier:';
    function startSubelementIndex: NSInteger; message 'startSubelementIndex';
    procedure setStartSubelementIndex (index: NSInteger); message 'setStartSubelementIndex:';
    function endSubelementIdentifier: NSWhoseSubelementIdentifier; message 'endSubelementIdentifier';
    procedure setEndSubelementIdentifier (subelement: NSWhoseSubelementIdentifier); message 'setEndSubelementIdentifier:';
    function endSubelementIndex: NSInteger; message 'endSubelementIndex';
    procedure setEndSubelementIndex (index: NSInteger); message 'setEndSubelementIndex:';
  end;
{$endif}

