{ Parsed from Foundation.framework (MacOSX10.8) NSTask.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{$ifdef TYPES}
type
  NSTaskPtr = ^NSTask;
{$endif}

{$ifdef TYPES}
type
  NSTaskTerminationReason = NSInteger;
  NSTaskTerminationReasonPtr = ^NSTaskTerminationReason;

const
  NSTaskTerminationReasonExit = 1;
  NSTaskTerminationReasonUncaughtSignal = 2;
{$endif}

{$ifdef CLASSES}

type
  NSTask = objcclass external (NSObject)
  public
    function init: id; message 'init';
    procedure setLaunchPath (path: NSString); message 'setLaunchPath:';
    procedure setArguments (arguments: NSArray); message 'setArguments:';
    procedure setEnvironment (dict: NSDictionary); message 'setEnvironment:';
    procedure setCurrentDirectoryPath (path: NSString); message 'setCurrentDirectoryPath:';
    procedure setStandardInput (input: id); message 'setStandardInput:';
    procedure setStandardOutput (output: id); message 'setStandardOutput:';
    procedure setStandardError (error: id); message 'setStandardError:';
    function launchPath: NSString; message 'launchPath';
    function arguments: NSArray; message 'arguments';
    function environment: NSDictionary; message 'environment';
    function currentDirectoryPath: NSString; message 'currentDirectoryPath';
    function standardInput: id; message 'standardInput';
    function standardOutput: id; message 'standardOutput';
    function standardError: id; message 'standardError';
    procedure launch; message 'launch';
    procedure interrupt; message 'interrupt';
    procedure terminate; message 'terminate';
    function suspend: boolean; message 'suspend';
    function resume: boolean; message 'resume';
    function processIdentifier: cint; message 'processIdentifier';
    function isRunning: boolean; message 'isRunning';
    function terminationStatus: cint; message 'terminationStatus';
    function terminationReason: NSTaskTerminationReason; message 'terminationReason'; { available in 10_6, NA }
    procedure setTerminationHandler(newValue: OpaqueCBlock); message 'setTerminationHandler:';
    function terminationHandler: OpaqueCBlock; message 'terminationHandler';
  end;


type
  NSTaskConveniences = objccategory external (NSTask)
    class function launchedTaskWithLaunchPath_arguments (path: NSString; arguments_: NSArray): NSTask; message 'launchedTaskWithLaunchPath:arguments:';
    procedure waitUntilExit; message 'waitUntilExit';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSTaskDidTerminateNotification: NSString; cvar; external;
{$endif}

