{ Parsed from InstantMessage.framework (MacOSX10.8) IMAVControl.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{$ifdef TYPES}
type
  IMAVControlPtr = ^IMAVControl;
  IMAVButtonPtr = ^IMAVButton;
  IMAVSliderPtr = ^IMAVSlider;
  IMAVControlBarPtr = ^IMAVControlBar;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
{$ifdef CLASSES}

type
  IMAVControl = objcclass external (NSObject)
  private
    _contents: id;
  public
    function target: id; message 'target';
    procedure setTarget (anObject: id); message 'setTarget:';
    function action: SEL; message 'action';
    procedure setAction (aSelector: SEL); message 'setAction:';
    function tag: NSInteger; message 'tag';
    procedure setTag (anInt: NSInteger); message 'setTag:';
    function isEnabled: boolean; message 'isEnabled';
    procedure setEnabled (flag: boolean); message 'setEnabled:';
    function integerValue: NSInteger; message 'integerValue';
    procedure setIntegerValue (anInteger: NSInteger); message 'setIntegerValue:';
    function intValue: cint; message 'intValue';
    procedure setIntValue (anInt: cint); message 'setIntValue:';
    function floatValue: single; message 'floatValue';
    procedure setFloatValue (aFloat: single); message 'setFloatValue:';
    function doubleValue: double; message 'doubleValue';
    procedure setDoubleValue (aDouble: double); message 'setDoubleValue:';
  end;

type
  IMAVButton = objcclass external (IMAVControl)
  private
  public
    function state: NSInteger; message 'state';
    procedure setState (value: NSInteger); message 'setState:';
  end;


type
  IMAVButton_StandardControls = objccategory external name 'StandardControls' (IMAVButton)
    class function playPauseButton: IMAVButton; message 'playPauseButton';
    class function forwardButton: IMAVButton; message 'forwardButton';
    class function backwardButton: IMAVButton; message 'backwardButton';
    class function muteButton: IMAVButton; message 'muteButton';
  end;


type
  IMAVSlider = objcclass external (IMAVControl)
  private
  public
    function minValue: double; message 'minValue';
    procedure setMinValue (aDouble: double); message 'setMinValue:';
    function maxValue: double; message 'maxValue';
    procedure setMaxValue (aDouble: double); message 'setMaxValue:';
  end;


type
  StandardControls = objccategory external (IMAVSlider)
    class function timeSlider: IMAVSlider; message 'timeSlider';
  end;


type
  IMAVControlBar = objcclass external (NSObject)
  private
  public
    function controls: NSArray; message 'controls';
    procedure addControl (control: IMAVControl); message 'addControl:';
    procedure removeControl (control: IMAVControl); message 'removeControl:';
    procedure removeAllControls; message 'removeAllControls';
  end;
{$endif}

{$endif}
