{ Parsed from InstantMessage.framework (MacOSX10.8) IMAVManager.h }
{ Created on Mon Sep 10 11:48:04 2012 }


{ Types from IMAVManager }
{$ifdef TYPES}

{$endif}


{$ifdef TYPES}
type
  IMAVManagerPtr = ^IMAVManager;
{$endif}

{$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5)}
{$ifdef EXTERNAL_SYMBOLS}
var
  IMAVManagerStateChangedNotification: NSString; cvar; external;
  IMAVManagerURLToShareChangedNotification: NSString; cvar; external;
{$endif}

{$ifdef TYPES}
const
  IMAVInactive = 0;
  IMAVRequested = 1;
  IMAVShuttingDown = 2;
  IMAVStartingUp = 3;
  IMAVPending = 4;
  IMAVRunning = 5;

type
  IMAVManagerState = NSUInteger;
  IMAVManagerStatePtr = ^IMAVManagerState;

const
  IMVideoOptimizationDefault = 0;
  IMVideoOptimizationStills = 1 shl 0;
  IMVideoOptimizationReplacement = 1 shl 1;

type
  IMVideoOptimizationOptions = NSUInteger;
  IMVideoOptimizationOptionsPtr = ^IMVideoOptimizationOptions;
{$endif}

{$ifdef CLASSES}

type
  IMAVManager = objcclass external (NSObject)
  private
  public
    class function sharedAVManager: IMAVManager; message 'sharedAVManager';
    function state: IMAVManagerState; message 'state';
    function URLToShare: NSURL; message 'URLToShare';
    procedure setVideoDataSource (dataSource: id); message 'setVideoDataSource:';
    function videoDataSource: id; message 'videoDataSource';
    procedure setVideoOptimizationOptions (options: IMVideoOptimizationOptions); message 'setVideoOptimizationOptions:';
    function videoOptimizationOptions: IMVideoOptimizationOptions; message 'videoOptimizationOptions';
    procedure setNumberOfAudioChannels (count: NSInteger); message 'setNumberOfAudioChannels:';
    function numberOfAudioChannels: NSInteger; message 'numberOfAudioChannels';
    function audioDeviceUID: NSString; message 'audioDeviceUID';
    function audioDeviceChannels: NSArray; message 'audioDeviceChannels';
    {$if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)}
    function controlBar: IMAVControlBar; message 'controlBar';
    {$endif}
    procedure start; message 'start';
    procedure stop; message 'stop';
  end;


type
  IMVideoDataSource = objccategory external (NSObject)
    procedure getPixelBufferPixelFormat (pixelFormatOut: OSTypePtr); message 'getPixelBufferPixelFormat:';
    function renderIntoPixelBuffer_forTime (buffer: CVPixelBufferRef; timeStamp: CVTimeStampPtr): boolean; message 'renderIntoPixelBuffer:forTime:';
    procedure getOpenGLBufferContext_pixelFormat (contextOut: CGLContextObjPtr; pixelFormatOut: CGLPixelFormatObjPtr); message 'getOpenGLBufferContext:pixelFormat:';
    function renderIntoOpenGLBuffer_onScreen_forTime (buffer: CVOpenGLBufferRef; screenInOut: pcint; timeStamp: CVTimeStampPtr): boolean; message 'renderIntoOpenGLBuffer:onScreen:forTime:';
  end;
{$endif}

{$endif}
