{ Parsed from PreferencePanes.framework (MacOSX10.8) NSPreferencePane.h }
{ Created on Mon Sep 10 11:47:11 2012 }


{$ifdef TYPES}
type
  NSPreferencePanePtr = ^NSPreferencePane;
{$endif}

{$ifdef TYPES}
const
  NSUnselectCancel = 0;
  NSUnselectNow = 1;
  NSUnselectLater = 2;
type
  NSPreferencePaneUnselectReply = clong;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSPreferencePaneDoUnselectNotification: NSString; cvar; external;
  NSPreferencePaneCancelUnselectNotification: NSString; cvar; external;
  NSPrefPaneHelpMenuInfoPListKey: NSString; cvar; external;
  NSPrefPaneHelpMenuTitleKey: NSString; cvar; external;
  NSPrefPaneHelpMenuAnchorKey: NSString; cvar; external;
{$endif}

{$if (MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_7)}

{$else}
{$ifdef TYPES}
const
  kNSPrefPaneHelpMenuInfoPListKey = 'NSPrefPaneHelpAnchors';
  kNSPrefPaneHelpMenuTitleKey = 'title';
  kNSPrefPaneHelpMenuAnchorKey = 'anchor';
{$endif}

{$endif}
{$ifdef CLASSES}

type
  NSPreferencePane = objcclass external (NSObject)
  private
    _window: NSWindow;
    _initialKeyView: NSView;
    _firstKeyView: NSView;
    _lastKeyView: NSView;
    _mainView: NSView;
    _bundle: NSBundle;
    _reserved1: id;
    _reserved2: id;
    _reserved3: id;
  public
    function initWithBundle (bundle: NSBundle): id; message 'initWithBundle:';
    function bundle: NSBundle; message 'bundle';
    function loadMainView: NSView; message 'loadMainView';
    procedure mainViewDidLoad; message 'mainViewDidLoad';
    function mainNibName: NSString; message 'mainNibName';
    procedure assignMainView; message 'assignMainView';
    procedure willSelect; message 'willSelect';
    procedure didSelect; message 'didSelect';
    function shouldUnselect: NSPreferencePaneUnselectReply; message 'shouldUnselect';
    procedure replyToShouldUnselect (shouldUnselect_: boolean); message 'replyToShouldUnselect:';
    procedure willUnselect; message 'willUnselect';
    procedure didUnselect; message 'didUnselect';
    procedure setMainView (view: NSView); message 'setMainView:';
    function mainView: NSView; message 'mainView';
    function initialKeyView: NSView; message 'initialKeyView';
    procedure setInitialKeyView (view: NSView); message 'setInitialKeyView:';
    function firstKeyView: NSView; message 'firstKeyView';
    procedure setFirstKeyView (view: NSView); message 'setFirstKeyView:';
    function lastKeyView: NSView; message 'lastKeyView';
    procedure setLastKeyView (view: NSView); message 'setLastKeyView:';
    function autoSaveTextFields: boolean; message 'autoSaveTextFields';
    function isSelected: boolean; message 'isSelected';
    procedure updateHelpMenuWithArray (inArrayOfMenuItems: NSArray); message 'updateHelpMenuWithArray:';
  end;
{$endif}

