{ Parsed from QTKit.framework (MacOSX10.8) QTTime.h }
{ Created on Mon Sep 10 11:47:34 2012 }

{$ifdef TYPES}
const
  kQTTimeIsIndefinite = 1 shl 0;

type
  QTTime = record
    timeValue: clonglong;
    timeScale: clong;
    flags: clong;
  end;
type
  QTTimePtr = ^QTTime;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  QTZeroTime: QTTime; cvar; external;
  QTIndefiniteTime: QTTime; cvar; external;
{$endif}

{$ifdef FUNCTIONS}
function QTMakeTimeWithTimeRecord(timeRecord: TimeRecord): QTTime; cdecl; external;
function QTMakeTimeWithTimeInterval(timeInterval: NSTimeInterval): QTTime; cdecl; external;
function QTMakeTime(timeValue: clonglong; timeScale: clong): QTTime; cdecl; external;
function QTMakeTimeScaled(time: QTTime; timeScale: clong): QTTime; cdecl; external;
function QTGetTimeRecord(time: QTTime; timeRecord: TimeRecordPtr): boolean; cdecl; external;
function QTGetTimeInterval(time: QTTime; timeInterval: NSTimeIntervalPtr): boolean; cdecl; external;
function QTTimeCompare(time: QTTime; otherTime: QTTime): NSComparisonResult; cdecl; external;
function QTTimeIncrement(time: QTTime; increment: QTTime): QTTime; cdecl; external;
function QTTimeDecrement(time: QTTime; decrement: QTTime): QTTime; cdecl; external;
function QTStringFromTime(time: QTTime): NSString; cdecl; external;
function QTTimeFromString(string_: NSString): QTTime; cdecl; external;
function QTTimeIsIndefinite(time: QTTime): boolean; cdecl; external;
{$endif}

{$ifdef CLASSES}

type
  NSValueQTTimeExtensions = objccategory external (NSValue)
    class function valueWithQTTime (time: QTTime): NSValue; message 'valueWithQTTime:';
    function QTTimeValue: QTTime; message 'QTTimeValue';
  end;

type
  NSQTTimeCoding = objccategory external (NSCoder)
    procedure encodeQTTime_forKey (time: QTTime; key: NSString); message 'encodeQTTime:forKey:';
    function decodeQTTimeForKey (key: NSString): QTTime; message 'decodeQTTimeForKey:';
  end;
{$endif}

{$ifdef FUNCTIONS}
function QTStringFromSMPTETime(time: SMPTETime): NSString; cdecl; external;
{$endif}

{$if (QTKIT_VERSION_MAX_ALLOWED >= QTKIT_VERSION_7_2)}
{$ifdef CLASSES}

type
  NSValueQTSMPTETimeExtensions = objccategory external (NSValue)
    class function valueWithSMPTETime (time: SMPTETime): NSValue; message 'valueWithSMPTETime:';
    function SMPTETimeValue: SMPTETime; message 'SMPTETimeValue';
  end;

type
  NSCoderQTSMPTETimeCoding = objccategory external (NSCoder)
    procedure encodeSMPTETime_forKey (time: SMPTETime; key: NSString); message 'encodeSMPTETime:forKey:';
    function decodeSMPTETimeForKey (key: NSString): SMPTETime; message 'decodeSMPTETimeForKey:';
  end;
{$endif}

{$endif}
