{ Parsed from SceneKit.framework (MacOSX10.8) SCNGeometry.h }
{ Created on Mon Sep 10 11:46:01 2012 }


{$ifdef TYPES}
type
  SCNGeometryPtr = ^SCNGeometry;
  SCNGeometrySourcePtr = ^SCNGeometrySource;
  SCNGeometryElementPtr = ^SCNGeometryElement;
{$endif}

{$ifdef TYPES}
const
  SCNGeometryPrimitiveTypeTriangles = 0;
  SCNGeometryPrimitiveTypeTriangleStrip = 1;
  SCNGeometryPrimitiveTypeLine = 2;
  SCNGeometryPrimitiveTypePoint = 3;
type
  SCNGeometryPrimitiveType = clong;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  SCNGeometrySourceSemanticVertex: NSString { available in 10_7, NA }; cvar; external;
  SCNGeometrySourceSemanticNormal: NSString { available in 10_7, NA }; cvar; external;
  SCNGeometrySourceSemanticColor: NSString { available in 10_7, NA }; cvar; external;
  SCNGeometrySourceSemanticTexcoord: NSString { available in 10_7, NA }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  SCNGeometry = objcclass external (NSObject, SCNAnimatableProtocol, SCNBoundingVolumeProtocol, NSCopyingProtocol)
  private
    _geometryReserved: id;
  public
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    procedure setMaterials(newValue: NSArray); message 'setMaterials:';
    function materials: NSArray; message 'materials';
    procedure insertMaterial_atIndex (material: SCNMaterial; index: NSUInteger); message 'insertMaterial:atIndex:';
    procedure removeMaterialAtIndex (index: NSUInteger); message 'removeMaterialAtIndex:';
    procedure replaceMaterialAtIndex_withMaterial (index: NSUInteger; material: SCNMaterial); message 'replaceMaterialAtIndex:withMaterial:';
    function materialWithName (name_: NSString): SCNMaterial; message 'materialWithName:';
    class function geometryWithSources_elements (sources: NSArray; elements: NSArray): id; message 'geometryWithSources:elements:';
    function geometrySourcesForSemantic (semantic: NSString): NSArray; message 'geometrySourcesForSemantic:';
    function geometryElementCount: NSInteger; message 'geometryElementCount';
    function geometryElementAtIndex (elementIndex: NSInteger): SCNGeometryElement; message 'geometryElementAtIndex:';
    procedure setFirstMaterial(newValue: SCNMaterial); message 'setFirstMaterial:';
    function firstMaterial: SCNMaterial; message 'firstMaterial';

    { Adopted protocols }
    procedure addAnimation_forKey (animation: CAAnimation; key: NSString); message 'addAnimation:forKey:';
    function animationForKey (key: NSString): CAAnimation; message 'animationForKey:';
    function animationKeys: NSArray; message 'animationKeys';
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    function getBoundingBoxMin_max (min: SCNVector3Ptr; max: SCNVector3Ptr): boolean; message 'getBoundingBoxMin:max:';
    function getBoundingSphereCenter_radius (center: SCNVector3Ptr; radius: CGFloatPtr): boolean; message 'getBoundingSphereCenter:radius:';
    procedure removeAllAnimations; message 'removeAllAnimations';
    procedure removeAnimationForKey (key: NSString); message 'removeAnimationForKey:';
  end;

type
  SCNGeometrySource = objcclass external (NSObject)
  private
    _reserved: id;
  public
    class function geometrySourceWithData_semantic_vectorCount_floatComponents_componentsPerVector_bytesPerComponent_dataOffset_dataStride (data: NSData; semantic: NSString; vectorCount: NSInteger; floatComponents: boolean; componentsPerVector: NSInteger; bytesPerComponent: NSInteger; offset: NSInteger; stride: NSInteger): id; message 'geometrySourceWithData:semantic:vectorCount:floatComponents:componentsPerVector:bytesPerComponent:dataOffset:dataStride:';
    class function geometrySourceWithVertices_count (vertices: SCNVector3Ptr; count: NSInteger): id; message 'geometrySourceWithVertices:count:';
    class function geometrySourceWithNormals_count (normals: SCNVector3Ptr; count: NSInteger): id; message 'geometrySourceWithNormals:count:';
    class function geometrySourceWithTextureCoordinates_count (texcoord: CGPointPtr; count: NSInteger): id; message 'geometrySourceWithTextureCoordinates:count:';
    function data: NSData; message 'data';
    function semantic: NSString; message 'semantic';
    function vectorCount: NSInteger; message 'vectorCount';
    function floatComponents: boolean; message 'floatComponents';
    function componentsPerVector: NSInteger; message 'componentsPerVector';
    function bytesPerComponent: NSInteger; message 'bytesPerComponent';
    function dataOffset: NSInteger; message 'dataOffset';
    function dataStride: NSInteger; message 'dataStride';
  end;

type
  SCNGeometryElement = objcclass external (NSObject)
  private
    _reserved: id;
  public
    class function geometryElementWithData_primitiveType_primitiveCount_bytesPerIndex (data: NSData; primitiveType: SCNGeometryPrimitiveType; primitiveCount: NSInteger; bytesPerIndex: NSInteger): id; message 'geometryElementWithData:primitiveType:primitiveCount:bytesPerIndex:';
    function data: NSData; message 'data';
    function primitiveType: SCNGeometryPrimitiveType; message 'primitiveType';
    function primitiveCount: NSInteger; message 'primitiveCount';
    function bytesPerIndex: NSInteger; message 'bytesPerIndex';
  end;
{$endif}

