{ Parsed from SceneKit.framework (MacOSX10.8) SCNMaterial.h }
{ Created on Mon Sep 10 11:46:01 2012 }


{$ifdef TYPES}
type
  SCNMaterialPtr = ^SCNMaterial;
  SCNProgramPtr = ^SCNProgram;
  SCNProgramDelegateProtocolPtr = ^SCNProgramDelegateProtocol;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  SCNLightingModelPhong: NSString { available in 10_7, NA }; cvar; external;
  SCNLightingModelBlinn: NSString { available in 10_7, NA }; cvar; external;
  SCNLightingModelLambert: NSString { available in 10_7, NA }; cvar; external;
  SCNLightingModelConstant: NSString { available in 10_7, NA }; cvar; external;
  SCNProgramMappingChannelKey: NSString { available in 10_7, NA }; cvar; external;
{$endif}

{$ifdef TYPES}
const
  SCNCullBack = 0;
  SCNCullFront = 1;
type
  SCNCullMode = clong;
const
  SCNTransparencyModeAOne = 0;
  SCNTransparencyModeRGBZero = 1;
type
  SCNTransparencyMode = clong;
{$endif}

{$ifdef CLASSES}

type
  SCNMaterial = objcclass external (NSObject, SCNAnimatableProtocol, NSCopyingProtocol)
  private
    _reserved: id;
  public
    class function material: SCNMaterial; message 'material';
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    function diffuse: SCNMaterialProperty; message 'diffuse';
    function ambient: SCNMaterialProperty; message 'ambient';
    function specular: SCNMaterialProperty; message 'specular';
    function emission: SCNMaterialProperty; message 'emission';
    function transparent: SCNMaterialProperty; message 'transparent';
    function reflective: SCNMaterialProperty; message 'reflective';
    function multiply: SCNMaterialProperty; message 'multiply';
    function normal: SCNMaterialProperty; message 'normal';
    procedure setShininess(newValue: CGFloat); message 'setShininess:';
    function shininess: CGFloat; message 'shininess';
    procedure setTransparency(newValue: CGFloat); message 'setTransparency:';
    function transparency: CGFloat; message 'transparency';
    procedure setLightingModelName(newValue: NSString); message 'setLightingModelName:';
    function lightingModelName: NSString; message 'lightingModelName';
    procedure setLitPerPixel(newValue: boolean); message 'setLitPerPixel:';
    function isLitPerPixel: boolean; message 'isLitPerPixel';
    procedure setDoubleSided(newValue: boolean); message 'setDoubleSided:';
    function isDoubleSided: boolean; message 'isDoubleSided';
    procedure setCullMode(newValue: SCNCullMode); message 'setCullMode:';
    function cullMode: SCNCullMode; message 'cullMode';
    procedure setTransparencyMode(newValue: SCNTransparencyMode); message 'setTransparencyMode:';
    function transparencyMode: SCNTransparencyMode; message 'transparencyMode';
    procedure setLocksAmbientWithDiffuse(newValue: boolean); message 'setLocksAmbientWithDiffuse:';
    function locksAmbientWithDiffuse: boolean; message 'locksAmbientWithDiffuse';
    procedure setWritesToDepthBuffer(newValue: boolean); message 'setWritesToDepthBuffer:';
    function writesToDepthBuffer: boolean; message 'writesToDepthBuffer';
    procedure setProgram(newValue: SCNProgram); message 'setProgram:';
    function program_: SCNProgram; message 'program';

    { Adopted protocols }
    procedure addAnimation_forKey (animation: CAAnimation; key: NSString); message 'addAnimation:forKey:';
    function animationForKey (key: NSString): CAAnimation; message 'animationForKey:';
    function animationKeys: NSArray; message 'animationKeys';
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure removeAllAnimations; message 'removeAllAnimations';
    procedure removeAnimationForKey (key: NSString); message 'removeAnimationForKey:';
  end;

type
  SCNProgram = objcclass external (NSObject, NSCopyingProtocol)
  private
    _reserved: id;
  public
    class function program_: SCNProgram; message 'program';
    procedure setVertexShader(newValue: NSString); message 'setVertexShader:';
    function vertexShader: NSString; message 'vertexShader';
    procedure setFragmentShader(newValue: NSString); message 'setFragmentShader:';
    function fragmentShader: NSString; message 'fragmentShader';
    procedure setSemantic_forSymbol_options (semantic: NSString; symbol: NSString; options: NSDictionary); message 'setSemantic:forSymbol:options:';
    function semanticForSymbol (symbol: NSString): NSString; message 'semanticForSymbol:';
    procedure setDelegate(newValue: SCNProgramDelegateProtocol); message 'setDelegate:';
    function delegate: SCNProgramDelegateProtocol; message 'delegate';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  SCNProgramDelegateProtocol = objcprotocol external name 'SCNProgramDelegate' (NSObjectProtocol)
  optional
    function program_bindValueForSymbol_atLocation_programID_renderer (program_: SCNProgram; symbol: NSString; location: cuint; programID: cuint; renderer: SCNRenderer): boolean; message 'program:bindValueForSymbol:atLocation:programID:renderer:';
    procedure program_unbindValueForSymbol_atLocation_programID_renderer (program_: SCNProgram; symbol: NSString; location: cuint; programID: cuint; renderer: SCNRenderer); message 'program:unbindValueForSymbol:atLocation:programID:renderer:';
    procedure program_handleError (program_: SCNProgram; error: NSError); message 'program:handleError:';
    function programIsOpaque (program_: SCNProgram): boolean; message 'programIsOpaque:';
  end;
{$endif}

