{ Parsed from SceneKit.framework (MacOSX10.8) SCNNode.h }
{ Created on Mon Sep 10 11:46:01 2012 }


{$ifdef TYPES}
type
  SCNNodePtr = ^SCNNode;
  SCNNodeRendererDelegateProtocolPtr = ^SCNNodeRendererDelegateProtocol;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  SCNModelTransform: NSString { available in 10_7, NA }; cvar; external;
  SCNViewTransform: NSString { available in 10_7, NA }; cvar; external;
  SCNProjectionTransform: NSString { available in 10_7, NA }; cvar; external;
  SCNNormalTransform: NSString { available in 10_7, NA }; cvar; external;
  SCNModelViewTransform: NSString { available in 10_7, NA }; cvar; external;
  SCNModelViewProjectionTransform: NSString { available in 10_7, NA }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  SCNNode = objcclass external (NSObject, NSCopyingProtocol, SCNAnimatableProtocol, SCNBoundingVolumeProtocol)
  private
    _reserved: id;
  public
    class function node: SCNNode; message 'node';
    class function nodeWithGeometry (geometry: SCNGeometry): SCNNode; message 'nodeWithGeometry:';
    procedure setTransform(newValue: CATransform3D); message 'setTransform:';
    function transform: CATransform3D; message 'transform';
    procedure setPosition(newValue: SCNVector3); message 'setPosition:';
    function position: SCNVector3; message 'position';
    procedure setRotation(newValue: SCNVector4); message 'setRotation:';
    function rotation: SCNVector4; message 'rotation';
    procedure setScale(newValue: SCNVector3); message 'setScale:';
    function scale: SCNVector3; message 'scale';
    procedure setPivot(newValue: CATransform3D); message 'setPivot:';
    function pivot: CATransform3D; message 'pivot';
    function worldTransform: CATransform3D; message 'worldTransform';
    procedure setHidden(newValue: boolean); message 'setHidden:';
    function isHidden: boolean; message 'isHidden';
    procedure setOpacity(newValue: CGFloat); message 'setOpacity:';
    function opacity: CGFloat; message 'opacity';
    procedure setRenderingOrder(newValue: NSInteger); message 'setRenderingOrder:';
    function renderingOrder: NSInteger; message 'renderingOrder';
    function parentNode: SCNNode; message 'parentNode';
    function childNodes: NSArray; message 'childNodes';
    procedure setLight(newValue: SCNLight); message 'setLight:';
    function light: SCNLight; message 'light';
    procedure setCamera(newValue: SCNCamera); message 'setCamera:';
    function camera: SCNCamera; message 'camera';
    procedure setGeometry(newValue: SCNGeometry); message 'setGeometry:';
    function geometry: SCNGeometry; message 'geometry';
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    function presentationNode: SCNNode; message 'presentationNode';
    procedure insertChildNode_atIndex (child: SCNNode; index: NSUInteger); message 'insertChildNode:atIndex:';
    procedure replaceChildNode_with (child: SCNNode; child2: SCNNode); message 'replaceChildNode:with:';
    procedure removeFromParentNode; message 'removeFromParentNode';
    procedure addChildNode (child: SCNNode); message 'addChildNode:';
    function childNodeWithName_recursively (name_: NSString; recursively: boolean): SCNNode; message 'childNodeWithName:recursively:';
    function childNodesPassingTest (predicate: OpaqueCBlock): NSArray; message 'childNodesPassingTest:';
    procedure setRendererDelegate(newValue: SCNNodeRendererDelegateProtocol); message 'setRendererDelegate:';
    function rendererDelegate: SCNNodeRendererDelegateProtocol; message 'rendererDelegate';
    function clone: id; message 'clone';

    { Adopted protocols }
    procedure addAnimation_forKey (animation: CAAnimation; key: NSString); message 'addAnimation:forKey:';
    function animationForKey (key: NSString): CAAnimation; message 'animationForKey:';
    function animationKeys: NSArray; message 'animationKeys';
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    function getBoundingBoxMin_max (min: SCNVector3Ptr; max: SCNVector3Ptr): boolean; message 'getBoundingBoxMin:max:';
    function getBoundingSphereCenter_radius (center: SCNVector3Ptr; radius: CGFloatPtr): boolean; message 'getBoundingSphereCenter:radius:';
    procedure removeAllAnimations; message 'removeAllAnimations';
    procedure removeAnimationForKey (key: NSString); message 'removeAnimationForKey:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  SCNNodeRendererDelegateProtocol = objcprotocol external name 'SCNNodeRendererDelegate' (NSObjectProtocol)
  optional
    procedure renderNode_renderer_arguments (node: SCNNode; renderer: SCNRenderer; arguments: NSDictionary); message 'renderNode:renderer:arguments:';
  end;
{$endif}

