{ Parsed from WebKit.framework (MacOSX10.8) DOMElement.h }
{ Created on Mon Sep 10 11:47:21 2012 }


{$ifdef TYPES}
type
  DOMElementPtr = ^DOMElement;
{$endif}

{$if (WEBKIT_VERSION_MAX_ALLOWED >= WEBKIT_VERSION_1_3)}
{$ifdef TYPES}
const
  DOM_ALLOW_KEYBOARD_INPUT = 1;
{$endif}

{$ifdef CLASSES}

type
  DOMElement = objcclass external (DOMNode)
  public
    function tagName: NSString; message 'tagName';
    function style: DOMCSSStyleDeclaration; message 'style';
    function offsetLeft: cint; message 'offsetLeft';
    function offsetTop: cint; message 'offsetTop';
    function offsetWidth: cint; message 'offsetWidth';
    function offsetHeight: cint; message 'offsetHeight';
    function offsetParent: DOMElement; message 'offsetParent';
    function clientLeft: cint; message 'clientLeft';
    function clientTop: cint; message 'clientTop';
    function clientWidth: cint; message 'clientWidth';
    function clientHeight: cint; message 'clientHeight';
    procedure setScrollLeft(newValue: cint); message 'setScrollLeft:';
    function scrollLeft: cint; message 'scrollLeft';
    procedure setScrollTop(newValue: cint); message 'setScrollTop:';
    function scrollTop: cint; message 'scrollTop';
    function scrollWidth: cint; message 'scrollWidth';
    function scrollHeight: cint; message 'scrollHeight';
    function firstElementChild: DOMElement; message 'firstElementChild';
    function lastElementChild: DOMElement; message 'lastElementChild';
    function previousElementSibling: DOMElement; message 'previousElementSibling';
    function nextElementSibling: DOMElement; message 'nextElementSibling';
    function childElementCount: cuint; message 'childElementCount';
    function innerText: NSString; message 'innerText';
    function getAttribute (name: NSString): NSString; message 'getAttribute:';
    procedure setAttribute_value (name: NSString; value: NSString); message 'setAttribute:value:';
    procedure removeAttribute (name: NSString); message 'removeAttribute:';
    function getAttributeNode (name: NSString): DOMAttr; message 'getAttributeNode:';
    function setAttributeNode (newAttr: DOMAttr): DOMAttr; message 'setAttributeNode:';
    function removeAttributeNode (oldAttr: DOMAttr): DOMAttr; message 'removeAttributeNode:';
    function getElementsByTagName (name: NSString): DOMNodeList; message 'getElementsByTagName:';
    function getAttributeNS_localName (namespaceURI_: NSString; localName_: NSString): NSString; message 'getAttributeNS:localName:';
    procedure setAttributeNS_qualifiedName_value (namespaceURI_: NSString; qualifiedName: NSString; value: NSString); message 'setAttributeNS:qualifiedName:value:';
    procedure removeAttributeNS_localName (namespaceURI_: NSString; localName_: NSString); message 'removeAttributeNS:localName:';
    function getElementsByTagNameNS_localName (namespaceURI_: NSString; localName_: NSString): DOMNodeList; message 'getElementsByTagNameNS:localName:';
    function getAttributeNodeNS_localName (namespaceURI_: NSString; localName_: NSString): DOMAttr; message 'getAttributeNodeNS:localName:';
    function setAttributeNodeNS (newAttr: DOMAttr): DOMAttr; message 'setAttributeNodeNS:';
    function hasAttribute (name: NSString): boolean; message 'hasAttribute:';
    function hasAttributeNS_localName (namespaceURI_: NSString; localName_: NSString): boolean; message 'hasAttributeNS:localName:';
    procedure focus; message 'focus';
    procedure blur; message 'blur';
    procedure scrollIntoView (alignWithTop: boolean); message 'scrollIntoView:';
    procedure scrollIntoViewIfNeeded (centerIfNeeded: boolean); message 'scrollIntoViewIfNeeded:';
    procedure scrollByLines (lines: cint); message 'scrollByLines:';
    procedure scrollByPages (pages: cint); message 'scrollByPages:';
    function getElementsByClassName (name: NSString): DOMNodeList; message 'getElementsByClassName:';
    function querySelector (selectors: NSString): DOMElement; message 'querySelector:';
    function querySelectorAll (selectors: NSString): DOMNodeList; message 'querySelectorAll:';
    procedure webkitRequestFullScreen (flags: cushort); message 'webkitRequestFullScreen:';
  end;


type
  DOMElementDeprecated = objccategory external (DOMElement)
    procedure setAttribute (name: NSString); message 'setAttribute:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    function getAttributeNS (namespaceURI_: NSString): NSString; message 'getAttributeNS:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    procedure setAttributeNS_qualifiedName (namespaceURI_: NSString; value: NSString); message 'setAttributeNS:qualifiedName:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    procedure removeAttributeNS (namespaceURI_: NSString); message 'removeAttributeNS:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    function getElementsByTagNameNS (namespaceURI_: NSString): DOMNodeList; message 'getElementsByTagNameNS:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    function getAttributeNodeNS (namespaceURI_: NSString): DOMAttr; message 'getAttributeNodeNS:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    function hasAttributeNS (namespaceURI_: NSString): boolean; message 'hasAttributeNS:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
  end;
{$endif}

{$endif}
