{ Parsed from WebKit.framework (MacOSX10.8) DOMNode.h }
{ Created on Mon Sep 10 11:47:21 2012 }


{$ifdef TYPES}
type
  DOMNodePtr = ^DOMNode;
{$endif}

{$if (WEBKIT_VERSION_MAX_ALLOWED >= WEBKIT_VERSION_1_3)}
{$ifdef TYPES}
const
  DOM_ELEMENT_NODE = 1;
  DOM_ATTRIBUTE_NODE = 2;
  DOM_TEXT_NODE = 3;
  DOM_CDATA_SECTION_NODE = 4;
  DOM_ENTITY_REFERENCE_NODE = 5;
  DOM_ENTITY_NODE = 6;
  DOM_PROCESSING_INSTRUCTION_NODE = 7;
  DOM_COMMENT_NODE = 8;
  DOM_DOCUMENT_NODE = 9;
  DOM_DOCUMENT_TYPE_NODE = 10;
  DOM_DOCUMENT_FRAGMENT_NODE = 11;
  DOM_NOTATION_NODE = 12;
  DOM_DOCUMENT_POSITION_DISCONNECTED = $01;
  DOM_DOCUMENT_POSITION_PRECEDING = $02;
  DOM_DOCUMENT_POSITION_FOLLOWING = $04;
  DOM_DOCUMENT_POSITION_CONTAINS = $08;
  DOM_DOCUMENT_POSITION_CONTAINED_BY = $10;
  DOM_DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC = $20;
{$endif}

{$ifdef CLASSES}

type
  DOMNode = objcclass external (DOMObject, DOMEventTargetProtocol)
  public
    function nodeName: NSString; message 'nodeName';
    procedure setNodeValue(newValue: NSString); message 'setNodeValue:';
    function nodeValue: NSString; message 'nodeValue';
    function nodeType: cushort; message 'nodeType';
    function parentNode: DOMNode; message 'parentNode';
    function childNodes: DOMNodeList; message 'childNodes';
    function firstChild: DOMNode; message 'firstChild';
    function lastChild: DOMNode; message 'lastChild';
    function previousSibling: DOMNode; message 'previousSibling';
    function nextSibling: DOMNode; message 'nextSibling';
    function attributes: DOMNamedNodeMap; message 'attributes';
    function ownerDocument: DOMDocument; message 'ownerDocument';
    function namespaceURI: NSString; message 'namespaceURI';
    procedure setPrefix(newValue: NSString); message 'setPrefix:';
    function prefix: NSString; message 'prefix';
    function localName: NSString; message 'localName';
    function baseURI: NSString; message 'baseURI';
    procedure setTextContent(newValue: NSString); message 'setTextContent:';
    function textContent: NSString; message 'textContent';
    function parentElement: DOMElement; message 'parentElement';
    function isContentEditable: boolean; message 'isContentEditable';
    function insertBefore_refChild (newChild: DOMNode; refChild: DOMNode): DOMNode; message 'insertBefore:refChild:';
    function replaceChild_oldChild (newChild: DOMNode; oldChild: DOMNode): DOMNode; message 'replaceChild:oldChild:';
    function removeChild (oldChild: DOMNode): DOMNode; message 'removeChild:';
    function appendChild (newChild: DOMNode): DOMNode; message 'appendChild:';
    function hasChildNodes: boolean; message 'hasChildNodes';
    function cloneNode (deep: boolean): DOMNode; message 'cloneNode:';
    procedure normalize; message 'normalize';
    function isSupported_version (feature: NSString; version: NSString): boolean; message 'isSupported:version:';
    function hasAttributes: boolean; message 'hasAttributes';
    function isSameNode (other: DOMNode): boolean; message 'isSameNode:';
    function isEqualNode (other: DOMNode): boolean; message 'isEqualNode:';
    function lookupPrefix (namespaceURI_: NSString): NSString; message 'lookupPrefix:';
    function isDefaultNamespace (namespaceURI_: NSString): boolean; message 'isDefaultNamespace:';
    function lookupNamespaceURI (prefix_: NSString): NSString; message 'lookupNamespaceURI:';
    function compareDocumentPosition (other: DOMNode): cushort; message 'compareDocumentPosition:';
    function contains (other: DOMNode): boolean; message 'contains:';

    { Adopted protocols }
    procedure addEventListener_listener (type_: NSString; useCapture: boolean); message 'addEventListener:listener:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    procedure addEventListener_listener_useCapture (type_: NSString; listener: DOMEventListenerProtocol; useCapture: boolean); message 'addEventListener:listener:useCapture:';
    function autorelease: id; message 'autorelease';
    function class_: pobjc_class; message 'class';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function dispatchEvent (event: DOMEvent): boolean; message 'dispatchEvent:';
    function hash: NSUInteger; message 'hash';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function isProxy: boolean; message 'isProxy';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    procedure release; message 'release';
    procedure removeEventListener_listener (type_: NSString; useCapture: boolean); message 'removeEventListener:listener:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    procedure removeEventListener_listener_useCapture (type_: NSString; listener: DOMEventListenerProtocol; useCapture: boolean); message 'removeEventListener:listener:useCapture:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    function retainCount: NSUInteger; message 'retainCount';
    function self_: id; message 'self';
    function superclass: pobjc_class; message 'superclass';
    function zone: NSZonePtr; message 'zone';
  end;


type
  DOMNodeDeprecated = objccategory external (DOMNode)
    function insertBefore (newChild: DOMNode): DOMNode; message 'insertBefore:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    function replaceChild (newChild: DOMNode): DOMNode; message 'replaceChild:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    function isSupported (feature: NSString): boolean; message 'isSupported:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
  end;
{$endif}

{$endif}
