{ Parsed from WebKit.framework (MacOSX10.8) DOMRange.h }
{ Created on Mon Sep 10 11:47:22 2012 }


{$ifdef TYPES}
type
  DOMRangePtr = ^DOMRange;
{$endif}

{$if (WEBKIT_VERSION_MAX_ALLOWED >= WEBKIT_VERSION_1_3)}
{$ifdef TYPES}
const
  DOM_START_TO_START = 0;
  DOM_START_TO_END = 1;
  DOM_END_TO_END = 2;
  DOM_END_TO_START = 3;
  DOM_NODE_BEFORE = 0;
  DOM_NODE_AFTER = 1;
  DOM_NODE_BEFORE_AND_AFTER = 2;
  DOM_NODE_INSIDE = 3;
{$endif}

{$ifdef CLASSES}

type
  DOMRange = objcclass external (DOMObject)
  public
    function startContainer: DOMNode; message 'startContainer';
    function startOffset: cint; message 'startOffset';
    function endContainer: DOMNode; message 'endContainer';
    function endOffset: cint; message 'endOffset';
    function collapsed: boolean; message 'collapsed';
    function commonAncestorContainer: DOMNode; message 'commonAncestorContainer';
    function text: NSString; message 'text';
    procedure setStart_offset (refNode: DOMNode; offset: cint); message 'setStart:offset:';
    procedure setEnd_offset (refNode: DOMNode; offset: cint); message 'setEnd:offset:';
    procedure setStartBefore (refNode: DOMNode); message 'setStartBefore:';
    procedure setStartAfter (refNode: DOMNode); message 'setStartAfter:';
    procedure setEndBefore (refNode: DOMNode); message 'setEndBefore:';
    procedure setEndAfter (refNode: DOMNode); message 'setEndAfter:';
    procedure collapse (toStart: boolean); message 'collapse:';
    procedure selectNode (refNode: DOMNode); message 'selectNode:';
    procedure selectNodeContents (refNode: DOMNode); message 'selectNodeContents:';
    function compareBoundaryPoints_sourceRange (how: cushort; sourceRange: DOMRange): cshort; message 'compareBoundaryPoints:sourceRange:';
    procedure deleteContents; message 'deleteContents';
    function extractContents: DOMDocumentFragment; message 'extractContents';
    function cloneContents: DOMDocumentFragment; message 'cloneContents';
    procedure insertNode (newNode: DOMNode); message 'insertNode:';
    procedure surroundContents (newParent: DOMNode); message 'surroundContents:';
    function cloneRange: DOMRange; message 'cloneRange';
    function toString: NSString; message 'toString';
    procedure detach; message 'detach';
    function createContextualFragment (html: NSString): DOMDocumentFragment; message 'createContextualFragment:';
    function intersectsNode (refNode: DOMNode): boolean; message 'intersectsNode:';
    function compareNode (refNode: DOMNode): cshort; message 'compareNode:';
    function comparePoint_offset (refNode: DOMNode; offset: cint): cshort; message 'comparePoint:offset:';
    function isPointInRange_offset (refNode: DOMNode; offset: cint): boolean; message 'isPointInRange:offset:';
  end;


type
  DOMRangeDeprecated = objccategory external (DOMRange)
    procedure setStart (refNode: DOMNode); message 'setStart:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    procedure setEnd (refNode: DOMNode); message 'setEnd:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
    function compareBoundaryPoints (how: cushort): cshort; message 'compareBoundaryPoints:'; deprecated 'available in 1.3 and later but deprecated in 3.0';
  end;
{$endif}

{$endif}
