{ Parsed from WebKit.framework (MacOSX10.8) WebScriptObject.h }
{ Created on Mon Sep 10 11:47:21 2012 }


{$ifdef TYPES}
type
  WebScriptObjectPtr = ^WebScriptObject;
  WebUndefinedPtr = ^WebUndefined;
{$endif}

{$if (WEBKIT_VERSION_MAX_ALLOWED >= WEBKIT_VERSION_1_3)}
{$ifdef CLASSES}

type
  WebScripting = objccategory external (NSObject)
    class function webScriptNameForSelector (selector: SEL): NSString; message 'webScriptNameForSelector:';
    class function isSelectorExcludedFromWebScript (selector: SEL): boolean; message 'isSelectorExcludedFromWebScript:';
    class function webScriptNameForKey (name: PChar): NSString; message 'webScriptNameForKey:';
    class function isKeyExcludedFromWebScript (name: PChar): boolean; message 'isKeyExcludedFromWebScript:';
    function invokeUndefinedMethodFromWebScript_withArguments (name: NSString; arguments: NSArray): id; message 'invokeUndefinedMethodFromWebScript:withArguments:';
    function invokeDefaultMethodWithArguments (arguments: NSArray): id; message 'invokeDefaultMethodWithArguments:';
    procedure finalizeForWebScript; message 'finalizeForWebScript';
  end;


type
  WebScriptObject = objcclass external (NSObject)
  private
    _private: WebScriptObjectPrivate;
  public
    class function throwException (exceptionMessage: NSString): boolean; message 'throwException:';
    function JSObject: JSObjectRef; message 'JSObject';
    function callWebScriptMethod_withArguments (name: NSString; arguments: NSArray): id; message 'callWebScriptMethod:withArguments:';
    function evaluateWebScript (script: NSString): id; message 'evaluateWebScript:';
    procedure removeWebScriptKey (name: NSString); message 'removeWebScriptKey:';
    function stringRepresentation: NSString; message 'stringRepresentation';
    function webScriptValueAtIndex (index: cuint): id; message 'webScriptValueAtIndex:';
    procedure setWebScriptValueAtIndex_value (index: cuint; value: id); message 'setWebScriptValueAtIndex:value:';
    procedure setException (description: NSString); message 'setException:';
  end;

type
  WebUndefined = objcclass external (NSObject, NSCodingProtocol, NSCopyingProtocol)
  public
    class function undefined: WebUndefined; message 'undefined';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;
{$endif}

{$endif}
